'****************************************************************
'*  Name    : STM06.bas                                         *
'*  Project : Testing the State Machine Template                *
'*  Author  : [Alberto Freixanet]                               *
'*  Notice  : Copyright (c) February 2017 [A. Freixanet 2017]   *
'*          : All Rights Reserved                               *
'*  Date    : 12/04/2017                                        *
'*  Version : 1.0                                               *
'*  Notes   : Using the AMICUS18 Development Board              *
'*          : CPU : PIC18F25K20 with Xtal 16Mhz, with 4xPLL     *
'*            CoolTerm Terminal is Used for bootloader & testing*
'* Powered by PROTON DEVELOPMENT SUITE COMPILER V3.5.9.3        *
'*          BEST DESIGN                                         *
'*          Testing the DS1307 clock calendar                   *
'*          Testing the AMI18 LCD BOARD                         *
'*          Configuration of Date/Time/Contrast by Buttons      *
'* Bootloader: Using AGV Bootloader Version 4.1 Low Side of ROM *
'****************************************************************
'
' INC FILES LIST for this PROJECT:
'
' SYS_18FXXK20.Inc
' STMachine01.Inc
' DS1307-H.Inc
' DS1307-S.Inc
' LCD_ST7036.Inc
' HRsout_K40.Inc
' ORG_SyncBlock_K20.Inc
' STM_Strings06.Inc
'
'===============================================================================
' This source code is free software and provided 'as is', any express or implied 
' warranties are disclaimed. you can redistribute it and/or modify.
' The author is not responsible of the use of this software.
' This program is distributed in the hope that it will be useful, but WITHOUT 
' ANY WARRANTY. However, a mention of the author and compiler would be appreciated.
'*******************************************************************************
' Este cdigo fuente es un software libre, puede redistribuirlo y/o modificarlo.
' El autor no se hace responsable del uso de este software.
' Este programa se distribuye con la esperanza de que sea til,
' pero SIN NINGUNA GARANTA. No obstante citar el autor y el compilador
' sera muy apreciado.
'*******************************************************************************
' Ce code source est un logiciel libre, vous pouvez le redistribuer et/ou modifier.
' L'auteur n'est pas responsable de l'utilisation de ce logiciel.
' Ce programme est distribu dans l'espoir qu'il sera utile, mais SANS AUCUNE GARANTIE.
' Cependant mentionner l'auteur et le compileur serait trs aprci.
'===============================================================================
' Testing the CODE by Proteus
    $define _ProteusDebug_
'===============================================================================
' Choose the Bootloader you are using for the Amicus18 Board (real hardware).
' CHOOSE ONLY ONE.
$ifndef _ProteusDebug_

    $define _AmicusBootloader_
'    $define _LSM_AGV_BootloaderV41_

$endif
'===============================================================================

    Device = 18F25K20

    $ifdef _ProteusDebug_
    ' Settings CPU Proteus at 4Mhz (with settings fuses)
    Declare Xtal = 16
    $else
    ' Settings CPU Amicus18 Board at 16Mhz (with settings fuses)
    Declare Xtal = 64
    $endif
'*******************************************************************************
'* Name    : Compiler Declare                                                  *
'* Purpose : Configuration of the compiler                                     *
'* Notes   :                                                                   *
'******************************************************************************* 
    $if _defined(_LSM_AGV_BootloaderV41_) And _defined(_AmicusBootloader_)
        $error "ONLY CHOOSE ONE BOOTLOADER"
    $endif

    ' More security using the Bootloader in the Low Side of ROM memory (only for real piece).
    $ifdef _LSM_AGV_BootloaderV41_
        Declare PROTON_START_ADDRESS = 2048
    $endif
    '---------------------------------------------------------------------------
    Declare Eeprom_Address = $F00000
    Declare Optimiser_Level = 2
    Declare Dead_Code_Remove = On
    Declare Create_Coff = On
    Declare Watchdog = On
'    Declare Float_Display_Type = Fast
'    Declare Float_Rounding = Off
    Declare Bootloader = Off
'    Declare Show_System_Variables = On
    Declare MemWrite_Int_Control = 1
    $if 65537 < _code
    Declare Access_Upper_64K = On
    $endif
'    Declare Keypad_Port PORTB
'-------------------------------------------------------------------------------
    $ifdef _ProteusDebug_
    $define _PinsTest_
    $endif
'*******************************************************************************
'* Name    : Config Fuses                                                      *
'* Purpose :                                                                   *
'* Notes   : 1 version for Proteus & another version for AGV LSM Bootloader    *
'******************************************************************************* 
$ifdef _ProteusDebug_
'-------------------------------------------------------------------------------
Config_Start
    FOSC = HSPLL	;HS oscillator, PLL enabled (Clock Frequency = 4 x FOSC1)
    FCMEN = OFF	    ;Fail-Safe Clock Monitor disabled
    IESO = OFF	 ;Oscillator Switchover mode disabled
    PWRT = On	  ;PWRT enabled
    BOREN = On	 ;Brown-out Reset enabled and controlled by software (SBOREN is enabled)
    BORV = 22	  ;VBOR set to 2.2 V nominal
    WDTEN = OFF	    ;WDT is controlled by SWDTEN bit of the WDTCON register
    WDTPS = 128	    ;1:128
    CCP2MX = PORTC	;CCP2 input/output is multiplexed with RC1
    PBADEN = On	    ;PORTB<4:0> pins are configured as analog input channels on Reset
    LPT1OSC = OFF	;Timer1 configured for higher power operation
    HFOFST = OFF	;The system clock is held off until the HFINTOSC is stable.
    MCLRE = On	     ;MCLR pin enabled; RE3 input pin disabled
    STVREN = On	    ;Stack full/underflow will cause Reset
    LVP = OFF	  ;Single-Supply ICSP disabled
    XINST = OFF	    ;Instruction set extension and Indexed Addressing mode disabled (Legacy mode)
    Debug = OFF	    ;Background debugger disabled, RB6 and RB7 configured as general purpose I/O pins
    Cp0 = OFF	;Block 0 (000800-001FFFh) not code-protected
    CP1 = OFF	;Block 1 (002000-003FFFh) not code-protected
    CP2 = OFF	;Block 2 (004000-005FFFh) not code-protected
    CP3 = OFF	;Block 3 (006000-007FFFh) not code-protected
    CPB = OFF	;Boot block (000000-0007FFh) not code-protected
    CPD = OFF	;Data EEPROM not code-protected
    WRT0 = OFF	;Block 0 (000800-001FFFh) not write-protected
    WRT1 = OFF	;Block 1 (002000-003FFFh) not write-protected
    WRT2 = OFF	;Block 2 (004000-005FFFh) not write-protected
    WRT3 = OFF	;Block 3 (006000-007FFFh) not write-protected
    WRTC = On	;Configuration registers (300000-3000FFh) write-protected
    WRTB = OFF	;Boot Block (000000-0007FFh) not write-protected
    WRTD = OFF	;Data EEPROM not write-protected
    EBTR0 = OFF	;Block 0 (000800-001FFFh) not protected from table reads executed in other blocks
    EBTR1 = OFF	;Block 1 (002000-003FFFh) not protected from table reads executed in other blocks
    EBTR2 = OFF	;Block 2 (004000-005FFFh) not protected from table reads executed in other blocks
    EBTR3 = OFF	;Block 3 (006000-007FFFh) not protected from table reads executed in other blocks
    EBTRB = OFF	;Boot Block (000000-0007FFh) not protected from table reads executed in other blocks
Config_End
'-------------------------------------------------------------------------------
$else
'-------------------------------------------------------------------------------
' Full Boot Block protected for the Low Side ROM Bootloader.
Config_Start
    FOSC = HSPLL	;HS oscillator, PLL enabled (Clock Frequency = 4 x FOSC1)
    FCMEN = OFF	;Fail-Safe Clock Monitor disabled
    IESO = OFF	;Oscillator Switchover mode disabled
    PWRT = On	;PWRT enabled
    BOREN = On	;Brown-out Reset enabled and controlled by software (SBOREN is enabled)
    BORV = 22	;VBOR set to 2.2 V nominal
    WDTEN = OFF	;WDT is controlled by SWDTEN bit of the WDTCON register
    WDTPS = 128	;1:128
    CCP2MX = PORTC	;CCP2 input/output is multiplexed with RC1
    PBADEN = On	    ;PORTB<4:0> pins are configured as analog input channels on Reset
    LPT1OSC = OFF	;Timer1 configured for higher power operation
    HFOFST = OFF	;The system clock is held off until the HFINTOSC is stable.
    MCLRE = On	;MCLR pin enabled; RE3 input pin disabled
    STVREN = On	;Stack full/underflow will cause Reset
    LVP = OFF	;Single-Supply ICSP disabled
    XINST = OFF	;Instruction set extension and Indexed Addressing mode disabled (Legacy mode)
    Debug = OFF	;Background debugger disabled, RB6 and RB7 configured as general purpose I/O pins
    Cp0 = OFF	;Block 0 (000800-001FFFh) not code-protected
    CP1 = OFF	;Block 1 (002000-003FFFh) not code-protected
    CP2 = OFF	;Block 2 (004000-005FFFh) not code-protected
    CP3 = OFF	;Block 3 (006000-007FFFh) not code-protected
    CPB = On	;Boot block (000000-0007FFh) code-protected
    CPD = On	;Data EEPROM code-protected
    WRT0 = OFF	;Block 0 (000800-001FFFh) not write-protected
    WRT1 = OFF	;Block 1 (002000-003FFFh) not write-protected
    WRT2 = OFF	;Block 2 (004000-005FFFh) not write-protected
    WRT3 = OFF	;Block 3 (006000-007FFFh) not write-protected
    WRTC = On	;Configuration registers (300000-3000FFh) write-protected
    WRTB = On	;Boot Block (000000-0007FFh) write-protected
    WRTD = OFF	;Data EEPROM not write-protected
    EBTR0 = OFF	;Block 0 (000800-001FFFh) not protected from table reads executed in other blocks
    EBTR1 = OFF	;Block 1 (002000-003FFFh) not protected from table reads executed in other blocks
    EBTR2 = OFF	;Block 2 (004000-005FFFh) not protected from table reads executed in other blocks
    EBTR3 = OFF	;Block 3 (006000-007FFFh) not protected from table reads executed in other blocks
    EBTRB = On	;Boot Block (000000-0007FFh) protected from table reads executed in other blocks
Config_End
'-------------------------------------------------------------------------------
$endif
'*******************************************************************************
'* Name    : LCD                                                               *
'* Purpose : Declare the LCD pins                                              *
'* Notes   : Configuration of the LCD for the AMI18 Shield.                    *
'******************************************************************************* 
    Declare LCD_DTPin = PORTB.4         ' LCD's Data lines (D4 to D7)
    Declare LCD_ENPin = PORTB.3         ' LCD's EN line
    Declare LCD_RSPin = PORTB.2         ' LCD's RS line
    Declare LCD_Interface = 4           ' 4-bit interface to LCD
    Declare LCD_Lines = 2               ' LCD contains 2 lines
    Declare LCD_DataUs = 50             ' Time to wait after print a data To LCD
    Declare LCD_CommandUs = 4000        ' Time to wait after print a command to LCD
    Declare LCD_Type = Alphanumeric     ' LCD type is alphanumeric
    Symbol __LCD_CharsLenght = 16       ' For the AMI18 LCD Shield: 16 Characters
    Symbol bLCD_BackLight = LATB.1      ' BackLight for the LCD.
'*******************************************************************************
'* Name    : Variables & Constants                                             *
'* Purpose : Declare the Variables or Constants                                *
'* Notes   : The local variables are declared for this State Machine file only *
'* Rules   : If the Variable is used once then get Local Variable.             *
'*         : If the Variable is used several times in a large loop in STM1     *
'*         : with STM2 or in others modules then get a Global Variable.        *
'******************************************************************************* 
' Definition of local Bytes for Main code only
$ifndef _SMLVBS_Block1_
    $define _SMLVBS_Block1_
    Dim SMLVSByte1 As Byte System     ' Local Variable System Byte1
    Dim SMLVSByte2 As Byte System     ' Local Variable System Byte2
    Dim SMLVSByte3 As Byte System     ' Local Variable System Byte3
    Dim SMLVSByte4 As Byte System     ' Local Variable System Byte4
$endif
' If you need more local Byte Variables, uncomment this block.
'$ifndef _SMLVBS_Block2_
'    $define _SMLVBS_Block2_
'    Dim SMLVSByte5 As Byte System     ' Local Variable System Byte1
'    Dim SMLVSByte6 As Byte System     ' Local Variable System Byte2
'    Dim SMLVSByte7 As Byte System     ' Local Variable System Byte3
'    Dim SMLVSByte8 As Byte System     ' Local Variable System Byte4
'$endif

' Definition of local Words For Main Code only
'$ifndef _SMLVWS_Block1_
'    $define _SMLVWS_Block1_
'    Dim SMLVSWord1 As Word System     ' Local Variable System Word1
'    Dim SMLVSWord2 As Word System     ' Local Variable System Word2
'$endif
' If you need more local Word Variables, uncomment this block.
'$ifndef _SMLVWS_Block2_
'    $define _SMLVWS_Block2_
'    Dim SMLVSWord3 As Word System     ' Local Variable System Word1
'    Dim SMLVSWord4 As Word System     ' Local Variable System Word2
'$endif

' Definition of local DWords For Main Code only
'$ifndef _SMLVDWS_Block1_
'    $define _SMLVDWS_Block1_
'    Dim SMLVSDWord1 As DWord System     ' Local Variable System Word1
'    Dim SMLVSDWord2 As DWord System     ' Local Variable System Word2
'$endif
' If you need more local Dword Variables, uncomment this block.
'$ifndef _SMLVDWS_Block2_
'    $define _SMLVDWS_Block2_
'    Dim SMLVSDWord3 As DWord System     ' Local Variable System Word1
'    Dim SMLVSDWord4 As DWord System     ' Local Variable System Word2
'$endif

' Definition of local bits
'$ifndef _LVSBitS_Block1_
'    $define _LVSBitS_Block1_
'    Dim LVSBitsA As Byte System     ' Local Variable System byte
'$endif

'-------------------------------------------------------------------------------
' Global Bits for the USER
    Dim SM_UserFunctionFlags As Byte System
    Dim F_UserFunction1 As SM_UserFunctionFlags.0 
    Dim F_UserFunction2 As SM_UserFunctionFlags.1
    Dim F_UserFunction3 As SM_UserFunctionFlags.2
    Dim F_UserFunction4 As SM_UserFunctionFlags.3
    Dim F_UserFunction5 As SM_UserFunctionFlags.4
    Dim F_UserFunction6 As SM_UserFunctionFlags.5        
    Dim F_UserFunction7 As SM_UserFunctionFlags.6
    Dim F_UserFunction8 As SM_UserFunctionFlags.7

'    Dim SM_UserFlags As Byte System

    ' Flags
    Dim SM_UserSystemFlags As Word System
    Dim F_DS1307_1S   As SM_UserSystemFlags.0
    Dim F_Buttons10mS As SM_UserSystemFlags.1
    Dim F_AlarmX      As SM_UserSystemFlags.2 
    Dim F_Alarm1      As SM_UserSystemFlags.3
    Dim F_EnableAlarm1  As SM_UserSystemFlags.4
    Dim F_Alarm1Avaible As SM_UserSystemFlags.5
    Dim F_SettingAlarm1 As SM_UserSystemFlags.6
    Dim F_Alarm2        As SM_UserSystemFlags.7
    Dim F_EnableAlarm2  As SM_UserSystemFlags.8
    Dim F_Alarm2Avaible As SM_UserSystemFlags.9
    Dim F_SettingAlarm2 As SM_UserSystemFlags.10
    Dim F_SettingAlarmX As SM_UserSystemFlags.11
    Dim F_MenuContrastFromReset As SM_UserSystemFlags.12   
'-------------------------------------------------------------------------------
    
'===============================================================================
    Dim MyDummyByte As Byte ' This byte is to calculate the position of the Arrays
'===============================================================================
' DECLARE THE ARRAYS BELOW THIS LINE
'===============================================================================
'-------------------------------------------------------------------------------
' Definition of PORT pins for Amicus18. (bits)
    Symbol bBUZZER = LATB.0
    Symbol bButton1 = PORTA.0
    Symbol bButton2 = PORTA.1
    Symbol bButton3 = PORTA.2
    Symbol bButton4 = PORTA.3            
'-------------------------------------------------------------------------------
    Symbol MaxYear = 30 
    Symbol ThisYear = 17
'-------------------------------------------------------------------------------
' Definition of the Test pins. (bits)
    $ifdef _PinsTest_
    Symbol bTest1 = LATC.0
    Symbol bTest2 = LATC.1 
    $endif
'*******************************************************************************
'* Name    : Write the ARRAYs in BANK0 and upward                              *
'* Purpose : Declare manually a Dummy Array                                    *
'* Notes   : Using a Dummy Byte as reference                                   *
'******************************************************************************* 
    ' After last compiling, verify the address (in asm file) of the variable "MyDummyByte" 
    ' and update the AddressofMyDummyByte value & compile again.
    $ifdef _ProteusDebug_
    $define AddressofMyDummyByte 70
    $else
    $define AddressofMyDummyByte 74
    $endif

    $ifdef _bankAend
        $if AddressofMyDummyByte < _bankAend
            $define DummyArray_Lenght _bankAend - AddressofMyDummyByte + 1
            Dim DummyArray[DummyArray_Lenght] As Byte  
        $endif
    $else
        $error "The _bankAend parameter is absent from the .def file of the PDS!"
    $endif
'===============================================================================
' Declare the Arrays bellow this line.
    Dim SMDS1307_Array[8] As Byte
    Dim VSecond    As SMDS1307_Array#0     ' Second (0..59)
    Dim VMinute    As SMDS1307_Array#1     ' Minute (0..59)
    Dim VHour      As SMDS1307_Array#2     ' Hour    (0..11 or 0..23)
    Dim VDayOfWeek As SMDS1307_Array#3     ' Day of the week (1..7)
    Dim VDay       As SMDS1307_Array#4     ' Date  (0..31)
    Dim VMonth     As SMDS1307_Array#5     ' Month (1..12)
    Dim VYear      As SMDS1307_Array#6     ' Year  (0..99)
'===============================================================================
'===============================================================================
' My Bits definition of the PIC18F25K20.
'    Include "D:\MyIncFiles\SYS_18FXXK20.inc"
    Include "INC\SYS_18FXXK20.inc"
'*******************************************************************************
'* Name    : Language                                                          *
'* Purpose : Define one language for this project                              *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   : One language must be enabled                                      *
'*******************************************************************************            
    $define _English_
'    $define _Spanish_
'    $define _French_ 
'*******************************************************************************
'* Name    : State machine numbers                                             *
'* Purpose : Define every State with a name (optional)                         *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   :                                                                   *
'******************************************************************************* 
    $define SM_Init 0               ' STATE00
    $define SM_ProjectInfo 1        ' STATE01
    $define SM_CheckACK 2           ' STATE02
    $define SM_Enable1Hz 3          ' STATE04
    $define SM_WriteConfig 4        ' STATE03
    $define SM_ReadTimeDate 5       ' STATE05
    $define SM_Error_NACK 6         ' STATE06
    $define SM_AskForConfig 7       ' STATE07
    $define SM_ButtonsOFF 8         ' STATE08
    $define SM_ReadButtons 9        ' STATE09    
    $define SM_ButtonsOFF2 10       ' STATE10
    $define SM_GetWeek 11           ' STATE11
    $define SM_GetDay 12            ' STATE12
    $define SM_GetMonth 13          ' STATE13
    $define SM_GetYear 14           ' STATE14
    $define SM_GetHour 15           ' STATE15
    $define SM_GetMinute 16         ' STATE16
    $define SM_ContrastSetup 17     ' STATE17
    $define SM_SetContrast 18       ' STATE18    
    $define SM_SaveContrast 19      ' STATE19        
    $define SM_AlarmMenu 20         ' STATE20
    $define SM_SaveAlarm 21         ' STATE21
    $define SM_Alarm 22             ' STATE22
    $define SM_SeeAlarm2 23         ' STATE23
    $define SM_SeeAlarm1 24         ' STATE24
    $define SM_DisableAlarms 25     ' STATE25
'*******************************************************************************
'* Name    : State machine2 numbers                                            *
'* Purpose : Define every State with a name (optional)                         *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   :                                                                   *
'******************************************************************************* 
    $define SM2_Init 0          ' STATE100
    $define SM2_PrintTimeDate 1 ' STATE101
'*******************************************************************************
'* Name    : Enable the Library Commands inside the STMachine00.Inc file       *
'* Notes   :                                                                   *
'*******************************************************************************
' Uncomment the followed line to insert the Keypad option.
'    $define _Disable_Keypad_Pullups_
'    $define _4x4KEYPAD_
'    $define _4x3KEYPAD_
'    $define _4x2KEYPAD_
'-------------------------------------------------------------------------------
' Others State Machine libraries.
    $define _HRSE2PStrg_
'    $define _PrintE2PStrg_
'    $define _Manchester_
'    $define _MidPoint_
'    $define _MedianFilter_
'    $define _BubbleSort_
'    $define _GetParity_
'    $define _RotateBits_
'    $define _BinaryTo3BCD_
'    $define _BCD2ToBinary_
'    $define _WordTo5BCD_
'    $define _DwordArray_
'    $define _CountUntil_
'    $define _ArrayROL_
'    $define _ArrayROR_
'    $define _ArrayROLR_
'    $define _ArrayRORR_
'    $define _ArrayBit_
'    $define _CRC16_
'    $define _Multi_DIM_Array_
'*******************************************************************************
'* Name    : HSerial                                                           *
'* Purpose : Declare the HSerial Communication for the STM Library             *
'* Notes   : Uncomment a line to declare a Terminal Baud Rate. (One only)      *
'******************************************************************************* 
' Uncomment a line to define a Terminal Baud Rate, and compile. (One only)
$ifdef _ProteusDebug_
'    $define _HSerialBaud_ 9600
'    $define _HSerialBaud_ 19200   
    $define _HSerialBaud_ 38400
'    $define _HSerialBaud_ 57600
'    $define _HSerialBaud_ 115200
$else
'    $define _HSerialBaud_ 9600
'    $define _HSerialBaud_ 19200   
'    $define _HSerialBaud_ 38400
'    $define _HSerialBaud_ 57600
    $define _HSerialBaud_ 115200
$endif
'===============================================================================
'    $if _HSerialBaud_ = 9600
'    'Calculated Baudrate = 9598 @ Xtal 64MHz, Error = -0,02%
'    Declare Hserial_RCSTA  = %10010000  ' Enable continuous receive 
'    Declare Hserial_TXSTA  = %00100100  ' Enable transmit, BRGH = 1
'    Declare Hserial_Clear  = On         ' Clear overflow automatically
'    Declare Hserial_SPBRG  = $82        ' Baud Rate Generator Low Byte Value
'    SPBRGH    = $06                     ' Baud Rate Generator High Byte Value
'    BAUDCON.3 = 1                       ' Enable the 16 bit Baud Rate Generator  
'    $endif

    $if _HSerialBaud_ = 9600
        Declare Hserial_Baud = 9600
        Declare Hserial_TXSTA = 36      ' Enable transmit and asynchronous mode
        Declare Hserial_RCSTA = 144     ' Enable serial port and continuous receive
        Declare Hserial_Clear = On      ' Enable Error clearing on received characters
    $endif
    $if _HSerialBaud_ = 19200
        Declare Hserial_Baud = 19200        ' Set baud rate to 19200
        Declare Hserial_RCSTA = %10010000   ' Enable serial port and continuous receive
        Declare Hserial_TXSTA = %00100100   ' Enable transmit and asynchronous mode
        Declare Hserial_Clear = On          ' Enable Error clearing on received characters
    $endif
    $if _HSerialBaud_ = 38400
        Declare Hserial_Baud = 38400        ' Set baud rate to 38400
        Declare Hserial_RCSTA = %10010000   ' Enable serial port and continuous receive
        Declare Hserial_TXSTA = %00100100   ' Enable transmit and asynchronous mode
        Declare Hserial_Clear = On          ' Enable Error clearing on received characters
    $endif
    $if _HSerialBaud_ = 57600
        Declare Hserial_Baud = 57600    ' Set baud rate to 57600
        Declare Hserial_RCSTA = 144     ' Enable serial port and continuous receive
        Declare Hserial_TXSTA = 36      ' Enable transmit and asynchronous mode
        Declare Hserial_Clear = On      ' Enable Error clearing on received characters
    $endif
    $if _HSerialBaud_ = 115200
        Declare Hserial_Baud = 115200
        Declare Hserial_RCSTA = 144     ' Enable serial port and continuous receive
        Declare Hserial_TXSTA = 36      ' Enable transmit and asynchronous mode
        Declare Hserial_Clear = On      ' Enable Error clearing on received characters
    $endif
'-------------------------------------------------------------------------------
(*
'    $if _HSerialBaud_ = 9600
'    'Calculated Baudrate = 9598 @ Xtal 64MHz, Error = -0,02%
'    Declare Hserial2_RCSTA  = %10010000  ' Enable continuous receive 
'    Declare Hserial2_TXSTA  = %00100100  ' Enable transmit, BRGH = 1
'    Declare Hserial2_Clear  = On         ' Clear overflow automatically
'    Declare Hserial2_SPBRG  = $82        ' Baud Rate Generator Low Byte Value
'    SPBRGH    = $06                     ' Baud Rate Generator High Byte Value
'    BAUDCON.3 = 1                       ' Enable the 16 bit Baud Rate Generator  
'    $endif

    $if _HSerialBaud_ = 9600
        Declare Hserial2_Baud = 9600
        Declare Hserial2_TXSTA = 36      ' Enable transmit and asynchronous mode
        Declare Hserial2_RCSTA = 144     ' Enable serial port and continuous receive
        Declare Hserial2_Clear = On      ' Enable Error clearing on received characters
    $endif
    $if _HSerialBaud_ = 19200
        Declare Hserial2_Baud = 19200        ' Set baud rate to 19200
        Declare Hserial2_RCSTA = %10010000   ' Enable serial port and continuous receive
        Declare Hserial2_TXSTA = %00100100   ' Enable transmit and asynchronous mode
        Declare Hserial2_Clear = On          ' Enable Error clearing on received characters
    $endif
    $if _HSerialBaud_ = 38400
        Declare Hserial2_Baud = 38400        ' Set baud rate to 38400
        Declare Hserial2_RCSTA = %10010000   ' Enable serial port and continuous receive
        Declare Hserial2_TXSTA = %00100100   ' Enable transmit and asynchronous mode
        Declare Hserial2_Clear = On          ' Enable Error clearing on received characters
    $endif
    $if _HSerialBaud_ = 57600
        Declare Hserial2_Baud = 57600    ' Set baud rate to 57600
        Declare Hserial2_RCSTA = 144     ' Enable serial port and continuous receive
        Declare Hserial2_TXSTA = 36      ' Enable transmit and asynchronous mode
        Declare Hserial2_Clear = On      ' Enable Error clearing on received characters
    $endif
    $if _HSerialBaud_ = 115200
        Declare Hserial2_Baud = 115200
        Declare Hserial2_RCSTA = 144     ' Enable serial port and continuous receive
        Declare Hserial2_TXSTA = 36      ' Enable transmit and asynchronous mode
        Declare Hserial2_Clear = On      ' Enable Error clearing on received characters
    $endif
*)
'-------------------------------------------------------------------------------
'===============================================================================
' Choose the HSRSout command for the STM Library. (One only)
    $define _HRSOut HRSOut
'    $define _HRSOut HRSOut1
'    $define _HRSOut HRSOut2
'    $define _HRSOut HRSOut3
'    $define _HRSOut HRSOut4
'    $define _HRSOut HRSOut5
'*******************************************************************************
'* Name    : State Machine Commands                                            *
'* Notes   : Uncomment the line to enable a STM Function                       *
'*******************************************************************************
' Uncomment the followed line to disable the TIMER0 option
' for the STM Library only.
    $define _SMEnableTimer0_

' Uncomment the followed line to disable the terminal function to send strings
' for the STM Library only.
' Enabled = Default configuration.
    $define _EnableTerminal_

' Uncomment the followed line to enable the ReturnSM function.
' Disabled = Default configuration.
'    $define _CheckReturnStateM_

' Uncomment the followed line to disable the Carriage Return before every state
' for the STM Library only. 
' Enabled = Default configuration.
    $define _DisableCRBeforeState_

' Uncomment the followed line to enable some Timers
' All Enabled = Default configuration.
    $define _Timer10mS_
    $define _Timer1S_

' Uncomment the followed line to Synchronize the Main code with Timer 1mS.
' All Disabled = Default configuration.
'    $define _Synchronize1mS_
    $define _SynchronizeB1mS_
'    $define _Synchronize10mS_

' Uncomment the followed line to enable some Delays
' Enabled = Default configuration.
    $define _SMVDelay_

' User Delay1. Disabled = Default configuration.
    $define _Delay1_    

' User Delay2. Disabled = Default configuration.
    $define _Delay2_     

' User Delay3. Disabled = Default configuration.
'    $define _Delay3_

' SM TimeOut system for Buttons and Keypads menus.
    $define _TimeOutSystem_

' SM TimeOut system for Buttons and Keypads menus.
    $define _BackLightSystem_

' Uncomment the followed line to enable another States Machine2 in Background
' All Disabled = Default configuration.
    $define _StatesMachine2_
'    $define _SM2VDelay_    1
'    $define _TimeCounter2_ 1

' (For DEBUG) Uncomment the followed line to insert a state number in every module.
' Disabled = Default configuration. If _DebugStates_ is set then disable _DisableCRBeforeState_.
'    $define _DebugStates_ 

'-------------------------------------------------------------------------------
    ' Library for the States Machine system.
'    Include "D:\MyIncFiles\STMachine01.inc"
    Include "INC\STMachine01.inc"
'*******************************************************************************
'=============================================================================== 
    GoTo STM_START
'*******************************************************************************
'* Name    : USER FUNCTION 1 (Meta Macro and Subroutine)                       *
'* Purpose : Toggle the BUZZER in alarm state                                  *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   : Generate special Routines inside the State Machine Timing         *
'*******************************************************************************  
    $define StartFunction1() F_UserFunction1 = 1

    $define StopFunction1() F_UserFunction1 = 0 : bBUZZER = 0  

'*******************************************************************************
'* Name    : USER FUNCTION 2 (Meta Macro And Subroutine)                       *
'* Purpose : Set the bBUZZER for 250 mS                                        *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   : Generate special Routines inside the State Machine Timing         *
'******************************************************************************* 
    $define StartBeep(pValue) '
    F_UserFunction2 = 1       '
    Set bBUZZER               '
    StartUserDelay2(pValue)

'*******************************************************************************
'* Name    : USER FUNCTION 3 (Meta Macro And Subroutine)                       *
'* Purpose :                                                                   *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   :                                                                   *
'******************************************************************************* 



'*******************************************************************************
'* Name    : USER FUNCTION 4 (Meta Macro And Subroutine)                       *
'* Purpose : Set the BackLight                                                 *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   : SetBackLightTime(Max) => NO delay                                 *
'******************************************************************************* 
' Continuous setting at maximum value.
    Dim BackLightTime As Byte System

$define SetBackLightTime(pTime) '
    $if pTime = Max             '
    PWMBLCounterValue = 11      '
    $else                       '
    BackLightTime = pTime + 1   '
    PWMBLCounterValue = 11      '
    $endif

'*******************************************************************************
'* Name    : LCD Clear                                                         *
'* Purpose : Clear the LCD                                                     *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   : This command use less time than the Cls command.                  *
'******************************************************************************* 
    $ifndef LCD_Clear
    $define LCD_Clear() Print $FE,1
    $endif

'*******************************************************************************
'* Name    : Save Clock parameters to eeprom memory                            *
'* Purpose :                                                                   *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   :                                                                   *
'******************************************************************************* 
    Dim MyAlarmDS1307_Array[5] As Byte
    Dim zMinute    As MyAlarmDS1307_Array#0     
    Dim zHour      As MyAlarmDS1307_Array#1     
    Dim zDay       As MyAlarmDS1307_Array#2     
    Dim zMonth     As MyAlarmDS1307_Array#3     
    Dim zYear      As MyAlarmDS1307_Array#4 

' Address of clock parameters in eeprom
    Symbol EEADR2_Alarm2Avaible = _eeprom - 12 
    Symbol EEADR2_Minute = _eeprom - 11     ' Minute (0..59)
    Symbol EEADR2_Hour = _eeprom - 10       ' Hour    (0..11 or 0..23)

    Symbol EEADR1_Alarm1Avaible = _eeprom - 9 
    Symbol EEADR1_Minute = _eeprom - 8     ' Minute (0..59)
    Symbol EEADR1_Hour = _eeprom - 7       ' Hour    (0..11 or 0..23)
    Symbol EEADR1_Day = _eeprom - 6        ' Date  (0..31)
    Symbol EEADR1_Month = _eeprom - 5      ' Month (1..12)
    Symbol EEADR1_Year = _eeprom - 4       ' Year  (0..99)
    ' The _eeprom -1, -2, -3 locations are reserved for the LCD parameters.
'-------------------------------------------------------------------------------
' Declare local variables.
$ifndef _SMLVWS_Block1_
    $define _SMLVWS_Block1_
    Dim SMLVSWord1 As Word System     ' Local Variable System Word1
    Dim SMLVSWord2 As Word System     ' Local Variable System Word2
$endif

    $if _eeprom > 256
    Dim CLK_Address As SMLVSWord1
    $else
    Dim CLK_Address As SMLVSByte1
    $endif

'-------------------------------------------------------------------------------    
$define SaveE2PTimeDate1() GoSub SaveE2PTimeDate1_Sub

SaveE2PTimeDate1_Sub:
    EWrite EEADR1_Alarm1Avaible,[$5A,VMinute,VHour,VDay,VMonth,VYear]
    F_Alarm1Avaible = 1
    F_EnableAlarm1 = 1
    Return
'------------------------------------------------------------------------------- 
$define SaveE2PTimeDate2() GoSub SaveE2PTimeDate2_Sub

SaveE2PTimeDate2_Sub:
    EWrite EEADR2_Alarm2Avaible,[$5A,VMinute,VHour]
    F_Alarm2Avaible = 1
    F_EnableAlarm2 = 1
    Return
'*******************************************************************************
'* Name    : Save/Restore Alarm parameters to/from eeprom memory               *
'* Purpose :                                                                   *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   :                                                                   *
'*******************************************************************************
' Declare local variables.
    Dim CLKLoop   As SMLVSByte2
    Dim ALAvaible As SMLVSByte3

$define CheckAlarm1Avaible() GoSub CheckAlarm1Avaible_Sub

CheckAlarm1Avaible_Sub:
    ALAvaible  = ERead EEADR1_Alarm1Avaible
    If ALAvaible = $5A Then
        F_Alarm1Avaible = 1
    Else
        F_Alarm1Avaible = 0    
    EndIf
    Return

'-------------------------------------------------------------------------------
$define CheckAlarm2Avaible() GoSub CheckAlarm2Avaible_Sub

CheckAlarm2Avaible_Sub:
    ALAvaible  = ERead EEADR2_Alarm2Avaible
    If ALAvaible = $5A Then
        F_Alarm2Avaible = 1
    Else
        F_Alarm2Avaible = 0    
    EndIf
    Return
'-------------------------------------------------------------------------------
$define RestoreE2PTimeDate1() GoSub RestoreE2PTimeDate1_Sub

RestoreE2PTimeDate1_Sub:
    CLK_Address = EEADR1_Minute
    CLKLoop = 0
    Repeat
        #ifdef WatchDog_Req
        Clrwdt
        #endif 
        MyAlarmDS1307_Array[CLKLoop] = ERead CLK_Address
        Inc CLKLoop
        Inc CLK_Address
    Until CLKLoop > 4
    Return
'-------------------------------------------------------------------------------
$define RestoreE2PTimeDate2() GoSub RestoreE2PTimeDate2_Sub

RestoreE2PTimeDate2_Sub:
    CLK_Address = EEADR2_Minute
    CLKLoop = 0
    Repeat
        #ifdef WatchDog_Req
        Clrwdt
        #endif 
        MyAlarmDS1307_Array[CLKLoop] = ERead CLK_Address
        Inc CLKLoop
        Inc CLK_Address
    Until CLKLoop > 1
    Return
'===============================================================================



'===============================================================================
UserFunctionsExit:
'*******************************************************************************
'* Name    : High Interrupt_Handler                                            *
'* Purpose : Generate a 1mS interrupt                                          *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   : Using the Timer2 & PR2 it is more easy.                           *
'*******************************************************************************     
    On_Hardware_Interrupt GoTo Interrupt_Handler
'-------------------------------------------------------------------------------
'Interrupt Handler.
    Declare Reminders = OFF
Interrupt_Handler:
    Context Save 
    '---------------------------------------------------------------------------
    If PIR1Bits_TMR2IF = 1 Then     ' Check if this is a timer2 interrupt?
        PIR1Bits_TMR2IF = 0         ' Clear the Timer2 interrupt flag for next time.
        '-----------------------------------------------------------------------
        $ifdef _Synchronize1mS_
        F_Timer1mS = 1              ' Set a Flag every 1mS
        $endif
        $ifdef _SynchronizeB1mS_
        F_SMMain1mS = 1             ' Set a Flag every 1mS
        $endif
        $ifdef _PinsTest_
        Toggle bTest1
        $endif
        '-----------------------------------------------------------------------        
        $if _defined(_Timer10mS_) Or _defined(_Timer1S_)
        Inc Timer10mS
        If Timer10mS = 10 Then
            Timer10mS = 0      ' 100Hz Timer
            F_Buttons10mS = 1  ' Interrupt flag to read the Buttons in state 05 (SM_ReadTimeDate)
            '-------------------------------------------------------------------
            $ifdef _BackLightSystem_
            ' Start the PWM BackLight every 10mS
            High bLCD_BackLight
            Set F_PWMBackLight
            PWMBLCounter = PWMBLCounterValue
            $endif
            '-------------------------------------------------------------------            
            $ifdef _Synchronize10mS_
            F_Timer10mS = 1         ' Flag 10mS for user fuinctions.
            $endif
            $ifdef _Timer1S_
            Inc Timer500mS
            If Timer500mS = 50 Then
                Timer500mS = 0
                Toggle F_Timer500mS    ' 1 Hz Timer, to toggle some leds.
                If F_Timer500mS = 1 Then
                    F_Timer1S = 1
                EndIf 
            EndIf 
            $endif
            ' Other Timers?
            ' Your code...
        EndIf
        $endif
        '-----------------------------------------------------------------------
        $ifdef _SMVDelay_
        ' Delay 1mS for the States.
        If F_SMVDelay = 1 Then          ' The VDelay is started.
            Dec SMDelayCounter          ' Decrements the SMDelayCounter every 1mS.
            If SMDelayCounter = 0 Then  ' Check if delay counter reaches 0.
                F_SMVDelay = 0          ' Delay END, clear the Vdelay FLAG.
            EndIf
        EndIf
        $endif  
        '-----------------------------------------------------------------------
        $ifdef _Delay1_
        ' Count every 1mS.
        If F_Delay1 = 1 Then            ' The Delay is started.
            Dec Delay1Counter           ' Decrements the DelayCounter every 1mS.
            If Delay1Counter = 0 Then   ' Check if delay counter reaches 0.
                F_Delay1 = 0            ' Delay End, clear the delay FLAG.
            EndIf
        EndIf
        $endif  
        '-----------------------------------------------------------------------
        $ifdef _Delay2_
        ' Count every 1mS.
        If F_Delay2 = 1 Then            ' The Delay is started.
            Dec Delay2Counter           ' Decrements the DelayCounter every 1mS.
            If Delay2Counter = 0 Then   ' Check if delay counter reaches 0.
                F_Delay2 = 0            ' Delay End, clear the delay FLAG.
            EndIf
        EndIf
        $endif  
        '-----------------------------------------------------------------------
        $ifdef _Delay3_
        ' Count every 1mS.
        If F_Delay3 = 1 Then            ' The Delay is started.
            Dec Delay3Counter           ' Decrements the DelayCounter every 1mS.
            If Delay3Counter = 0 Then   ' Check if delay counter reaches 0.
                F_Delay3 = 0            ' Delay End, clear the delay FLAG.
            EndIf
        EndIf
        $endif  
        '-----------------------------------------------------------------------
        $ifdef _TimeOutSystem_
        ' Count every 1mS.
        If F_TimeOutDelay = 1 Then       ' The Delay is started.
            Dec TimeOutCounter           ' Decrements the DelayCounter every 1mS.
            If TimeOutCounter = 0 Then   ' Check if delay counter reaches 0.
                F_TimeOutDelay = 0       ' Delay End, clear the delay FLAG.
            EndIf
        EndIf
        $endif          
        '-----------------------------------------------------------------------
        $ifdef _BackLightSystem_
        ' Count down the PWM BackLight.
        If F_PWMBackLight = 1 Then
            Dec PWMBLCounter           ' Decrements the DelayCounter every 1mS.
            If PWMBLCounter = 0 Then   ' Check if delay counter reaches 0.
                F_PWMBackLight = 0     ' Delay End, clear the delay FLAG.
                Low bLCD_BackLight
            EndIf        
        EndIf
        $endif
        '-----------------------------------------------------------------------
    EndIf    
'-------------------------------------------------------------------------------
    ' PORTA.4 TMR0 Interrupt
    ' The Timer0 interrupt is used at High to Low edge interrupt.
    If INTCONBits_TMR0IF = 1 Then
        INTCONBits_TMR0IF = 0
        T0CONBits_TMR0ON = 0    ' Stop the Timer0.
        Nop
        TMR0L = 255             ' Reload the Timer0 for next interrupt.
        Nop
        T0CONBits_TMR0ON = 1    ' Restart the Timer0.
        F_DS1307_1S = 1         ' External flag for DS1307 interrupt.
    EndIf
'-------------------------------------------------------------------------------
' Here the another user interrupt handler code....
' .......
' .......
' .......
'-------------------------------------------------------------------------------
END_INT:
'-------------------------------------------------------------------------------
    Context Restore          ' Exit the interrupt handler and restore variables
    Declare Reminders = On
'*******************************************************************************

'*******************************************************************************
'* Name    : EEPROM Data                                                       *
'* Purpose : Write some strings in the EEPROM memory                           *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   : For testing the HRSE2PStrg(Address Eeprom) command                *
'*******************************************************************************
E2p_AddressString1 EData "Testing the STATE MACHINE STM06 scheduler",0

E2p_AddressString2 EData "using the Amicus18 Board (PIC18F25K20)",0

E2p_AddressString3 EData "and the AMI18-LCD.",0
'*******************************************************************************
STM_START:
'*******************************************************************************
' PLACE to insert the library files:
'*******************************************************************************
'* Name    : DS1307-H.Inc                                                      *
'* Purpose : DS1307 Clock Calendar library                                     *
'* Notes   :                                                                   *
'*******************************************************************************  
'   Hardware/Software I2C pins
    Declare SDA_Pin = PORTC.4   ' SDA connected to this pin
    Declare SCL_Pin = PORTC.3   ' SCL connected to this pin
    Declare Hbus_Bitrate 100    ' Bus frequency 400kHz to 1000 Khz that is better for SM.
'    Declare Slow_Bus = On  
    '---------------------------------------------------------------------------
    ' Library for the DS1307 Clock Calendar.  
    ' I2C Harware of the PIC (HBusOut/HBusIn) with ACK control.
'    $define _EnableGIE_Save_
'    Include "D:\MyIncFiles\DS1307-H.inc"    
    Include "INC\DS1307-H.inc"

    ' I2C Software of the PIC (BusOut/BusIn) with ACK control.
'    Include "D:\MyIncFiles\DS1307-S.inc"    
'    Include "INC\DS1307-S.inc"   
'*******************************************************************************
'* Name    : LCD_ST7036.Inc                                                    *
'* Purpose : LCD ST7036 driver                                                 *
'* Notes   : Take care, the contrast datas are in the end of eeprom memory.    *
'*******************************************************************************
    $ifndef _ProteusDebug_
'    Include "D:\MyIncFiles\LCD_ST7036.inc"
    Include "INC\LCD_ST7036.inc"
    $endif
'*******************************************************************************
'* Name    : HRsout_K40.Inc                                                    *
'* Purpose : HRSout1,2,3,4,5 command for 1 or 2 stop bits                      *
'* Notes   :                                                                   *
'*******************************************************************************
    $define _DisableAllinterrupt_
'    Include "D:\MyIncFiles\HRsout_K40.inc"
    Include "INC\HRsout_K40.inc"
'*******************************************************************************
'* Name    : ORG_SyncBlock_K20.Inc                                             *
'* Purpose : Generate an ORG command syncronized with Erase Blocks, K20 series *
'* Notes   : For Cdata Tables                                                  *
'******************************************************************************* 
'    Include "D:\MyIncFiles\ORG_SyncBlock_K20.inc"
    Include "INC\ORG_SyncBlock_K20.inc"
' Syntax: ORG_EBlock(pAddress)  
'===============================================================================

'###MAIN CODE###################################################################
STMAIN:
'*******************************************************************************
'* Name    : Init some variables                                               *
'* Purpose :                                                                   *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   :                                                                   *
'*******************************************************************************
    #ifdef WatchDog_Req
    Clrwdt
    #endif 
    WDTCON.0 = 0            ' Disable the Watchdog
    INTCON = 0              ' Disable All interrupts
    TBLPTRU = 0
    INTCON2Bits_RBPU = 1    ' Disable internal PullUp
    WPUB = 0                ' Pullups disabled in PORTB
    T0CON = 0

' Init the PORTS
'    ANSEL = 0
'    ANSELH = 0
'    CM1CON0 = 0
'    CM2CON0 = 0
    PORTA = 0               ' Clear all ports
    LATA = 0
    PORTB = 0
    LATB = 0    
    PORTC = 0
    LATC = 0
    Input PORTC.7
    Output PORTC.6
'===============================================================================
    DelayMS 250     ' Delay for LCD to stabilize.
    BPF = 0         ' Sure the reset is done.
    Cls
    DelayMS 100
    $ifdef _ST7036_INC_
    LCD_Clear()
    $else
    Print $FE,1
    $endif
'-------------------------------------------------------------------------------
' Init the PORTS
    Low bBUZZER
    Low bLCD_BackLight      ' Clear the bLCD_BackLight.
    PWMBLCounterValue = 9   ' Start Value of PWM BackLight.
    Input bButton1
    Input bButton2
    Input bButton3
    Input bButton4
    $ifdef _PinsTest_
    Low bTest1
    Low bTest2
    $endif
'-------------------------------------------------------------------------------
    Input PORTA.4   ' Input of the Timer0 for counting.
'*******************************************************************************
'* Name    :                                                                   *
'* Purpose : Initialize some variables and the State Machine                   *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   :                                                                   *
'*******************************************************************************
    ' Clear All flags to begin.
    SM_UserFunctionFlags = 0
'    SM_UserFlags = 0
    SM_UserSystemFlags = 0         
'-------------------------------------------------------------------------------
     InitStateMachine()
'###############################################################################
'#### STATE MACHINE STARTS #####################################################
' The Main code Start Here:
StateMachineInit:
'*******************************************************************************
'* Name    : NextState(0)                                                      *
'* Purpose : Initialize the State Machine.                                     *
'* Notes   : Start the first state.                                            *
'*******************************************************************************
    NextState(0)
'*******************************************************************************
'* Name    : StateMachineStart                                                 *
'* Purpose : Clear the Watchdog If enabled.                                    *
'* Notes   : The ReturnSM() goes Here:                                         *
'*******************************************************************************
StateMachineStart:
    #ifdef WatchDog_Req
    Clrwdt
    #endif 
'*******************************************************************************
'* Name    : USER Functions                                                    *
'* Purpose : Write some Timing functions                                       *
'* Notes   : Use short code only to avoid delaying the state machine           *
'*******************************************************************************
' RUN Timer function: 
    $ifdef _Synchronize1mS_
    If F_Timer1mS = 1 Then
        F_Timer1mS = 0
        ' Your Code...
    EndIf
    $endif
'-------------------------------------------------------------------------------
' RUN Example of an user Timing.
    $ifdef _Synchronize10mS_
    If F_Timer10mS = 1 Then
        F_Timer10mS = 0

    EndIf
    $endif
'-------------------------------------------------------------------------------
' RUN User Function1: 
    If F_UserFunction1 = 1 Then
        bBUZZER = F_Timer500mS
    EndIf
'-------------------------------------------------------------------------------
' RUN User Function2: Clear bBUZZER after a delay2.
    If F_UserFunction2 = 1 Then
        If F_Delay2 = 0 Then
            Clear bBUZZER
            F_UserFunction2 = 0
        EndIf
    EndIf
'-------------------------------------------------------------------------------
' RUN User Function3: 

'-------------------------------------------------------------------------------

'*******************************************************************************
'* Name    : States Machine Scheduler                                                          
'* Purpose : Running the code of All modules.                   
'* Notes   : Do not forget update the State Label.                                            
'===============================================================================
'  Running the States Machine2 in BackGround.
$ifdef _StatesMachine2_
    If State2Index > 0 Then
        GoTo StateMachine2Start 
    EndIf
$endif
' Return from States Machine2
ReturnStateMachine2:
'===============================================================================
    ' Running the Module Delay. The F_SMVDelay flag must be clear by a Timer running
    ' in the interrupt handler.
    $ifdef _SMVDelay_
    If F_SMVDelay = 1 Then
        GoTo StateMachineStart  '  Waiting delay for the States Machine1.            
    EndIf
    $endif
    '===========================================================================
    ' Update the LABELS when you add a new State Machine Module.
    BranchL StateIndex,[STATE00,STATE01,STATE02,STATE03,STATE04,STATE05,STATE06,_
    STATE07,STATE08,STATE09,STATE10,STATE11,STATE12,STATE13,STATE14,STATE15,_
    STATE16,STATE17,STATE18,STATE19,STATE20,STATE21,STATE22,STATE23,STATE24,_
    STATE25]
    '---------------------------------------------------------------------------
    ' Debug section. StateIndex is OUT of RANGE.
    $ifdef _SMVDelay_
    F_SMVDelay = 0
    $endif
    $ifdef _EnableTerminal_
    _HRSOut "STATE OUT OF RANGE: ", Dec StateIndex,CR,LF
    DelayMS 1000
    $endif
    ' ERROR in States Machine Variable Range. Reset the States Machine. 
    GoTo StateMachineInit  ' Equivalent of Reset On stack overflow. 
'#### STATE MACHINE END ########################################################
'###############################################################################

'*******************************************************************************
'* Name    : STATE00                                                          
'* Purpose : Initialize the project in the terminal window and LCD.                   
'* Input   : None                                                              
'* Output  : None                                                              
'* Notes   : Start the first state.                                            
'===============================================================================
' Define the Global variables used in this state:
    Dim AllButtonsBitsDefects As Byte
    Dim ButtonFail As Byte
' Define the Local variables used in this state:

' Define the Symbols used:

'===============================================================================
STATE00:
'===============================================================================
    StateInit() 
    ' Transitional Input State.
    '##-INIT SECTION-###########################################################

    '##-END INIT-###############################################################
    StateInitEnd()
    ' Static State.
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    SM_UserFunctionFlags = 0
'    SM_UserFlags = 0
    SM_UserSystemFlags = 0   
    AllButtonsBitsDefects = %11110000   ' NO button fails. Reset value.
    ButtonFail = 0
    '---------------------------------------------------------------------------
    ' Terminal
    HRSLStrg(TXT0,AllChars,0) : HRSOut " STM06",CR,LF    ' "STATES MACHINE"
    HRSLStrg(TXT1,1)        ' "By A. Freixanet"
    '---------------------------------------------------------------------------
    ' LCD
    SetBackLightTime(Max)   ' Set the Backlight to see the text on the LCD.
    LCD_Clear()
    PrintStrg(TXT0,1,1)     ' "STATES MACHINE"
    PrintStrg(TXT1,2,1)     ' "By A. Freixanet"
    '---------------------------------------------------------------------------
    NextStateDelay(3000,IncState)  ' Goto State 01 with 3Sec delay. 

':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(0) ' Delay between execution of MAIN module (adjust the delay)
'===============================================================================
    StateOut()
    'Transitional Output State.
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    HRSOut CR,LF
    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    StateOutEnd()    
'===============================================================================    
    ReturnSM()
'*******************************************************************************

'*******************************************************************************
'* Name    : STATE01 [SM_ProjectInfo]   
'* Purpose : Initialize the project in the terminal window                     
'* Input   : None                                                              
'* Output  : None                                                              
'* Notes   : Start the first state.                                            
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:
    Dim Loop As SMLVSByte1
    Dim DataTemp As SMLVSByte2
' Define the Symbols used:
    Symbol _ID_LOCATION = $200000   ' Write the IDLOCS address. Eight memory locations (200000h-200007h) are designated, see the datasheet
'===============================================================================
STATE01:
'===============================================================================
    StateInit() 
    ' Transitional Input State.
    '##-INIT SECTION-###########################################################

    '##-END INIT-###############################################################
    StateInitEnd()
    ' Static State.
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    $ifdef _ST7036_INC_
    HRSLStrg(TXT33,1)   ' "Using the ST7036 LCD with the LCD Driver <LCD_ST7036.inc>"
    HRSLStrg(TXT28,1)   ' "Using the library <DS1307-H.Inc>"
    SetBackLightTime(Max)           ' Set the Backlight to see the text on the LCD.
    LCD_Clear()
    PrintStrg(TXT33,1,1,16)         ' "Using the ST7036" Print 16 characters only.
    PrintStrg(TXT34,2,1,AllChars)   ' "<LCD_ST7036.Inc>"
    $endif

    HRSLStrg(TXT3,1)    ' "Testing the DS1307 Clock Calendar"
    HRSLStrg(TXT4,1)    ' "Sending Time every second & Date every minute To the terminal."    
    HRSLStrg(TXT5,0)    ' "The Hserial Baud Rate is set to "  

    $if _HSerialBaud_ = 9600
    HRSLStrg(TXT6,0)    ' "9600"
    $endif
    $if _HSerialBaud_ = 19200
    HRSLStrg(TXT7,0)    ' "19200"
    $endif
    $if _HSerialBaud_ = 38400
    HRSLStrg(TXT8,0)    ' "38400"
    $endif
    $if _HSerialBaud_ = 57600
    HRSLStrg(TXT9,0)    ' "57600"
    $endif
    $if _HSerialBaud_ = 115200
    HRSLStrg(TXT10,0)    ' "115200"
    $endif
    HRSLStrg(TXT23,1)    ' " Bauds."

    $ifdef _ProteusDebug_
    HRSLStrg(TXT31,1)           ' "Clock = 16 Mhz for Proteus testing"
    $else
    HRSLStrg(TXT32,1)           ' "Clock = 64 Mhz For real piece testing"    
    $endif
    '---------------------------------------------------------------------------
    ' Sending more information from the eeprom to the terminal.
    HRSOut CR,LF
    ' Send 1st String.
    HRSE2PStrg(E2p_AddressString1,1)
    ' Send 2nd String.
    HRSE2PStrg(E2p_AddressString2,1)
    ' Send 3rd String.
    $ifdef _ST7036_INC_    
    HRSE2PStrg(E2p_AddressString3,1)
    $endif
    '---------------------------------------------------------------------------
    ' READING THE IDLOCS...
    HRSOut CR,LF
    HRSLStrg(TXT35,0)               ' "Project Version (Read PIC ID):"
    EECON1 = %11000000              ' Access Configuration registers
    TBLPTRL = _ID_LOCATION & 255
    TBLPTRH = (_ID_LOCATION >> 8) & 255
    TBLPTRU = (_ID_LOCATION >> 16) & 255
    For Loop = 0 To 7       ' Start the loop
        Tblrd*+             ' Read one memory position.
        HRSOut TABLAT       ' Read ASCII characters
    Next  
    EECON1 = 0  ' Disable read the Configuration registers
    TBLPTRU = 0 ' The HRSOut command of the compiler does not clear the "TBLPTRU", then take care of that.
                ' The HRSOut command can crash if the TBLPTRU SFR is not cleared.
    HRSOut CR,LF
    '---------------------------------------------------------------------------
    ' Check if some Alarm is available in eeprom memory.
    CheckAlarm1Avaible()
    CheckAlarm2Avaible()
    '---------------------------------------------------------------------------
    F_MenuContrastFromReset = 1
    '---------------------------------------------------------------------------
    NextStateDelay(2500,IncState)   ' With delay because there are some strings 
                                    ' printed to the LCD.
':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(0) ' Delay between execution of MAIN module (adjust the delay)
'===============================================================================
    StateOut()
    'Transitional Output State.
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    HRSOut CR,LF
    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    StateOutEnd()    
'===============================================================================    
    ReturnSM()
'*******************************************************************************

'*******************************************************************************
'* Name    : STATE02  (SM_CheckACK)                                                        
'* Purpose : Check if the DS1307 is present on the I2C bus.                               
'* Input   : None                                                             
'* Output  : None                                                            
'* Notes   : The ReturnACK must to be = 0.                                                                 
'===============================================================================
' Define the Global variables used in this state:
    Dim ReturnACK As Byte
' Define the Local variables used in this state:

' Define the Symbols used:

'===============================================================================
STATE02:
'===============================================================================
    StateInit() 
    ' Transitional Input State.
    '##-INIT SECTION-###########################################################
    HRSLStrg(TXT11,1)       ' "Check the DS1307 ackknowledge."
    HRSLStrg(TXT12,1)       ' Check if the DS1307 Clock Calendar is connected?
    '##-END INIT-###############################################################
    StateInitEnd(SyncOn)    ' Module synchronized with timing 1mS.
    ' Static State.
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    ' Only check value = 0, other values could be = 1 to 255.
    DS1307_Present(ReturnACK)
    If ReturnACK = 1 Then
        HRSLStrg(TXT14,1)           ' "NACK DS1307 RTC device!", CR
        NextState(SM_Error_NACK)    ' The program demo cannot run.
    Else
        HRSLStrg(TXT13,1)           ' "The DS1307 Device is ready!", CR
        NextState(SM_Enable1Hz)
    EndIf  

':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(0)    ' Delay between execution of the MAIN module (adjust the delay)
'===============================================================================
    StateOut()
    'Transitional Output State.
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    HRSOut CR,LF
    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    StateOutEnd()    
'===============================================================================    
    ReturnSM()
'*******************************************************************************

'*******************************************************************************
'* Name    : STATE03  (SM_Enable1Hz)                                                          
'* Purpose : Config the DS1307 to output the 1Hz signal.                                  
'* Input   : None                                                               
'* Output  : None                                                               
'* Notes   : Goto the menu 1.                                                                   
'===============================================================================
' Define the Global variables used in this state:
    Dim AllButtons As Byte
    Dim LCDContrast As Byte
    Dim RTC_MinuteOld As Byte
    Dim F_DOeveryMinute As Bit
' Define the Local variables used in this state:

' Define the Symbols used:

'===============================================================================
STATE03:
'===============================================================================
    StateInit() 
    ' Transitional Input State.
    '##-INIT SECTION-###########################################################
    HRSLStrg(TXT15,1)       ' "Enable signal Output with frequency = 1 Hz."
    '##-END INIT-###############################################################
    StateInitEnd(SyncOn)    ' Module synchronized with timing 1mS.
    ' Static State.
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    ' Write to the Config register: Enable signal output with frequency = 1 Hz.
    DS1307_WriteControl(%10010000,ReturnACK)
    If ReturnACK = 1 Then
        HRSLStrg(TXT16,1)                   ' "NACK DS1307 Write Control", CR
        NextState(SM_Error_NACK)            ' Go to SM_Error_NACK State.
    Else
        AllButtons = 0
        StartTimeOut(SM_AskForConfig,10)    ' Start a Time Out for 10 seconds.
        NextState(SM_ContrastSetup)         ' Menu Configuration of the LCD contrast.
    EndIf

':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(0)  ' Delay between execution of MAIN module (adjust the delay)
'===============================================================================
    StateOut()
    'Transitional Output State.
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    RTC_MinuteOld = 255     ' Force to Print the date for reading at first time.
    F_DOeveryMinute = 0
    HRSOut CR,LF
    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    StateOutEnd()    
'===============================================================================    
    ReturnSM()
'*******************************************************************************

'*******************************************************************************
'* Name    : STATE04  (SM_WriteConfig)                                         *
'* Purpose : Configure a valor to the DS1307.                                  *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   : Write All data in the DS1307 calendar                             *
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:

' Define the Symbols used:

'===============================================================================
STATE04:
'===============================================================================
    StateInit() 
    ' Transitional Input State.
    '##-INIT SECTION-###########################################################
    HRSLStrg(TXT61,1)       ' "Update the Time & Date"
    '##-END INIT-###############################################################
    StateInitEnd(SyncOn)    ' Module synchronized with timing 1mS.
    ' Static State.
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

' Code for configuring the DS1307. Only write it once to PIC. 
' If the RTC have a Battery only, compile again without this lines
'  & write to the PIC again.
    ' Config Time and Date to the clock calendar.

    DS1307_WriteDate(VDayOfWeek, VDay, VMonth, VYear, ReturnACK)    ' Write a new date
    If ReturnACK = 1 Then
        HRSLStrg(TXT29,1)               ' "NACK DS1307 Write Date"
        NextState(SM_Error_NACK)        ' The program demo cannot run. 
        GoTo STATE04EXIT
    EndIf
    '---------------------------------------------------------------------------
    Sync1mS()   ' DS1307_WriteTime command synchronized with timing 1mS.
    '---------------------------------------------------------------------------
    DS1307_WriteTime(VHour, VMinute, 0, ReturnACK) ' Write a new time   
    If ReturnACK = 1 Then
        HRSLStrg(TXT30,1)               ' "NACK DS1307 Write Time"
        NextState(SM_Error_NACK)        ' The program demo cannot run. 
        GoTo STATE04EXIT
    EndIf
    '---------------------------------------------------------------------------
    NextState(SM_ReadTimeDate)          ' Write with success.

STATE04EXIT:
':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(0) ' Delay between execution of MAIN module (adjust the delay)
'===============================================================================
    StateOut()
    'Transitional Output State.
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    StateOutEnd()    
'===============================================================================    
    ReturnSM()
'*******************************************************************************

'*******************************************************************************
'* Name    : STATE05 (SM_ReadTimeDate)                                                         
'* Purpose : READING Time & Date                                          
'* Input   : None                                                              
'* Output  : None                                                              
'* Notes   : MAIN program: Read the Time every second & Read the date every minute.
'*           Set the Backlight to 5 Sec every minute to see the Time & Date on the LCD.
'*           INFINITE LOOP                                                                 
'===============================================================================
' Define the Global variables used:
    Dim ButtonsVirtualPORT As Byte
    Dim F_SW1 As ButtonsVirtualPORT.0
    Dim F_SW2 As ButtonsVirtualPORT.1    
    Dim F_SW3 As ButtonsVirtualPORT.2    
    Dim F_SW4 As ButtonsVirtualPORT.3
    Dim RTC_DayName As String * 9         ' Holds the name of the day
    Dim RTC_MonthName As String * 10      ' Holds the name of the month
' Define the Local variables used in this state:

' Define the Symbols used :

'===============================================================================
STATE05:
'===============================================================================
    StateInit()
    ' Transitional Input State.
    '##-INIT SECTION-###########################################################
    SetBackLightTime(5)      ' Set the Backlight 5 seconds to see the text on the LCD.
    ' Initialise some values.
    F_MenuContrastFromReset = 0     ' Reset finished.
    IOCB = 0
    DisableTimeOut()                ' Only for security.
    '##-END INIT-###############################################################
    StateInitEnd(SyncOn)   ' Module synchronized with timing 1mS.
    ' Static State.
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
   
    ' Check if an alarm is On detected by the SM2?
    If F_AlarmX = 1 Then
        F_AlarmX = 0
        AllButtons = 0
        NextState(SM_Alarm)
        GoTo ERROR05EXIT        ' Priority exit.
    EndIf
    '---------------------------------------------------------------------------
    ' DO every second.
    If F_DS1307_1S = 1 Then     ' Timing 1 Sec from DS1307 interrupt.
    '---------------------------------------------------------------------------
        $ifdef _PinsTest_
        Set bTest2
        $endif
        '-----------------------------------------------------------------------
        DS1307_ReadTime(ReturnACK)      ' Read the time from the DS1307
        If ReturnACK = 1 Then
            HRSLStrg(TXT18,1)           ' "NACK DS1307 Read Time"        
            NextState(SM_Error_NACK)
            GoTo ERROR05EXIT            ' Bypass the code below.
        EndIf
        F_DS1307_1S = 0                 ' Clear the Second flag waiting for next one.
        '-----------------------------------------------------------------------
        $ifdef _StatesMachine2_
        ' This code is executed always after this module.
        NextState2(SM2_PrintTimeDate)   ' Start a code (every second) in BackGround with the State Machine2.
        $endif
        '=======================================================================
        ' DO Every Minute.
        If RTC_Minute <> RTC_MinuteOld Then
            '-----------------------------------------------------------------------
            Sync1mS()       ' (DS1307_ReadDate) Command synchronized with interrupt 1mS.
            '-------------------------------------------------------------------
            ' Read the Date from the DS1307
            DS1307_ReadDate(ReturnACK)      ' Read the date from the DS1307
            If ReturnACK = 1 Then
                HRSLStrg(TXT19,1)           ' "NACK DS1307 Read Date"
                NextState(SM_Error_NACK)
                GoTo ERROR05EXIT            ' Bypass the code below.
            EndIf

            ' Get the day's name into string RTC_DayName
            DS1307_Get_DayName(RTC_DayOfWeek, RTC_DayName) 
            ' Get the months's name into string RTC_MonthName
            DS1307_Get_MonthName(RTC_Month, RTC_MonthName) 
            RTC_MinuteOld = RTC_Minute      ' Save the new minute value.
            '-------------------------------------------------------------------
            $ifdef _StatesMachine2_
            F_DOeveryMinute = 1 ' Start a code (every minute) in BackGround with the States Machine2.
                                ' This code is executed always after this module.
            $endif
            '-------------------------------------------------------------------                                    
            SetBackLightTime(5) ' Set the Backlight to see the text on the LCD every minute.  
            '-------------------------------------------------------------------
            ' DO every minute.
            ' Clear the Buttons FAULT. ' Try checking again if it has been fixed.
            AllButtonsBitsDefects = %11110000  
            ButtonFail = 0             
        EndIf                        
        '=======================================================================
        ' DO every second.
        ' Decrement the Delay to stop the Backlight.
        If BackLightTime > 0 Then                
            Dec BackLightTime           ' Decrement the Backlight counter every second.
            If BackLightTime = 0 Then
                PWMBLCounterValue = 3   ' Minimum value (30%) of the PWM BackLight.
            EndIf
        EndIf    
    '---------------------------------------------------------------------------
    Else    
    '---------------------------------------------------------------------------
        ' Press a Button if any function is needed again.
        ' HOW TO USE an USER Timing function: Read the Buttons every 10mS. 
        If F_Buttons10mS = 1 Then       ' Check Buttons every 10mS.
            F_Buttons10mS = 0
            GoSub ReadButtons2PORT_Sub  ' There is not a debounce code.
            
            ' Press the Button1 to go to the Contrast Setup (menu).
            If F_SW1 = 0 Then
                StartTimeOut(SM_ReadTimeDate,10) ' Start a Time Out For 10 seconds.
                NextIndState(SM_ButtonsOFF2,SM_ContrastSetup)
            EndIf
                
            ' Press the Button2 to go to the DS1307 Configuration setup (menu).
            If F_SW2 = 0 Then
                StartTimeOut(SM_ReadTimeDate,10) ' Start a Time Out For 10 seconds.
                NextIndState(SM_ButtonsOFF2,SM_AskForConfig)            
            EndIf

            ' Press the Button3 to enable the Day Alarm.
            If F_SW3 = 0 Then       ' If F_SW3 pressed...
                NextIndState(SM_ButtonsOFF2,SM_SeeAlarm2)
            EndIf

            ' Press the Button4 To disable the Alarms.
            If F_SW4 = 0 Then       ' If F_SW4 pressed...
                NextIndState(SM_ButtonsOFF2,SM_DisableAlarms)
            EndIf
            AllButtons = 0
        EndIf
    '---------------------------------------------------------------------------
    EndIf
    '---------------------------------------------------------------------------
ERROR05EXIT:        ' This LABEL must be inside the MAIN Module.

    $ifdef _PinsTest_
    Clear bTest2
    $endif
':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(0) ' Delay between execution of MAIN module (adjust the delay)
'===============================================================================
    StateOut()
    'Transitional Output State.
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    StateOutEnd()
'===============================================================================
    ReturnSM() 
'*******************************************************************************

'*******************************************************************************
'* Name    : STATE06 (SM_Error_NACK)                                                          
'* Purpose : Press any Button To try the communication again.  
'* Input   : None                                                              
'* Output  : None                                                              
'* Notes   :                                                                  
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:

' Define the Symbols used :

'===============================================================================
STATE06:
'===============================================================================
    StateInit()
    ' Transitional Input State.
    '##-INIT SECTION-###########################################################
    NextState2(SM2_Init)    ' Stop the States Machine2.
    HRSLStrg(TXT22,1)       ' "Warning: Communication error! ACK no valid."
    HRSLStrg(TXT25,1)       ' "Press the Button 2 to ReStart the programm."
    SetBackLightTime(Max)   ' Set the Backlight to see the text on the LCD.
    LCD_Clear() 
    PrintStrg(TXT26,1,1)    ' "NACK DS1307"
    PrintStrg(TXT27,2,1)    ' "RESTART any SW"
    '##-END INIT-###############################################################
    StateInitEnd()    
    ' Static State.
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    GoSub ReadButtons2PORT_Sub                      ' Read All Buttons.

    ' If any Button pressed... in case of a Button fails...
    If F_SW1 = 0 Or F_SW2 = 0 Or F_SW3 = 0 Or F_SW4 = 0 Then
        PrintStrg(TXT39,2,1)    ' "TRY DS1307 AGAIN"
        NextIndStateDelay(1500,SM_ButtonsOFF2,SM_CheckACK) ' Indirect addressing
    EndIf

':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(30)     ' Read the Button every 30 mS.
'===============================================================================
    StateOut()
    'Transitional Output State.
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    StateOutEnd() 
'===============================================================================
    ReturnSM() 
'*******************************************************************************

'*******************************************************************************
'* Name    : STATE07 [SM_AskForConfig]                                                      
'* Purpose : Fist window of the menu. Make choice: Config Time & Date or not.                                               
'* Input   : None                                                          
'* Output  : None                                                            
'* Notes   : There is a Time Out of 10 seconds by Delay1                                                        
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:

' Define the Symbols used:

'===============================================================================
STATE07:
'===============================================================================
    StateInit()
    ' Transitional Input State.
    '##-INIT SECTION-###########################################################
    SetBackLightTime(Max)   ' Set the Backlight to see the text on the LCD.
    LCD_Clear()
    PrintStrg(TXT41,1,1)    ' "SET TIME/DATE S3"
    PrintStrg(TXT72,2,1)    ' "SET ALARMS    S1"
    '##-END INIT-###############################################################
    StateInitEnd()
    ' Static State.
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    Select AllButtons
        Case 2,4                        ' Answer NO => Read Time & Date 
            AllButtons = 0                     
            NextState(SM_ReadTimeDate)  ' Goto Read Time & Date.

        Case 1                               ' Answer S1 => Set Alarms.
            AllButtons = 0                    
            StartTimeOut(SM_ReadTimeDate,10) ' Start a Time Out 10 seconds 
            NextState(SM_AlarmMenu)          ' Start configuration.

        Case 3                              ' Answer S3 => Go to Get Week.
            AllButtons = 3                  ' Like the Button 3 pressed (+)
            VDayOfWeek = 0                  ' Initialise parameter.
            StartTimeOut(SM_ReadTimeDate,10)    ' Start a Time Out for 10 seconds 
            NextState(SM_GetWeek)           ' Start configuration.

        Case Else
            ' Make a loop with the SM_ButtonsOFF Module.
            StartTimeOut(SM_ReadTimeDate,10)          ' Start a Time Out for 10 seconds  
            NextIndState(SM_ButtonsOFF,CallerState)   ' Load the present state to return here.
    EndSelect 

':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(0)             ' Delay between execution of the MAIN module (adjust the delay)
'===============================================================================
    StateOut()
    'Transitional Output State.
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    StateOutEnd()
'===============================================================================
    ReturnSM() 
'*******************************************************************************

'*******************************************************************************
'* Name    : STATE08 [SM_ButtonsOFF]                                                       
'* Purpose : Check All Buttons are OFF                      
'* Input   : None                                                              
'* Output  : None                                                             
'* Notes   : While/Wend loop by state machine. Waiting the Buttons until OFF.       
'*           In Delay used to do these functions, the PDS programmer could write
'*           some applications running in the BackGroung using the State Machine 2.
'===============================================================================
' Define the Global variables used in this state:
    Dim ButtonsOffCounter As Byte
' Define the Local variables used in this state:
 
' Define the Symbols used:

'===============================================================================
STATE08:
'===============================================================================
    StateInit()
    ' Transitional Input State.
    '##-INIT SECTION-###########################################################
    SetBackLightTime(Max)     ' Set the Backlight to see the text on the LCD.
    ButtonsOffCounter = 0
    '##-END INIT-###############################################################
    StateInitEnd()
    ' Static State.
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    GoSub ReadButtonsPORT_Sub           ' Init & Read All Buttons.

    ' Waiting All Buttons OFF (All Buttons have a Pull-up resistor).
    If ButtonsVirtualPORT = 255 Then
        NextStateDelay(30,IncState)     ' Delay 30mS to exit the state.
    EndIf

    ' Check if the Buttons fail. Just for joke.
    GoSub CheckButtonsFail_Sub          ' If 5 Sec pull down => Buttons Fails!

':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(30)
'===============================================================================
    StateOut()
    'Transitional Output State.
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    StateOutEnd()
'===============================================================================
    ReturnSM() 
'===============================================================================
'* Name    : ReadButtonsPORT_Sub                                              
'* Called From: SM_ButtonsOff, SM_ReadButtons                                     
'* Purpose : Read All Buttons                                                 
'* Input   : None                                                              
'* Output  : None                                                              
'* Notes   : 4 Buttons in PORTA & disable the Button that failed.                         
'===============================================================================  
ReadButtonsPORT_Sub:
    ANSEL = 0                       ' PORTA digital
    TRISA = TRISA | %00001111       ' SW0 to F_SW3 for input.
ReadButtons2PORT_Sub:
    If ButtonFail > 0 Then
        SetBit AllButtonsBitsDefects,ButtonFail - 1   ' Disable the PushButton.
    EndIf
    ' All Buttons failed are saved in the AllButtonsBitsDefects buffer.
    ButtonsVirtualPORT = PORTA | AllButtonsBitsDefects ' Read SW0 to F_SW3
    Return
'===============================================================================
'* Name    : CheckButtonsFail_Sub                                              
'* Called From: SM_ButtonsOff, SM_ButtonsOFF2                                     
'* Purpose : Check If one Button fails.                                                 
'* Input   : None                                                              
'* Output  : None                                                              
'* Notes   : This routine works with the command: StartDelayMS(30) within loop delay.                         
'=============================================================================== 
CheckButtonsFail_Sub:
    Inc ButtonsOffCounter
    If ButtonsOffCounter = 167 Then             ' 167 x 30mS = 5 Seconds
        ButtonsOffCounter = 0
        If ButtonsVirtualPORT.0 = 0 Then
            ButtonFail = 1
        ElseIf ButtonsVirtualPORT.1 = 0 Then
            ButtonFail = 2
        ElseIf ButtonsVirtualPORT.2 = 0 Then
            ButtonFail = 3
        ElseIf ButtonsVirtualPORT.3 = 0 Then
            ButtonFail = 4
        EndIf
        NextState(SM_ReadTimeDate)              ' Come back to the Main Module.
    EndIf
    Return
'*******************************************************************************

'*******************************************************************************
'* Name    : STATE09 [SM_ReadButtons]
'* Purpose : Read All Buttons in PORTA
'* Input   : None
'* Output  : None                                                             
'* Notes   :                                                                  
'===============================================================================
' Define the Global variables used in this state:
    Dim KEYnOld As Byte
    Dim KEYCounter As Byte
' Define the Local variables used in this state:

' Define the Symbols used:

'===============================================================================
STATE09:
'===============================================================================
    StateInit()
    ' Transitional Input State.
    '##-INIT SECTION-###########################################################
'    HRSLStrg(TXT40,1)       ' "Waiting a Button pressed!"
    KEYnOld = 0             ' Initialize parameters for debouncing.
    KEYCounter = 0
    AllButtons = 0
    '##-END INIT-###############################################################
    StateInitEnd()
    ' Static State.
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    GoSub ReadButtons2PORT_Sub                  ' Read All Buttons.

    If ButtonsVirtualPORT < 255 Then            ' If one Button pressed.
        If KEYnOld = ButtonsVirtualPORT Then    ' Some debounce system
            Inc KEYCounter
            If KEYCounter = 4 Then              ' 4 + 1 readings necessary.
                KEYCounter = 0
                '---------------------------------------------------------------
                If F_SW1 = 0 Then       ' Check Button 1.
                    AllButtons = 1
                    IncState()
                ElseIf F_SW2 = 0 Then   ' Check Button 2.
                    AllButtons = 2
                    IncState()
                ElseIf F_SW3 = 0 Then   ' Check Button 3.
                    AllButtons = 3
                    IncState()
                ElseIf F_SW4 = 0 Then   ' Check Button 4.
                    AllButtons = 4
                    IncState()
                EndIf            
                '---------------------------------------------------------------
            EndIf
        Else
            KEYCounter = 0
        EndIf
        KEYnOld = ButtonsVirtualPORT
    Else
        KEYCounter = 0
    EndIf
    '---------------------------------------------------------------------------
    ' Check the Time Out & goto the correspondent state.
    CheckTimeOut()

':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(30)    ' Adjust some sample time 30mS to debounce the Buttons.
'===============================================================================
    StateOut()
    'Transitional Output State.
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    If F_TimeOutSystemEnable = 0 Then
        StopFunction1() ' Clear the BUZZER when alarm Timeout is finished.
    EndIf
    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$ 
    StateOutEnd()
'===============================================================================
    ReturnSM()
'*******************************************************************************

'*******************************************************************************
'* Name    : STATE10 [SM_ButtonsOFF2]                                                       
'* Purpose : Waiting the Buttons Until OFF.                     
'* Input   : None                                                              
'* Output  : None                                                             
'* Notes   : It is a While 1=1/Wend loop made by the State Machine. 
'*           Using the Indirect addressing [ReturnIndState()]     
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:
 
' Define the Symbols used:

'===============================================================================
STATE10:
'===============================================================================
    StateInit()
    ' Transitional Input State.
    '##-INIT SECTION-###########################################################
    StartBeep(250)     ' Start a pulse of the bBUZZER with every Button pressed.
    ButtonsOffCounter = 0
    '##-END INIT-###############################################################
    StateInitEnd()
    ' Static State.
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    GoSub ReadButtons2PORT_Sub  ' Read All Buttons.

    ' Waiting All Buttons OFF (All Buttons have a Pull-up resistor).
    If ButtonsVirtualPORT = 255 Then
        ReturnIndState(0)       ' Load the Return State defined by the caller.
    EndIf

    ' Check if the Buttons fail. Just for joke.
    GoSub CheckButtonsFail_Sub  ' If 5 Sec pull down => Buttons Fails! 

':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(30)    ' Read the buttons every 30 mS.
'===============================================================================
    StateOut()
    'Transitional Output State.
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    StateOutEnd()
'===============================================================================
    ReturnSM() 
'*******************************************************************************

'*******************************************************************************
'* Name    : STATE11 [SM_GetWeek]                                                      
'* Purpose : Module to configurate the Day of Week.                                                
'* Input   : None                                                          
'* Output  : None                                                            
'* Notes   : (DayOfWeek, Day, Month, Year)                                                       
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:

' Define the Symbols used:

'===============================================================================
STATE11:
'===============================================================================
    StateInit()
    ' Transitional Input State.
    '##-INIT SECTION-###########################################################
    SetBackLightTime(Max)   ' Set the Backlight to see the text on the LCD.
    LCD_Clear()
    PrintStrg(TXT43,1,1)    ' "Day of Week? S3+"
    '##-END INIT-###############################################################
    StateInitEnd()
    ' Static State.
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    Select AllButtons
        Case 1,3
            AllButtons = 0
            Inc VDayOfWeek
            If VDayOfWeek > 7 Then
                VDayOfWeek = 1
            EndIf
            Select VDayOfWeek        
                CLL(2)                      ' Erase the Line 2 of the LCD.
                Case 1
                    PrintStrg(TXT44,2,1)    ' "Sunday" 
                Case 2
                    PrintStrg(TXT45,2,1)    ' "Monday"
                Case 3
                    PrintStrg(TXT46,2,1)    ' "Tuesday"
                Case 4
                    PrintStrg(TXT47,2,1)    ' "Wednesday"
                Case 5
                    PrintStrg(TXT48,2,1)    ' "Thursday"
                Case 6
                    PrintStrg(TXT49,2,1)    ' "Friday"
                Case 7
                    PrintStrg(TXT50,2,1)    ' "Saturday"
            EndSelect
            NextIndState(SM_ButtonsOFF,CallerState)   ' Load the present state to return here.

        Case 2
            AllButtons = 3                  ' Like the Button 3 pressed (+)                     
            VDay = 14
            NextState(SM_GetDay)

        Case 4
            AllButtons = 0
            NextState(SM_ReadTimeDate)      ' Escape.

        Case Else
            ' Make a loop with the SM_ButtonsOFF Module.
            NextIndState(SM_ButtonsOFF,CallerState)    ' Load the present state to return here.
    EndSelect

    StartTimeOut(SM_ReadTimeDate,10)      ' Start a Time Out for 10 seconds

':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(0)
'===============================================================================
    StateOut()
    'Transitional Output State.
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    StateOutEnd()
'===============================================================================
    ReturnSM() 
'*******************************************************************************

'*******************************************************************************
'* Name    : STATE12 [SM_GetDay]                                                        
'* Purpose : Module To configurate the Day (1 to 31).                                                 
'* Input   : None                                                              
'* Output  : None                                                             
'* Notes   : (DayOfWeek, Day, Month, Year)                                                                 
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:

' Define the Symbols used:

'===============================================================================
STATE12:
'===============================================================================
    StateInit()
    ' Transitional Input State.
    '##-INIT SECTION-###########################################################
    SetBackLightTime(Max)   ' Set the Backlight to see the text on the LCD.
    LCD_Clear()
    PrintStrg(TXT51,1,1)    ' "S1-   Day?   S3+"
    PrintStrg(TXT56,2,1)    ' "Day: "
    '##-END INIT-###############################################################
    StateInitEnd() 
    ' Static State.
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    If AllButtons = 1 Then          ' Button (-)
         AllButtons = 0
        Dec VDay
        If VDay = 0 Then
            VDay = 31
        EndIf
        Print Dec2 VDay
        NextIndState(SM_ButtonsOFF,CallerState) ' Load the present state to return here.

    ElseIf AllButtons = 2 Then
        AllButtons = 3              ' Like the Button 3 pressed (+)                     
        VMonth = 5
        NextState(SM_GetMonth)

    ElseIf AllButtons = 3 Then      ' Button (+)
        AllButtons = 0
        Inc VDay
        If VDay > 31 Then
            VDay = 1
        EndIf
        Print Dec2 VDay
        NextIndState(SM_ButtonsOFF,CallerState) ' Load the present state to return here.

    ElseIf AllButtons = 4 Then
        AllButtons = 0
        NextState(SM_ReadTimeDate)  ' Escape.

    Else
        ' Make a loop with the SM_ButtonsOFF Module.
        NextIndState(SM_ButtonsOFF,CallerState)    ' Load the present state to return here.  
    EndIf

    StartTimeOut(SM_ReadTimeDate,10)      ' Start a Time Out for 10 seconds

':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(0)
'===============================================================================
    StateOut()
    'Transitional Output State.
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    StateOutEnd()
'===============================================================================
    ReturnSM() 
'*******************************************************************************

'*******************************************************************************
'* Name    : STATE13 [SM_GetMonth]                                                      
'* Purpose : Module To configurate the Month (1 to 12).                                               
'* Input   : None                                                             
'* Output  : None                                                             
'* Notes   : (DayOfWeek, Day, Month, Year)                                                                   
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:

' Define the Symbols used:

'===============================================================================
STATE13:
'===============================================================================
    StateInit()
    ' Transitional Input State.
    '##-INIT SECTION-###########################################################
    SetBackLightTime(Max)   ' Set the Backlight to see the text on the LCD
    LCD_Clear()
    PrintStrg(TXT52,1,1)    ' "S1-  Month?  S3+"
    PrintStrg(TXT57,2,1)    ' "Month: "
    '##-END INIT-###############################################################
    StateInitEnd() 
    ' Static State.
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    If AllButtons = 1 Then              ' Button (-)
        AllButtons = 0
        Dec VMonth
        If VMonth = 0 Then
            VMonth = 12
        EndIf
        Print Dec2 VMonth
        NextIndState(SM_ButtonsOFF,CallerState)    ' Load the present state to return here.

    ElseIf AllButtons = 2 Then
        AllButtons = 3                  ' Like the Button 3 pressed (+)                     
        VYear = ThisYear - 1
        NextState(SM_GetYear)

    ElseIf AllButtons = 3 Then          ' Button (+)
        AllButtons = 0
        Inc VMonth
        If VMonth > 12 Then
            VMonth = 1
        EndIf
        Print Dec2 VMonth
        NextIndState(SM_ButtonsOFF,CallerState)    ' Load the present state to return here.

    ElseIf AllButtons = 4 Then          ' Escape.
        AllButtons = 0
        NextState(SM_ReadTimeDate)

    Else
        ' Make a loop with the SM_ButtonsOFF Module.
        NextIndState(SM_ButtonsOFF,CallerState)    ' Load the present state to return here.
    EndIf

    StartTimeOut(SM_ReadTimeDate,10)      ' Start a Time Out for 10 seconds

':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(0)
'===============================================================================
    StateOut()
    'Transitional Output State.
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    StateOutEnd()
'===============================================================================
    ReturnSM() 
'*******************************************************************************

'*******************************************************************************
'* Name    : STATE14  [SM_GetYear]                                                       
'* Purpose : Module To configurate the Year.                                                
'* Input   : None                                                              
'* Output  : None                                                              
'* Notes   : (DayOfWeek, Day, Month, Year)                                                                  
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:

' Define the Symbols used:

'===============================================================================
STATE14:
'===============================================================================
    StateInit()
    ' Transitional Input State.
    '##-INIT SECTION-###########################################################
    SetBackLightTime(Max)   ' Set the Backlight to see the text on the LCD.
    LCD_Clear()
    PrintStrg(TXT53,1,1)    ' "S1-  Year?   S3+"
    PrintStrg(TXT58,2,1)    ' "Year: "
    '##-END INIT-###############################################################
    StateInitEnd()
    ' Static State.
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    If AllButtons = 1 Then          ' Button (-)
        AllButtons = 0
        Dec VYear
        If VYear < ThisYear Then
            VYear = MaxYear
        EndIf
        Print Dec2 VYear
        NextIndState(SM_ButtonsOFF,CallerState) ' Load the present state to return here.

    ElseIf AllButtons = 2 Then
        AllButtons = 3              ' Like the Button 3 pressed (+)                     
        VHour = 11
        NextState(SM_GetHour)

    ElseIf AllButtons = 3 Then      ' Button (+)
        AllButtons = 0
        Inc VYear
        If VYear > MaxYear Then
            VYear = ThisYear
        EndIf
        Print Dec2 VYear
        NextIndState(SM_ButtonsOFF,CallerState) ' Load the present state to return here.

    ElseIf AllButtons = 4 Then
        AllButtons = 0
        NextState(SM_ReadTimeDate) ' Escape.

    Else
        ' Make a loop with the SM_ButtonsOFF Module.
        NextIndState(SM_ButtonsOFF,CallerState)    ' Load the present state to return here. 
    EndIf

    StartTimeOut(SM_ReadTimeDate,10)      ' Start a Time Out for 10 seconds

':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(0)
'===============================================================================
    StateOut()
    'Transitional Output State.
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    
    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    StateOutEnd()    
'===============================================================================
    ReturnSM() 
'*******************************************************************************

'*******************************************************************************
'* Name    : STATE15 [SM_GetHour]                                                       
'* Purpose : Module To configurate the Hour.                                                
'* Input   : None                                                             
'* Output  : None                                                              
'* Notes   : DS1307_WriteTime(VHour, VMinute, VSecond)                                                                   
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:

' Define the Symbols used:

'===============================================================================
STATE15:
'===============================================================================
    StateInit()
    ' Transitional Input State.
    '##-INIT SECTION-###########################################################
    SetBackLightTime(Max)   ' Set the Backlight to see the text on the LCD.
    LCD_Clear()
    PrintStrg(TXT54,1,1)    ' "S1-  Hour?   S3+"
    PrintStrg(TXT59,2,1)    ' "Hour: "
    '##-END INIT-###############################################################
    StateInitEnd()    
    ' Static State.
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    If AllButtons = 1 Then              ' Button (-)
        AllButtons = 0
        Dec VHour
        If VHour = 255 Then
            VHour = 23
        EndIf
        Print Dec2 VHour
        NextIndState(SM_ButtonsOFF,CallerState)  ' Load the present state to return here.

    ElseIf AllButtons = 2 Then
        AllButtons = 0
        If F_SettingAlarm2 = 1 Then     ' Programming Alarm2 now?
            VMinute = zMinute - 1       ' Value programmed yet.
        Else
            VMinute = 29                ' Standard value.
        EndIf
        AllButtons = 3                  ' Like the Button 3 pressed (+)
        NextState(SM_GetMinute)

    ElseIf AllButtons = 3 Then          ' Button (+)
        AllButtons = 0
        Inc VHour
        If VHour > 23 Then
            VHour = 0
        EndIf
        Print Dec2 VHour
        NextIndState(SM_ButtonsOFF,CallerState)    ' Load the present state to return here.

    ElseIf AllButtons = 4 Then
        AllButtons = 0          
        NextState(SM_ReadTimeDate)      ' Escape.

    Else
        ' Make a loop with the SM_ButtonsOFF Module.
        NextIndState(SM_ButtonsOFF,CallerState)    ' Load the present state to return here.
    EndIf

    StartTimeOut(SM_ReadTimeDate,10)      ' Start a Time Out for 10 seconds

':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(0)
'===============================================================================
    StateOut()
    'Transitional Output State.
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    StateOutEnd()    
'===============================================================================
    ReturnSM() 
'*******************************************************************************

'*******************************************************************************
'* Name    : STATE16 [SM_GetMinute]                                                       
'* Purpose : Module To configurate the Minutes.                                                 
'* Input   : None                                                              
'* Output  : None                                                              
'* Notes   : DS1307_WriteTime(VHour, VMinute, VSecond)                                                                    
'===============================================================================
' Define the Global variables used in this state:
 
' Define the Local variables used in this state:

' Define the Symbols used:

'===============================================================================
STATE16:
'===============================================================================
    StateInit()
    ' Transitional Input State.
    '##-INIT SECTION-###########################################################
    SetBackLightTime(Max)   ' Set the Backlight to see the text on the LCD.
    LCD_Clear()
    PrintStrg(TXT55,1,1)    ' "S1- Minute?  S3+"
    PrintStrg(TXT60,2,1)    ' "Minute: "
    '##-END INIT-###############################################################
    StateInitEnd()
    ' Static State.
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    If AllButtons = 1 Then               ' Button (-)
        Dec VMinute
        If VMinute = 255 Then
            VMinute = 59
        EndIf
        Print Dec2 VMinute
        NextIndState(SM_ButtonsOFF,CallerState)   ' Load the present state to return here.

    ElseIf AllButtons = 2 Then
        If F_SettingAlarmX = 0 Then
            NextState(SM_WriteConfig)   ' Goto Write the configuration into the DS1307 calendar.
        Else
            NextState(SM_SaveAlarm)  
            GoTo STATE16EXIT            ' Exit priority, No TimeOut.
        EndIf

    ElseIf AllButtons = 3 Then          ' Button (+)
        Inc VMinute
        If VMinute > 59 Then
            VMinute = 0
        EndIf
        Print Dec2 VMinute
        NextIndState(SM_ButtonsOFF,CallerState)   ' Load the present state to return here.

    ElseIf AllButtons = 4 Then
        NextState(SM_ReadTimeDate) ' Escape.

    Else
        ' Make a loop with the SM_ButtonsOFF Module.
        NextIndState(SM_ButtonsOFF,CallerState)    ' Load the present state to return here.
    EndIf

    StartTimeOut(SM_ReadTimeDate,10)      ' Start a Time Out for 10 seconds 
    AllButtons = 0

STATE16EXIT:
':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(0)
'===============================================================================
    StateOut()
    'Transitional Output State.
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    StateOutEnd()    
'===============================================================================
    ReturnSM() 
'*******************************************************************************

'*******************************************************************************
'* Name    : STATE17 [SM_ContrastSetup]                                                           
'* Purpose : Asking to set the contrast or not.                                                 
'* Input   : None                                                               
'* Output  : None                                                               
'* Notes   :                                                                  
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:

' Define the Symbols used:

'===============================================================================
STATE17:
'===============================================================================
    StateInit()
    ' Transitional Input State.
    '##-INIT SECTION-###########################################################
    SetBackLightTime(Max)   ' Set the Backlight to see the text on the LCD.
    LCD_Clear()
    PrintStrg(TXT62,1,1)    ' "CONTRAST SETUP?"
    PrintStrg(TXT42,2,1)    ' "S2=YES  OTHER=NO"
    '##-END INIT-###############################################################
    StateInitEnd()
    ' Static State.
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    Select AllButtons
        Case 1,3,4          ' Buttons (NO)
            AllButtons = 0
            If F_MenuContrastFromReset = 1 Then
                NextState(SM_AskForConfig)  ' Exits from Reset 
            Else
                NextState(SM_ReadTimeDate)
            EndIf
            
        Case 2              ' Button 2 (YES)         
            AllButtons = 3                      ' Like Button (+) pressed.
            $ifndef _ProteusDebug_
            LCDContrast = LCD_ReadContrast()    ' Read the present contrast of the LCD driver.
            LCDContrast = LCDContrast - 1
            $else
            LCDContrast = 7
            $endif
            NextState(SM_SetContrast)

        Case Else
            ' Make a loop with the SM_ButtonsOFF Module.
            NextIndState(SM_ButtonsOFF,CallerState)    ' Load the present state to return here.
    EndSelect

    If F_MenuContrastFromReset = 1 Then
        StartTimeOut(SM_AskForConfig,10)      ' Start a Time Out for 10 seconds            
    Else
        StartTimeOut(SM_ReadTimeDate,10)      ' Start a Time Out for 10 seconds
    EndIf

':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(0)    ' Delay between execution of the MAIN module (adjust the delay)
'===============================================================================
    StateOut()
    'Transitional Output State.
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    StateOutEnd()    
'===============================================================================
    ReturnSM() 
'*******************************************************************************

'*******************************************************************************
'* Name    : STATE18  [SM_SetContrast]                                                       
'* Purpose : Adjust the contrast value of the LCD (by software)                                                 
'* Input   : None                                                               
'* Output  : None                                                               
'* Notes   :                                                                    
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:

' Define the Symbols used:

'===============================================================================
STATE18:
'===============================================================================
    StateInit()
    ' Transitional Input State.
    '##-INIT SECTION-###########################################################
    SetBackLightTime(Max)   ' Set the Backlight to see the text on the LCD.
    LCD_Clear()
    PrintStrg(TXT65,2,1)    ' "S1-  S2=> OK S3+"
    PrintStrg(TXT64,1,1,AllChars) : Print Dec2 LCDContrast   ' "Contrast = "
    '##-END INIT-###############################################################
    StateInitEnd()
    ' Static State.
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    If AllButtons = 1 Then           ' Button (-)
        If LCDContrast > 0 Then
            Dec LCDContrast
        EndIf
        $ifndef _ProteusDebug_
        LCD_WriteContrast(LCDContrast)                      ' Preset Contrast (0-15)
        $endif
        PrintStrg(TXT64,1,1)
        Print Dec2 LCDContrast   ' "CONTRAST: "
        NextIndState(SM_ButtonsOFF,CallerState)               ' Load the present state to return here.

    ElseIf AllButtons = 2 Then
        NextState(SM_SaveContrast)  ' Goto Write the contrast into the LCD.

    ElseIf AllButtons = 3 Then      ' Button (+)
        Inc LCDContrast
        If LCDContrast > 15 Then
            LCDContrast = 15
        EndIf
        $ifndef _ProteusDebug_
        LCD_WriteContrast(LCDContrast)             ' Preset Contrast (0-15)
        $endif
        PrintStrg(TXT64,1,1)
        Print Dec2 LCDContrast   ' "Contrast = "
        NextIndState(SM_ButtonsOFF,CallerState)    ' Load the present state to return here.

    ElseIf AllButtons = 4 Then                     ' Escape.
        If F_MenuContrastFromReset = 1 Then
            NextState(SM_AskForConfig)   ' Exits from Reset 
        Else
            NextState(SM_ReadTimeDate)         
        EndIf
    Else
        ' Make a loop with the SM_ButtonsOFF Module.
        NextIndState(SM_ButtonsOFF,CallerState)    ' Load the present state to return here.
    EndIf

    If F_MenuContrastFromReset = 1 Then
        StartTimeOut(SM_AskForConfig,10)      ' Start a Time Out
    Else
        StartTimeOut(SM_ReadTimeDate,10)      ' Start a Time Out         
    EndIf
    AllButtons = 0

':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(0)    ' Delay between execution of the MAIN module (adjust the delay)
'===============================================================================
    StateOut()
    'Transitional Output State.
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    StateOutEnd()    
'===============================================================================
    ReturnSM() 
'*******************************************************************************

'*******************************************************************************
'* Name    : STATE19  [SM_SaveContrast]                                                      
'* Purpose : Save the contrast value to the eeprom memory.                                                    
'* Input   : None                                                            
'* Output  : None                                                            
'* Notes   :                                                               
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:

' Define the Symbols used:

'===============================================================================
STATE19:
'===============================================================================
    StateInit()
    ' Transitional Input State.
    '##-INIT SECTION-###########################################################
    SetBackLightTime(Max)   ' Set the Backlight to see the text on the LCD.
    LCD_Clear()
    PrintStrg(TXT66,1,1)    ' " Save CONTRAST?"
    PrintStrg(TXT42,2,1)    ' "S2=YES  OTHER=NO"
    '##-END INIT-###############################################################
    StateInitEnd()
    ' Static State.
':::MAIN CODE:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    Select AllButtons
        Case 1,3,4
            CLL(2)
            PrintStrg(TXT68,2,1,AllChars)               ' "---NOT SAVED----" 
            If F_MenuContrastFromReset = 1 Then
                NextStateDelay(1500,SM_AskForConfig)    ' Exits with Delay from Reset
            Else
                NextStateDelay(1500,SM_ReadTimeDate)    ' Exits with Delay
            EndIf
   
        Case 2
            $ifndef _ProteusDebug_
            LCD_SaveContrast()
            $endif
            CLL(2)
            PrintStrg(TXT67,2,1,AllChars)               ' "Contrast Saved"        
            If F_MenuContrastFromReset = 1 Then
                NextStateDelay(1500,SM_AskForConfig)    ' Exits with Delay from Reset
            Else
                NextStateDelay(1500,SM_ReadTimeDate)    ' Exits with Delay
            EndIf

        Case Else
            ' Make a loop with the SM_ButtonsOFF Module.
            NextIndState(SM_ButtonsOFF,CallerState)    ' Load the present state to return here.
    EndSelect
               
    If F_MenuContrastFromReset = 1 Then
        StartTimeOut(SM_AskForConfig,10)      ' Start a Time Out
    Else
        StartTimeOut(SM_ReadTimeDate,10)      ' Start a Time Out         
    EndIf
    AllButtons = 0

':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(0)
'===EXIT SECTION=================================================================
    StateOut()
    'Transitional Output State.
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    StateOutEnd()    
'===============================================================================
    ReturnSM() 
'*******************************************************************************

'*******************************************************************************
'* Name    : STATE20  [SM_AlarmMenu]                                  
'* Purpose : Choose to configure between Alarm1 or Alarm2.                                                              
'* Input   : None                                                             
'* Output  : None                                                              
'* Notes   :                                                                  
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:

' Define the Symbols used:
'===============================================================================
STATE20:
'===============================================================================
    StateInit()
    ' Transitional Input State.
    '##-INIT SECTION-###########################################################
    SetBackLightTime(Max)   ' Set the Backlight to see the text on the LCD.
    LCD_Clear()
    PrintStrg(TXT73,1,1)    ' "SETTING ALARM"
    PrintStrg(TXT74,2,1)    ' "AL1=S1    AL2=S3"
    '##-END INIT-###############################################################
    StateInitEnd()
    ' Static State.
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    Select AllButtons
        Case 1
            AllButtons = 0
            F_SettingAlarm1 = 1
            F_SettingAlarmX = 1
            LCD_Clear()
            PrintStrg(TXT73,1,1,AllChars)   ' "SETTING ALARM" 
            Print "1"
            AllButtons = 3                  ' Like the Button 3 pressed (+)
            VDayOfWeek = 0                  ' Initialise parameter.
            NextStateDelay(1500,SM_GetWeek)

        Case 3
            F_SettingAlarm2 = 1
            F_SettingAlarmX = 1
            LCD_Clear()
            PrintStrg(TXT73,1,1,AllChars)   ' "SETTING ALARM" 
            Print "2"
            If F_Alarm2Avaible = 1 Then
                RestoreE2PTimeDate2()
                VHour = zHour - 1
            Else
                VHour = 11
            EndIf
            AllButtons = 3                  ' Like the Button 3 pressed (+)
            NextStateDelay(1500,SM_GetHour) ' Goto Write the configuration into the DS1307 calendar.

        Case 2,4
            AllButtons = 0          
            NextState(SM_ReadTimeDate)  ' Escape. Goto Read Time & Date.

        Case Else
            ' Make a loop with the SM_ButtonsOFF Module.
            NextIndState(SM_ButtonsOFF,CallerState) ' Load the present state to return here.
    EndSelect
               
    StartTimeOut(SM_ReadTimeDate,10) ' Start a Time Out for 10 seconds

':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(0)    ' Delay between execution of the MAIN module (adjust the delay)
'===============================================================================
    StateOut()
    'Transitional Output State.
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    StateOutEnd()    
'===============================================================================
    ReturnSM() 
'*******************************************************************************

'*******************************************************************************
'* Name    : STATE21  [SM_SaveAlarm]
'* Purpose : Save Time/Date parameters for alarm.                                                         
'* Input   : None                                                      
'* Output  : None                                                      
'* Notes   :                                                           
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:

' Define the Symbols used:
'===============================================================================
STATE21:
'===============================================================================
    StateInit()
    ' Transitional Input State.
    '##-INIT SECTION-###########################################################

    '##-END INIT-###############################################################
    StateInitEnd()
    ' Static State.
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    If F_SettingAlarm1 = 1 Then
        SaveE2PTimeDate1()
        F_SettingAlarm1 = 0
        F_SettingAlarmX = 0
        ' Only for testing.
        HRSLStrg(TXT72,9,0)   ' "SET ALARM"
        HRSOut " 1", CR,LF
        HRSLStrg(TXT20,0)   ' "Date = "
        HRSOut Dec2 VDay, "/", Dec2 VMonth, "/20", Dec2 VYear,CR,LF
        HRSLStrg(TXT21,0)   ' "Time = "            
        HRSOut Dec2 VHour, ":", Dec2 VMinute,CR,LF 

    ElseIf F_SettingAlarm2 = 1 Then
        SaveE2PTimeDate2()
        F_SettingAlarm2 = 0
        F_SettingAlarmX = 0
        ' Only for testing.
        HRSLStrg(TXT72,9,0)   ' "SET ALARM"
        HRSOut " 2", CR,LF
        HRSLStrg(TXT21,0)   ' "Time = "            
        HRSOut Dec2 VHour, ":", Dec2 VMinute,CR,LF 

    EndIf
    
    NextState(SM_ReadTimeDate)
       
':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(0)    ' Delay between execution of the MAIN module (adjust the delay)
'===============================================================================
    StateOut()
    'Transitional Output State.
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    HRSOut CR,LF
    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    StateOutEnd()    
'===============================================================================
    ReturnSM() 
'*******************************************************************************

                          
'*******************************************************************************
'* Name    : STATE22  [SM_Alarm]
'* Purpose : Clear the Alarm 1 or 2.                                                         
'* Input   : None                                                      
'* Output  : None                                                      
'* Notes   : Timeout 30 seconds.                                                          
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:

' Define the Symbols used:
'===============================================================================
STATE22:
'===============================================================================
    StateInit()
    ' Transitional Input State.
    '##-INIT SECTION-###########################################################
    SetBackLightTime(Max)   ' Set the Backlight to see the text on the LCD.
    LCD_Clear()
    PrintStrg(TXT69,1,1)    ' "---A L A R M----"
    PrintStrg(TXT71,2,1)    ' "  PRESS BUTTON  "
    StartFunction1()        ' Toggle the BUZZER every second
    '##-END INIT-###############################################################
    StateInitEnd()
    ' Static State.
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    Select AllButtons
        Case 1,2,3,4
            GoSub ClearAlarms_Sub
            NextState(SM_ReadTimeDate)

        Case Else
            ' Make a loop with the SM_ButtonsOFF Module.
            StartTimeOut(SM_ReadTimeDate,30) ' Start a Time Out for 30 seconds
            NextIndState(SM_ButtonsOFF,CallerState) ' Load the present state to return here.
    EndSelect
          
':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(0)    ' Delay between execution of the MAIN module (adjust the delay)
'===============================================================================
    StateOut()
    'Transitional Output State.
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    StateOutEnd()    
'===============================================================================
    ReturnSM() 
'===============================================================================
'* Name    : ClearAlarms_Sub                                              
'* Called From: SM_Alarm, CheckTimeOut()                                      
'* Purpose : Reset the Alarms                                                
'* Input   : None                                                              
'* Output  : None                                                              
'* Notes   :                           
'=============================================================================== 
ClearAlarms_Sub:
    AllButtons = 0
    If F_Alarm1 = 1 Then
        F_Alarm1 = 0
        EWrite EEADR1_Alarm1Avaible,[$FF]   ' Erase the Alarm1 (Not avaible)
        F_Alarm1Avaible = 0
        F_EnableAlarm1 = 0
    EndIf
    If F_Alarm2 = 1 Then
        F_Alarm2 = 0
        F_EnableAlarm2 = 0
    EndIf
    StopFunction1()
    Return
'*******************************************************************************

'*******************************************************************************
'* Name    : STATE23  [SM_SeeAlarm2]
'* Purpose : See the alarm2 values in the LCD.                                                         
'* Input   : None                                                      
'* Output  : None                                                      
'* Notes   :                                                           
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:

' Define the Symbols used:
'===============================================================================
STATE23:
'===============================================================================
    StateInit()
    ' Transitional Input State.
    '##-INIT SECTION-###########################################################

    '##-END INIT-###############################################################
    StateInitEnd()
    ' Static State.
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    SetBackLightTime(Max)                ' Set the Backlight 
    CheckAlarm2Avaible()
    LCD_Clear()
    If F_Alarm2Avaible = 1 Then
        RestoreE2PTimeDate2()
        PrintStrg(TXT75,1,1)            ' "DAYLY ALARM 2"
        Print At 2,1, "     ", Dec2 zHour, ":", Dec2 zMinute, "      " 
        F_EnableAlarm2 = 1
    Else
        PrintStrg(TXT75,1,1)            ' "DAYLY ALARM"
        PrintStrg(TXT76,2,1)            ' "NO ALARM"
    EndIf

    NextStateDelay(2000,SM_SeeAlarm1)
        
':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(0)    ' Delay between execution of the MAIN module (adjust the delay)
'===============================================================================
    StateOut()
    'Transitional Output State.
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    StateOutEnd()    
'===============================================================================
    ReturnSM() 
'*******************************************************************************

'*******************************************************************************
'* Name    : STATE24  [SM_SeeAlarm1]
'* Purpose : See the alarm1 values in the LCD.                                                       
'* Input   : None                                                      
'* Output  : None                                                      
'* Notes   :                                                           
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:

' Define the Symbols used:
'===============================================================================
STATE24:
'===============================================================================
    StateInit()
    ' Transitional Input State.
    '##-INIT SECTION-###########################################################

    '##-END INIT-###############################################################
    StateInitEnd()
    ' Static State.
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    CheckAlarm1Avaible()
    LCD_Clear()
    If F_Alarm1Avaible = 1 Then
        RestoreE2PTimeDate1()
        Print At 1,1, "AL1 "
        Print Dec2 zDay, "/", Dec2 zMonth, "/20", Dec2 zYear
        Print At 2,2, "     ", Dec2 zHour, ":", Dec2 zMinute, "      "
    Else
        PrintStrg(TXT76,1,1,12)        ' "NO ALARM"
        Print "1"
    EndIf

    NextStateDelay(2000,SM_ReadTimeDate)
          
':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(0)    ' Delay between execution of the MAIN module (adjust the delay)
'===============================================================================
    StateOut()
    'Transitional Output State.
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    StateOutEnd()    
'===============================================================================
    ReturnSM() 
'*******************************************************************************
                                 
'*******************************************************************************
'* Name    : STATE25  [SM_DisableAlarms]
'* Purpose : Disable the Alarms.                                                         
'* Input   : None                                                      
'* Output  : None                                                      
'* Notes   :                                                           
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:

' Define the Symbols used:
'===============================================================================
STATE25:
'===============================================================================
    StateInit()
    ' Transitional Input State.
    '##-INIT SECTION-###########################################################
    SetBackLightTime(Max)   ' Set the Backlight to see the text on the LCD.
    LCD_Clear()
    PrintStrg(TXT36,1,1)    ' "DISABLE   ALARMS"
    PrintStrg(TXT74,2,1)    ' "AL1=S1    AL2=S3"
    '##-END INIT-###############################################################
    StateInitEnd()
    ' Static State.
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    Select AllButtons
        Case 1
            EWrite EEADR1_Alarm1Avaible,[$FF]   ' Disable the Alarm1 (Not avaible)
            F_Alarm1Avaible = 0
            F_EnableAlarm1 = 0
            F_Alarm1 = 0
            PrintStrg(TXT37,2,1)                ' "ALARM1  DISABLED"
            NextStateDelay(1500,SM_ReadTimeDate)

        Case 3
            F_EnableAlarm2 = 0
            F_Alarm2 = 0
            PrintStrg(TXT38,2,1)                ' "ALARM2  DISABLED"
            NextStateDelay(1500,SM_ReadTimeDate)

        Case 2,4
            NextState(SM_ReadTimeDate)          ' Escape. Goto Read Time & Date.

        Case Else
            ' Make a loop with the SM_ButtonsOFF Module.
            NextIndState(SM_ButtonsOFF,CallerState) ' Load the present state to return here.
    EndSelect
               
    StartTimeOut(SM_ReadTimeDate,10) ' Start a Time Out for 10 seconds
    AllButtons = 0
          
':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(0)    ' Delay between execution of the MAIN module (adjust the delay)
'===============================================================================
    StateOut()
    'Transitional Output State.
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    StateOutEnd()    
'===============================================================================
    ReturnSM() 
'*******************************************************************************



'###############################################################################
'#### STATE MACHINE2 STARTS ####################################################
$ifdef _StatesMachine2_
' The Main code Start Here:
'*******************************************************************************
'* Name    : StateMachine2Start                                                *
'* Purpose : Clear the Watchdog If enabled.                                    *
'* Notes   :                                                                   *
'*******************************************************************************
StateMachine2Start:
    #ifdef WatchDog_Req
    Clrwdt
    #endif 
'*******************************************************************************
'* Name    : States Machine2 Scheduler                                                          
'* Purpose : Running the code of All modules.                   
'* Notes   : Do not forget update the State Label.                                            
'===============================================================================
    ' Running the Module2 Virtual Delay. The F_SM2VDelay flag must be clear by a Timer running
    ' in the interrupt handler.
    $ifdef _SM2VDelay_
    If F_SM2VDelay = 1 Then
        GoTo ReturnStateMachine2  '  Waiting delay for the States Machine1.            
    EndIf
    $endif
'===============================================================================
    ' Update the LABELS when you add a new States Machine Module.
    BranchL State2Index,[STATE100,STATE101]
    '---------------------------------------------------------------------------
    ' Debug section. StateIndex2 is OUT of RANGE.
    $ifdef _SM2VDelay_
    F_SM2VDelay = 0     ' Clear any VDelay2
    $endif
    $ifdef _EnableTerminal_
    _HRSOut "STATE MACHINE2 OUT OF RANGE: ", Dec State2Index,13,10
    DelayMS 1000
    $endif
    NextState2(0)
    ' ERROR in States Machine2 Variable Range. Reset the States Machine2. 
    GoTo ReturnStateMachine2  ' Equivalent of Reset On stack overflow. 
'#### STATE MACHINE END ########################################################
'###############################################################################
'*******************************************************************************
'* Name    : STATE100 [SM2_Init]       
'* Purpose :                                                       
'* Input   : None                                                      
'* Output  : None                                                        
'* Notes   : A not used Label is needed For the Scheduler.                                                            
'===============================================================================
STATE100:
    ' Nothing to do.
    ' Return to States Machine 1.
    ReturnSM1() 
'*******************************************************************************

'*******************************************************************************
'* Name    : STATE101 [SM2_PrintTimeDate]        
'* Purpose : Print messages to the LCD in Background and check alarms.                                                     
'* Input   : None                                                      
'* Output  : None                                                        
'* Notes   : DO jobs every second & every minute.                                                            
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:

' Define the Symbols used:

'===============================================================================
STATE101:
'===============================================================================
    StateInit2()
    ' Transitional Input State.
    '##-INIT SECTION-###########################################################

    '##-END INIT-###############################################################
    StateInit2End()
    ' Static State.
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    ' PRINT the Results to the LCD by the State Machine2 in BackGround.
    '---------------------------------------------------------------------------
    Print $FE,1     ' Clear the LCD display.
    '===========================================================================
    ' DO every Second.    
    ' Print the Date to the LCD.
    If ButtonFail > 0 Then                      ' Printing the last button failed.
        If ButtonFail = 1 Then
            PrintStrg(TXT77,1,1)                ' "Button 1 FAILS"
        ElseIf ButtonFail = 2 Then
            PrintStrg(TXT78,1,1)                ' "Button 2 FAILS"
        ElseIf ButtonFail = 3 Then
            PrintStrg(TXT79,1,1)                ' "Button 3 FAILS"
        ElseIf ButtonFail = 4 Then
            PrintStrg(TXT80,1,1)                ' "Button 4 FAILS"
        EndIf
    Else
        ' DO every Second.
        Print Dec2 RTC_Day, "/", Dec2 RTC_Month, "/20", Dec2 RTC_Year, " "
        '---------------------------------------------------------------------------
        ' DO every Second.       
        ' Check Alarm enable to print "ALARM" in the right side of LCD.
        If F_EnableAlarm1 = 1 Or F_EnableAlarm2 = 1 Then
            PrintStrg(TXT70,1,12,5)    ' "ALARM"
        Else
            Print Str RTC_MonthName\5  ' Print the Month Name To the LCD.
        EndIf
    EndIf
    '---------------------------------------------------------------------------
    ' DO every Second.
    ' Print the Time to the LCD.
    Cursor 2,1
    Print Dec2 RTC_Hour,":", Dec2 RTC_Minute, ":", Dec2 RTC_Second, " ", Str RTC_DayName\7
    '===========================================================================
    ' Do every Minute.
    If F_DOeveryMinute = 1 Then
        F_DOeveryMinute = 0
        '-----------------------------------------------------------------------
        ' Check the alarms clock
        ' Alarm1
        If F_Alarm1Avaible = 1 Then
            If F_EnableAlarm1 = 1 Then
                RestoreE2PTimeDate1()
                If RTC_Minute = zMinute Then
                    If RTC_Hour = zHour Then
                        If RTC_Day = zDay Then
                            If RTC_Month = zMonth Then
                                If RTC_Year = zYear Then
                                    F_Alarm1 = 1    ' Set an Alarm.
                                    F_AlarmX = 1    ' Set an general Alarm.
                                EndIf
                            EndIf
                        EndIf
                    EndIf
                EndIf
            EndIf
        EndIf
        ' Alarm2 (Dayly)
        If F_Alarm2Avaible = 1 Then
            If F_EnableAlarm2 = 1 Then
                RestoreE2PTimeDate2()
                If RTC_Minute = zMinute Then
                    If RTC_Hour = zHour Then
                        F_Alarm2 = 1    ' Set an Alarm.
                        F_AlarmX = 1    ' Set an general Alarm.
                    EndIf
                EndIf
            EndIf
        EndIf
        '-----------------------------------------------------------------------
        ' Do every Minute.
        ' Send Date & Time to the terminal.
        HRSLStrg(TXT20,0)   ' "Date = "
        HRSOut RTC_DayName, " ", Dec2 RTC_Day, "/", Dec2 RTC_Month, "/20", Dec2 RTC_Year,CR,LF
        HRSLStrg(TXT21,0)   ' "Time = "            
        HRSOut Dec2 RTC_Hour, ":", Dec2 RTC_Minute, ":", Dec2 RTC_Second,CR,LF 
        HRSOut CR,LF
        '-----------------------------------------------------------------------
    EndIf
    '===========================================================================
    NextState2(SM2_Init)    ' JOB finished in background. 

':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    SM2StartDelayMS(0)
'===============================================================================
    StateOut2(0)        ' Disable the Time Counter (NO code).
    'Transitional Output State.
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    StateOut2End()    
'===============================================================================
    ' Return to States Machine 1.
    ReturnSM1() 
'*******************************************************************************

'*******************************************************************************
'* Name    : STATE102 []        
'* Purpose : Print a message To the LCD in Background every minute.                                                      
'* Input   : None                                                      
'* Output  : None                                                        
'* Notes   :                                                           
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:

' Define the Symbols used:

'===============================================================================
STATE102:
'===============================================================================
'    StateInit2()
    ' Transitional Input State.
    '##-INIT SECTION-###########################################################

    '##-END INIT-###############################################################
'    StateInit2End()
    ' Static State.
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::



':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
'    SM2StartDelayMS(0)
'===============================================================================
'    StateOut2(0)        ' Disable the Time Counter (NO code).
    'Transitional Output State.
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
'    StateOut2End()    
'===============================================================================
    ' Return to States Machine 1.
'    ReturnSM1() 
'*******************************************************************************

'*******************************************************************************
'* Name    : STATE103 []        
'* Purpose :                                                       
'* Input   : None                                                      
'* Output  : None                                                        
'* Notes   : Increment a Value & GoTo Stop                                                            
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:

' Define the Symbols used:

'===============================================================================
STATE103:
'===============================================================================
'    StateInit2()
    ' Transitional Input State.
    '##-INIT SECTION-###########################################################

    '##-END INIT-###############################################################
'    StateInit2End()
    ' Static State.
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    

':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
'    SM2StartDelayMS(0)
'===============================================================================
'    StateOut2(0)        ' Disable the Time Counter (NO code).
    'Transitional Output State.
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
'    StateOut2End()    
'===============================================================================
    ' Return to States Machine 1.
'    ReturnSM1() 
'*******************************************************************************

'*******************************************************************************
'*******************************************************************************
' End of States Machine2
$endif  
'*******************************************************************************

'###############################################################################
'###############################################################################
'*******************************************************************************
'* Name    : STM_Strings04.Inc                                                 *
'* Purpose : CData Table for Strings or Datas                                  *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   : Write the Tables at top of memory syncronized with Erase Block    *
'*         : The Cdata table could have 1290 Bytyes                            *
'*         : Table of Strings of the program                                   *
'*******************************************************************************
'    ORG_EBlock(_MAXMEM - 1290)
'    Include "D:\MyIncFiles\STM_Strings06.Inc"
    Include "INC\STM_Strings06.Inc"
'*******************************************************************************
' Write some static data to the ID Locations.
' STM06V10
Asm
__IDLOCS   __IDLOC0,0x53
__IDLOCS   __IDLOC1,0x54
__IDLOCS   __IDLOC2,0x4D
__IDLOCS   __IDLOC3,0x30
__IDLOCS   __IDLOC4,0x36
__IDLOCS   __IDLOC5,0x56
__IDLOCS   __IDLOC6,0x31
__IDLOCS   __IDLOC7,0x30
EndAsm
'*******************************************************************************
'*** END OF FILE ***************************************************************
'*******************************************************************************

                
