'****************************************************************
'*  Name    : STMachine00.inc                                   *
'*  Author  : [Alberto Freixanet]                               *
'*  Notice  : Copyright (c) 2017 [AFreixanet 2017]              *
'*          : All Rights Reserved                               *
'*  Date    : 11/04/2017                                        *
'*  Version : 1.0                                               *
'*  Notes   : Library for the Static StateS Machine project     *
'*          : Development Board: AMICUS18                       *
'*          : Powered by the PDS compiler 3.5.9.3               *
'****************************************************************
'
' Corrected the PrintStrg(pLabel,pLine,pPos,pNbChars) Macro
' Added the PrintE2PStrg(pLabel,pLine,pPos,pNbChars)
'
'-------------------------------------------------------------------------------
'===============================================================================
' This program is free software, you can redistribute it and/or modify.
' The code is offered as-is and the author take any responsibility for its use.
' This program is distributed in the hope that it will be useful, but WITHOUT ANY
' WARRANTY. However, a mention of the author and compiler would be appreciated.
'
' Este programa es un software libre, puede redistribuirlo y/o modificarlo.
' Se entrega este cdigo tal como esta y el autor NO se hace responsable de
' su utilizacin. Este programa se distribuye con la esperanza de que sea til,
' pero SIN NINGUNA GARANTA. No obstante citar el autor y el compilador
' sera muy apreciado.

' Ce programme est un logiciel libre, vous pouvez le redistribuer et/ou modifier.
' Ce logiciel est offert tel qu'il est, et son auteur NE prend AUCUNE responsabilit
' pour son utilization. Ce programme est distribu dans l'espoir qu'il sera util,
' mais SANS AUCUNE GARANTIE. Cependant mentionner l'auteur et le compileur serait
' aprci.
'===============================================================================
'===============================================================================
$ifndef _STMachine_inc_
$define _STMachine_inc_

    GoTo _OverStateMachineLibrary 
'-------------------------------------------------------------------------------
    ' Check if the device is a PIC18.
    $if _core <> 16
        $error "This Template is for PIC18 devices ONLY!"
    $endif
'-------------------------------------------------------------------------------
' Checking some errors
    $ifndef _EnableTerminal_
        $ifdef _DebugStates_
        $undef _DebugStates_
        $endif
    $endif
'-------------------------------------------------------------------------------
' Checking some errors
    $ifndef _StatesMachine2_
        $ifdef _SM2VDelay_
        $undef _SM2VDelay_
        $endif
        $ifdef _TimeCounter2_
        $undef _TimeCounter2_
        $endif
    $endif        
'-------------------------------------------------------------------------------
    ' Check the language (English as default)
    $if !_defined(_English_) And !_defined(_Spanish_) And !_defined(_French_) 
        $define _English_
    $endif
'-------------------------------------------------------------------------------
    ' Check the HRSOut command.
    $ifndef _HRSOut
        $define _HRSOut HRSOut
    $endif
'*******************************************************************************
'* Name    :                                                                   *
'* Purpose : Declare All local variables                                       *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   :                                                                   *
'******************************************************************************* 
' Definition of local Bytes for Library/Subroutines code only
$ifndef _LVBS_Block1_
    $define _LVBS_Block1_
    Dim LVSByte1 As Byte System     ' Local Variable System Byte1
    Dim LVSByte2 As Byte System     ' Local Variable System Byte2
    Dim LVSByte3 As Byte System     ' Local Variable System Byte3
    Dim LVSByte4 As Byte System     ' Local Variable System Byte4
$endif

' Definition of local Bytes for Library/Subroutines code only
'$ifndef _LVBS_Block2_
'    $define _LVBS_Block2_
'    Dim LVSByte5 As Byte System     ' Local Variable System Byte5
'    Dim LVSByte6 As Byte System     ' Local Variable System Byte6
'    Dim LVSByte7 As Byte System     ' Local Variable System Byte7
'    Dim LVSByte8 As Byte System     ' Local Variable System Byte8
'$endif

' Definition of local Words For Library/Subroutines Code only
'$ifndef _LVWS_Block1_
'    $define _LVWS_Block1_
'    Dim LVSWord1 As Word System     ' Local Variable System Word1
'    Dim LVSWord2 As Word System     ' Local Variable System Word2
'$endif

' Definition of local Words for Library/Subroutines code
'$ifndef _LVWS_Block2_
'    $define _LVWS_Block2_
'    Dim LVSWord3 As Word System     ' Local Variable System Word1
'    Dim LVSWord4 As Word System     ' Local Variable System Word2
'$endif

' Definition of local DWords For Library/Subroutines Code only
'$ifndef _LVDWS_Block2_
'    $define _LVDWS_Block2_
'    Dim LVSDWord3 As Dword System     ' Local Variable System Word3
'    Dim LVSDWord4 As Dword System     ' Local Variable System Word4
'$endif

' Definition of local bits For Library/Subroutines Code only
'$ifndef _LVSBitS_Block1_
'    $define _LVSBitS_Block1_
'    Dim LVSBitsA As Byte System     ' Local Variable System byte
'$endif

'$ifndef _LVSBitS_Block2_
'    $define _LVSBitS_Block2_
'    Dim LVSBitsB As Byte System     ' Local Variable System byte
'$endif

$ifndef FSR0_Var
    $define FSR0_Var
	Dim FSR0 As FSR0L.Word         'Combine FSR0L\H into a single 16-bit register
$endif
$ifndef FSR1_Var
    $define FSR1_Var
	Dim FSR1 As FSR1L.Word         'Combine FSR0L\H into a single 16-bit register
$endif
$ifndef TBLPTR_Var
    $define TBLPTR_Var
	Dim TBLPTR As TBLPTRL.Word     'Combine TBLPTRL\H into a single 16-bit register
$endif
'*******************************************************************************
'* Name    :                                                                   *
'* Purpose : Declare All global variables for this library                     *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   :                                                                   *
'*******************************************************************************        
' Global variables for the States Machine (System)
    Dim StateIndex       As Byte System
    Dim StateIndexOld    As Byte System    
    Dim StateIndexFrom   As Byte System
    Dim ReturnStateIndex As Byte System
    Dim STHRS_NumberCR   As Byte System
    Dim IndirectState    As Byte System    
    $ifdef _BackLightSystem_
    Dim TimeOutGotoNextState As Byte System
    $endif

' Global Bits for the States Machine (System)
    Dim SM_Flags As Word System
    Dim F_ReturnState       As SM_Flags.0
    Dim F_EnableReturnState As SM_Flags.1
    Dim F_StateInitMade     As SM_Flags.2
    Dim F_StateOverride     As SM_Flags.3
    Dim F_SMVDelay          As SM_Flags.4
    Dim F_NextStateVDelay   As SM_Flags.5
    Dim F_EnableReturnIndState As SM_Flags.6
    Dim F_TimeOutSystemEnable  As SM_Flags.7
    Dim F_PWMBackLight         As SM_Flags.8 

' Timing Flags for States Machine1
    Dim SM_TimingFlags As Word System
    Dim F_Timer1mS     As SM_TimingFlags.0
    Dim F_Timer10mS    As SM_TimingFlags.1
    Dim F_Timer500mS   As SM_TimingFlags.2
    Dim F_Timer1S      As SM_TimingFlags.3
    Dim F_Delay1       As SM_TimingFlags.4
    Dim F_Delay2       As SM_TimingFlags.5
    Dim F_Delay3       As SM_TimingFlags.6
    Dim F_SMMain1mS    As SM_TimingFlags.7
    Dim F_TimeOutDelay As SM_TimingFlags.8

' Declare some SM1 counters.
    Dim Timer10mS As Byte System
    Dim Timer500mS As Byte System

    $ifdef _SMVDelay_
    Dim SMDelayCounter As Word System
    $endif
    $ifdef _TimeOutSystem_
    Dim TimeOutCounter As Word System
    $endif
    $ifdef _BackLightSystem_
    Dim PWMBLCounter      As Byte System 
    Dim PWMBLCounterValue As Byte System   
    $endif
    $ifdef _Delay1_
    Dim Delay1Counter As Word System
    $endif
    $ifdef _Delay2_
    Dim Delay2Counter As Word System
    $endif
    $ifdef _Delay3_
    Dim Delay3Counter As Word System
    $endif
'-------------------------------------------------------------------------------
$ifdef _StatesMachine2_
' Variables & Flags for States Machine2
    Dim State2Index    As Byte System
    Dim State2IndexOld As Byte System 
    Dim SM2_Flags      As Byte System
    Dim F_StateInit2Made     As SM2_Flags.0
    Dim F_SM2NextStateVDelay As SM2_Flags.1
    Dim F_SM2VDelay          As SM2_Flags.2

' Declare some SM2 counters.
    $ifdef _SM2VDelay_
    Dim SM2DelayCounter As Word System
    $endif
    $ifdef _TimeCounter2_
    Dim SM2TimeCounter As Byte System
    $endif

' Declare some Constants.

$endif
'===============================================================================


'###############################################################################
'*******************************************************************************
' Name    : States Machine Commands.
' Purpose : Make your life easier.
' Notes   :  
'*******************************************************************************
'* Name    : Change State                                                      *
'* Purpose : Define or Increment/Decrement a State Number                      *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   :                                                                   *
'******************************************************************************* 
' SM_State (State machine Variable)
$define SM_State StateIndex

' Goto the Next State
' There 3 modes of writing the command.
$define NextState(pNewState)     '
    $if pNewState = IncState     '
    Inc StateIndex               '
    $elseif pNewState = DecState '
    Dec StateIndex               '
    $else                        '
    StateIndex = pNewState       '
    $endif

'-------------------------------------------------------------------------------
' Goto the Next State & Override the ReturnState Function.
$define NextStateOverride(pNewState) '
    $if pNewState = IncState         '
    Inc StateIndex                   '
    $elseif pNewState = DecState     '
    Dec StateIndex                   '
    $else                            '
    StateIndex = pNewState           '
    $endif                           '
    $ifdef _CheckReturnStateM_       '
    F_StateOverride = 1              '
    $endif

'*******************************************************************************
'* Name    : NextStateReturn                                                   *
'* Purpose : Indirect addressing Module                                        *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   : Return State, Defines the path and starts the function.           *
'*******************************************************************************
$define NextStateReturn(pState1,PState2) '
    StateIndex = pState1                 '
    $ifdef _CheckReturnStateM_           '
    ReturnStateIndex = PState2           '
    F_ReturnState = 1                    '
    F_EnableReturnState = 1              '
    $endif

' Indirect state
$define NextIndState(pNewState1,pNewState2) '
    $if pNewState1 = IncState     '
    Inc StateIndex                '
    $elseif pNewState1 = DecState '
    Dec StateIndex                '
    $else                         '
    StateIndex = pNewState1       '
    $endif                        '
    F_EnableReturnIndState = 1    '
    IndirectState = pNewState2

' Indirect state with delay for the first destination pNewState1.
$define NextIndStateDelay(pDelay,pNewState1,pNewState2) '
    $ifdef _SMVDelay_             '
        $if pDelay > 0            '
        SMDelayCounter = pDelay   '
        F_NextStateVDelay = 1     '
        F_SMVDelay = 1            '
        $endif                    '
    $endif                        '
    $if pNewState1 = IncState     '
    Inc StateIndex                '
    $elseif pNewState1 = DecState '
    Dec StateIndex                '
    $else                         '
    StateIndex = pNewState1       '
    $endif                        '
    F_EnableReturnIndState = 1    '
    IndirectState = pNewState2

' Return the indirect Addressing with Delay.
$define ReturnIndState(pDelay)  '
    $ifdef _SMVDelay_           '
        $if pDelay > 0          '
        SMDelayCounter = pDelay '
        F_NextStateVDelay = 1   '
        F_SMVDelay = 1          '
        $endif                  '
    $endif                      '
    StateIndex = IndirectState

$define CallerState StateIndexOld

'-------------------------------------------------------------------------------
' Disable the Return State erasing flags parameters.
$define DisableReturnState()   '
    $ifdef _CheckReturnStateM_ '
    F_EnableReturnState = 0    '
    F_ReturnState = 0          '
    $endif

'-------------------------------------------------------------------------------
' Increment the State number and goto the following state: less code
$define IncState() Inc StateIndex

' Decrement the State number and goto the following state: less code
$define DecState() Dec StateIndex

'*******************************************************************************
'* Name    : StateInit/End header - Input Section                              *
'* Purpose : Initialize the Input Section                                      *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   : Using for debuging too when Terminal is connected                 *
'*******************************************************************************
$ifdef _EnableTerminal_
    $define StateInit()                '
    StateIndexOld = StateIndex         ' 
    $ifdef _SMVDelay_                  '
    F_NextStateVDelay = 0              '
    $endif                             '
    $ifdef _CheckReturnStateM_         '
    F_StateOverride = 0                '
    $endif                             '
    If F_StateInitMade = 0 Then        '
    $ifdef _DebugStates_               '
    GoSub DebugStateIn_Sub             '
    $else                              '
        $ifndef _DisableCRBeforeState_ '
        _HRSOut 13,10                  '
        $endif                         '
        F_StateInitMade = 1            '
    $endif

$ifdef _DebugStates_
DebugStateIn_Sub:
    F_StateInitMade = 1
    $ifndef _DisableCRBeforeState_
    _HRSOut 13,10
    $endif
    _HRSOut "ST",Dec StateIndex,"in",13,10
    _HRSOut "From State",Dec StateIndexFrom,13,10
    Return
$endif

$else
    $define StateInit()         '
    StateIndexOld = StateIndex  ' 
    $ifdef _SMVDelay_           '
    F_NextStateVDelay = 0       '
    $endif                      '
    $ifdef _CheckReturnStateM_  '
    F_StateOverride = 0         '
    $endif                      '
    If F_StateInitMade = 0 Then '
    F_StateInitMade = 1

$endif
'*******************************************************************************
'* Name    : StateInitEnd - Input Section                                      *
'* Purpose : Initialize the Input Section                                      *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   : Using for synchronize the Module code with 1mS Interrupt          *
'*           Synchronize the main code with interrupt every 1 mS.              *
'*******************************************************************************
' Synchronization at the first line of the module.
' StateInit End
$define StateInitEnd(pEnable) '
    EndIf                     '
    $ifdef _SynchronizeB1mS_  '
        $if pEnable = SyncOn  '
        F_SMMain1mS = 0       '
        While F_SMMain1mS = 0 '
        Wend                  '
        $endif                '
    $endif

'-------------------------------------------------------------------------------
' Synchronization Inside the module only.
$define Sync1mS()            '
    $ifdef _SynchronizeB1mS_ '
    F_SMMain1mS = 0          '
    While F_SMMain1mS = 0    '
    Wend                     '
    $endif
       
'*******************************************************************************
'* Name    : StateOut/End header - Output Section                              *
'* Purpose : Initialize the Output Section                                     *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   : Using for Delay and debuging too when Terminal is connected       *
'*******************************************************************************
' StateOut header In
$define StateOut() If StateIndex <> StateIndexOld Then 

'-------------------------------------------------------------------------------
' StateOut header End
$if _defined(_CheckReturnStateM_) Or _defined(_DebugStates_)
    $define StateOutEnd()   '
    GoSub DebugStateOut_Sub '
    EndIf

$else
    $define StateOutEnd() '
    F_StateInitMade = 0   '
    EndIf

$endif


$if _defined(_CheckReturnStateM_) Or _defined(_DebugStates_)
DebugStateOut_Sub:
    $ifdef _DebugStates_
    _HRSOut "Goto State",Dec StateIndex,13,10
        ' There is the First pass.
        $ifdef _CheckReturnStateM_
        If F_EnableReturnState = 1 Then
            _HRSOut "Return State",Dec ReturnStateIndex,13,10
        EndIf
        $endif
    _HRSOut "ST",Dec StateIndexOld,"Out",13,10
    StateIndexFrom = StateIndexOld
    $endif

    $ifdef _CheckReturnStateM_
    F_EnableReturnState = 0         ' First pass finished.
    $endif
 
    F_StateInitMade = 0
    Return
$endif
'*******************************************************************************
'* Name    : ReturnSM                                                          *
'* Purpose : Return to Scheduler                                               *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   : If state is used as subroutine. Goto other state.                 *
'*******************************************************************************
$ifdef _CheckReturnStateM_
    $define ReturnSM(pEnable) '
    $if pEnable = RSOn        '
    GoSub mNewReturnState_Sub '
    $endif                    '
    GoTo StateMachineStart
    
mNewReturnState_Sub:
    If F_StateOverride = 0 Then
        If F_ReturnState = 1 Then           ' Option Return State enabled.
            StateIndex = ReturnStateIndex   ' Change the StateMachine Index
            F_ReturnState = 0               ' Clear the flag for next use
        EndIf
    EndIf
    F_StateOverride = 0
    Return
$else
' Nothing to do.
$define ReturnSM() GoTo StateMachineStart

$endif
'===============================================================================
' State Machine definitions
  
    $define Goto_SMinit() GoTo StateMachineInit    

'*******************************************************************************
'* Name    : TimeOut System                                                    *
'* Purpose : Set a time out to read the Buttons or Keypad for the all Menus    *
'* Input   : TimeOut state, Delay in seconds                                   *
'* Output  : None                                                              *
'* Notes   : The TimeOut has its own delay                                     *
'******************************************************************************* 
$ifdef _TimeOutSystem_

$define StartTimeOut(pNewState,pDelay) '
    TimeOutGotoNextState = pNewState   '
    F_TimeOutSystemEnable = 1          '
    TimeOutCounter = pDelay*1000       '
    F_TimeOutDelay = 1

'-------------------------------------------------------------------------------
$define CheckTimeOut() GoSub CheckTimeOut_Sub

CheckTimeOut_Sub:
    If F_TimeOutSystemEnable = 1 Then
        If F_TimeOutDelay = 0 Then
            F_TimeOutSystemEnable = 0
            StateIndex = TimeOutGotoNextState       
        EndIf
    EndIf
    Return
'-------------------------------------------------------------------------------
    $define DisableTimeOut()  '
    F_TimeOutSystemEnable = 0 '
    F_TimeOutDelay = 0

'-------------------------------------------------------------------------------
$endif
'******************************************************************************* 

'===============================================================================
'-------------------------------------------------------------------------------
' END state machine.
'*******************************************************************************
'* Name    : NextStateDelay                                                    *
'* Purpose : Start a delay after to exit this module                           *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   : If depends of the destination module if delay is enabled          *
'*           Make delay for Modules running by interrupt: delay resolution 1mS *
'*******************************************************************************
' If the VDelay is not enabled, this commmand works like NextState(pNewState)
$define NextStateDelay(pDelay,pNewState) '
$ifdef _SMVDelay_                        '
    $if pDelay > 0                       '
    SMDelayCounter = pDelay              '
    F_NextStateVDelay = 1                '
    F_SMVDelay = 1                       '
    $endif                               '
    $if pNewState = IncState             '
    Inc StateIndex                       '
    $elseif pNewState = DecState         '
    Dec StateIndex                       '
    $else                                '
    StateIndex = pNewState               '
    $endif                               '
$endif

' If the NextStateDelay(pDelay,pNewState) has not been activated then this delay can run.
' Because F_NextStateVDelay = 0.
$define StartDelayMS(pDelay)                   '
    $ifdef _SMVDelay_                          '
        $if pDelay > 0                         '
        If F_NextStateVDelay = 0 Then          '
            If StateIndex = StateIndexOld Then '
                SMDelayCounter = pDelay        '
                F_SMVDelay = 1                 '
            EndIf                              '
        EndIf                                  '
        $endif                                 '
    $endif

'*******************************************************************************
'* Name    : StartUserDelay1                                                   *
'* Purpose : Delay number 1 Free to use by the user.                           *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   : Make delay for Modules running by interrupt: delay resolution 1mS *
'*           Another type of VDelay for User function ONLY                     *
'*******************************************************************************
$ifdef _Delay1_
$define StartUserDelay1(pDelay) '
    $if pDelay > 0              '
        Delay1Counter = pDelay  '
        F_Delay1 = 1            '
    $endif

$endif
'*******************************************************************************
'* Name    : StartUserDelay2                                                   *
'* Purpose : Delay number 2 Free to use by the user.                           *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   : Make delay for Modules running by interrupt: delay resolution 1mS *
'*           Another type of VDelay for User function ONLY                     *
'*******************************************************************************
$ifdef _Delay2_
$define StartUserDelay2(pDelay) '
    $if pDelay > 0              '
        Delay2Counter = pDelay  '
        F_Delay2 = 1            '
    $endif

$endif
'*******************************************************************************
'* Name    : StartUserDelay3                                                   *
'* Purpose : Delay number 3 Free to use by the user.                           *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   : Make delay for Modules running by interrupt: delay resolution 1mS *
'*           Another type of VDelay for User function ONLY                     *
'*******************************************************************************
$ifdef _Delay3_
$define StartUserDelay3(pDelay) '
    $if pDelay > 0              '
        Delay3Counter = pDelay  '
        F_Delay3 = 1            '
    $endif

$endif
'###############################################################################
'*******************************************************************************
'* Name    : 2nd STATES MACHINE System                                         *
'* Purpose : Running another States Machine in Background                      *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   :                                                                   *
'*******************************************************************************

' SM_State (State machine2 Variable)
$define SM2_State State2Index

' The code structure for the States Machines2 are simple and runs fast.
' Goto the Next State2
$define NextState2(pNewState)        '
    $ifdef _StatesMachine2_          '
        $if pNewState = IncState     '
        Inc State2Index              '
        $elseif pNewState = DecState '
        Dec State2Index              '
        $else                        '
        State2Index = pNewState      '
        $endif                       '
    $endif

' Increment the State number and goto the following state:
$define IncState2() Inc State2Index

' Decrement the State number and goto the previously state:
$define DecState2() Dec State2Index

' Return to States Machine Scheduler.
$define ReturnSM1() GoTo ReturnStateMachine2

'*******************************************************************************
'* Name    : State2Init header - Input Section                                 *
'* Purpose : Initialize the Input Section                                      *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   : Using for debuging too when Terminal is connected                 *
'*******************************************************************************
$define StateInit2()             '
    State2IndexOld = State2Index '
    $ifdef _SM2VDelay_           '
    F_SM2NextStateVDelay = 0     '
    $endif                       '
    If F_StateInit2Made = 0 Then
    
'-------------------------------------------------------------------------------
'$define StateInit2End()
' Clear the Times Counter too.
$define StateInit2End()   '
    $ifdef _TimeCounter2_ '
    SM2TimeCounter = 0    '
    $endif                '
    F_StateInit2Made = 1  '
    EndIf

'*******************************************************************************
'* Name    : System Virtual Delay for States Machine2                          *
'* Purpose : Manage the F_SM2VDelay                                            *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   : Make a delay running by interrupt: delay resolution 1mS.          *
'*           F_SM2NextStateVDelay = 1 avoid that the SM2StartDelayMS could     *
'*           erase the Delay values.                                           *
'*******************************************************************************
$define SM2NextStateDelay(pDelay,pNewState) '
$ifdef _SM2VDelay_                          '
    $if pDelay > 0                          '
    SM2DelayCounter = pDelay                '
    F_SM2NextStateVDelay = 1                '
    F_SM2VDelay = 1                         '
    $endif                                  '
    $if pNewState = IncState                '
    Inc State2Index                         '
    $elseif pNewState = DecState            '
    Dec State2Index                         '
    $else                                   '
    State2Index = pNewState                 '
    $endif                                  '
$endif

$define SM2StartDelayMS(pDelay)              '
$ifdef _SM2VDelay_                           '
    $if pDelay > 0                           '
    If F_SM2NextStateVDelay = 0 Then         '
        If State2Index = State2IndexOld Then '
            SM2DelayCounter = pDelay         '
            F_SM2VDelay = 1                  '
        EndIf                                '
    EndIf                                    '
    $endif                                   '
$endif

'*******************************************************************************
'* Name    : StateOut2 header - Output Section                                  *
'* Purpose : Initialize the Output Section                                     *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   : Using for Delay and debuging too when Terminal is connected       *
'*******************************************************************************
' StateOut header in
$define StateOut2(pCount, pIndex)   '
$ifdef _TimeCounter2_               '
    $if pCount > 0                  '
    Inc SM2TimeCounter              '
    If SM2TimeCounter = pCount Then '
        $if pIndex > 0              '
        State2Index = pIndex        '
        $else                       '
        State2Index = 0             '
        $endif                      '
    EndIf                           '
    $endif                          '
$endif                              '
    If State2Index <> State2IndexOld Then

'-------------------------------------------------------------------------------
' StateOut header End
$define StateOut2End()   '
    F_StateInit2Made = 0 '
    EndIf 

'===============================================================================



'*******************************************************************************
'* Name    : SM_CleanUART                                                      *
'* Purpose : Clear the generic UART                                            *
'* Input   : none                                                              *
'* Output  : none                                                              *
'* Note    :                                                                   *
'*******************************************************************************
$if _HRSOut = HRSOut
$define SM_CleanUART()   '
    Clear RCSTABits_CREN ' 
    Set RCSTABits_CREN   ' 
    WREG = RCREG

$endif

$if _HRSOut = HRSOut1
$define SM_CleanUART()    '
    Clear RC1STABits_CREN ' 
    Set RC1STABits_CREN   ' 
    WREG = RC1REG

$endif

$if _HRSOut = HRSOut2
$define SM_CleanUART()    '
    Clear RC2STABits_CREN ' 
    Set RC2STABits_CREN   ' 
    WREG = RC2REG

$endif

$if _HRSOut = HRSOut3
$define SM_CleanUART()    '
    Clear RC3STABits_CREN ' 
    Set RC3STABits_CREN   ' 
    WREG = RC3REG

$endif

$if _HRSOut = HRSOut4
$define SM_CleanUART()    '
    Clear RC4STABits_CREN ' 
    Set RC4STABits_CREN   ' 
    WREG = RC4REG

$endif

$if _HRSOut = HRSOut5
$define SM_CleanUART()    '
    Clear RC5STABits_CREN ' 
    Set RC5STABits_CREN   ' 
    WREG = RC5REG  

$endif    
 
'###############################################################################
'*******************************************************************************
'* Name    : Timer2 COnfiguration                                              *
'* Purpose : Generate a 1mS timing by Interrupt                                *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   : Only for the States Machine Interrupts (Every 1mS)                *
'******************************************************************************* 
' Same structure for 18F2xk22 & 18F2xk20 & 18F452 series.
$define InitStateMachine() GoSub Init_Timer2_Sub

Init_Timer2_Sub:
    $if _xtal = 16
        ' TMR2 8Bits counter, Postscaler 1/4, Prescaler 1/4, Osc Off, Clock Xtal/4 (Xtal: Xtal 4 + PLL = 16 Mhz) or (Xtal: Xtal 16Mhz)
        ' For Timer2 interrupt every 1,00 mS 
        $define _T2Postscaler 3
        $define _T2Prescaler 1
        $define _PR2Value 250
    $endif
    $if _xtal = 20
        ' TMR2 8Bits counter, Postscaler 1/5, Prescaler 1/4, Osc Off, Clock Xtal/4 (Xtal: Xtal 20 Mhz)
        ' For Timer2 interrupt every 1,00 mS 
        $define _T2Postscaler 4
        $define _T2Prescaler 1
        $define _PR2Value 250
    $endif
    $if _xtal = 40
        ' TMR2 8Bits counter, Postscaler 1/10, Prescaler 1/4, Osc Off, Clock Xtal/4 (Xtal: Xtal 20 Mhz) or (Xtal: Xtal 10 Mhz + PLL)
        ' For Timer2 interrupt every 1,00 mS 
        $define _T2Postscaler 9
        $define _T2Prescaler 1
        $define _PR2Value 250
    $endif
    $if _xtal = 64
        ' TMR2 8Bits counter, Postscaler 1/4, Prescaler 1/16, Osc Off, Clock Xtal/4 (Xtal: Xtal 16 + PLL = 64Mhz)
        ' For Timer2 interrupt every 1,00 mS
        $define _T2Postscaler 3
        $define _T2Prescaler 2
        $define _PR2Value 250
    $endif

    ' Updated for Xtal = 80 Mhz
    $if _xtal = 80
        ' TMR2 8Bits counter, Postscaler 1/5, Prescaler 1/16, Osc Off, Clock Xtal/4 (Xtal: Xtal 20 + PLL = 80Mhz)
        ' For Timer2 interrupt every 1,00 mS
        $define _T2Postscaler 4
        $define _T2Prescaler 2
        $define _PR2Value 250
    $endif       
    '---------------------------------------------------------------------------
    TBLPTRU = 0
    PIE1 = 0
    PIR1 = 0
    PIE2 = 0
    IPR1 = 0    
    EECON1 = 0
    '---------------------------------------------------------------------------
    ' Configuration of TIMER2 for Interrupts System for State Machine.
    T2CON = 0
    T2CON = ((_T2Postscaler & 15) << 3) | (_T2Prescaler & 3)
    PR2 = _PR2Value
    PIR1Bits_TMR2IF = 0
    T2CONBits_TMR2ON = 1    ' Starts the Timer2. (T2CON)
    PIE1Bits_TMR2IE = 1     ' Enable the Timer2 interrupt 
    RCON = 0                ' RCON register. Enable only the High Interrupts
    IPR1Bits_TMR2IP = 1     ' TMR2 to PR2 Match Interrupt Priority bit. 1 = High priority
    INTCON = %11000000      ' Enable All interrupts. 
    '---------------------------------------------------------------------------    
    ' Configuration of TIMER0 to use the PORTA.4 pin for Interrupt.
    ' bit7: 0 = Stops Timer0
    ' bit6: 1 = Timer0 is configured as an 8-bit timer/counter
    ' bit5: 1 = Transition on T0CKI pin
    ' bit4: 1 = Increment on high-to-low transition on T0CKI pin
    ' bit3: 1 = TImer0 prescaler is NOT assigned. Timer0 clock input bypasses prescaler.
    ' bit2: 0
    ' bit1: 0
    ' bit0: 0
    INTCONBits_TMR0IE = 0
    INTCONBits_TMR0IF = 0
    $ifdef _SMEnableTimer0_
    T0CON = %01111000
    INTCON2Bits_TMR0IP = 1  ' TMR0 Overflow Interrupt Priority bit. 1 = High priority
    TMR0L = 255
    Nop
    TMR0H = 0
    INTCONBits_TMR0IE = 1   ' Enable TMR0 interrupt.
    T0CONBits_TMR0ON = 1    ' Enable Timer0 to run.
    $endif
    '---------------------------------------------------------------------------
    ' Init the SM variables
    StateIndex = 0
    StateIndexOld = 0   
    StateIndexFrom = 0
    ReturnStateIndex = 0
    $ifdef _StatesMachine2_
    State2Index = 0
    State2IndexOld = 0
    SM2_Flags = 0
    $endif    
    SM_Flags = 0
    SM_TimingFlags = 0
    Timer10mS = 0
    Timer500mS = 0
    SM_CleanUART()
    '---------------------------------------------------------------------------
    Return
'*******************************************************************************
'* Name    : InkeyX                                                            *
'* Purpose : Read a 4x4, 4x3 Or 4x2 KEYPAD                                     *
'* Input   : EMI filter Delay (ReadDelay (Byte))                               *
'* Output  : Return_Var (Byte)                                                 *
'* Syntax  : Var1 = InkeyX(ReadDelay)                                          *
'* Notes   : This command is usefull for EMI compliance                        *
'*         : ReadDelay: must to be a Number8 (5 to 255) uS                     *
'*******************************************************************************
' Define the Global variables used :
$if _defined(_4x4KEYPAD_) Or _defined(_4x3KEYPAD_) Or _defined(_4x2KEYPAD_)
' Define the Local variables used 
    Dim KPInkeyDelayX As LVSByte1
    Dim KPColumnData  As LVSByte2
    Dim KPRead_PortX  As LVSByte3
    Dim KPScanResult  As LVSByte4

' Define the Symbols used:
    $ifdef _4x4KEYPAD_
    Symbol SetColumn0 = %11110111   ' For 4x4 Keypad.
    $endif
    $ifdef _4x3KEYPAD_
    Symbol SetColumn0 = %11101111   ' For 4x3 Keypad. 
    $endif
    $ifdef _4x2KEYPAD_
    Symbol SetColumn0 = %11011111   ' For 4x2 Keypad.
    $endif
'-------------------------------------------------------------------------------
$define InkeyX(pReadDelay) _mInkeyX pReadDelay 

_mInkeyX Macro- pReadDelay  
    #if (Prm_Count > 1)
	   #error "_mInkeyX - Too many parameters"
       Exitm
    #else
        #if (Prm_Count < 1)
            #error "_mInkeyX - Too few parameters"
            Exitm
        #else
            #if (Prm_1 != Num8)
                #error "_mInkeyX - _ReadDelay(Param1) Should be a number8"
                Exitm
            #endif
            ' Check the _ReadDelay value
            #if (pReadDelay < 5)
                KPInkeyDelayX = 5                     ' If Read Delay < 5 this line is compiled.
            #else
                Num_Byte pReadDelay, KPInkeyDelayX    ' If Read Delay >= 5 this line is compiled. 
            #endif                
            GoSub _Scan_Keypad_Sub                  ' Check the Keypad.
        #endif
    #endif
    #if (_mInkeyX_RETURN != 1)
        #error "_mInkeyX - Mandatory return parameter misssing"
        Exitm
    #else
        #if (Return_Type != Byte)
            #error "_mInkeyX - Return variable should be a BYTE variable"
            Exitm
        #endif
        Byte_Byte KPScanResult, Return_Var
    #endif
Endm
'-------------------------------------------------------------------------------
$ifdef _4x4KEYPAD_
#ifMacro- _mInkeyX
_Scan_Keypad_Sub:
' 4x4 KEYPAD
' Config the Keypad bits of the PORTX:
' RX0 to RX3 = outputs, RX4 to RX7 = inputs 
    Set_Bank __KEYPAD_PORT
    Asm
    Movlw 11110000b                     ; %11110000 High nible for inputs, Low nible for outputs.
    Movwf (__KEYPAD_PORT + 0x12),0      ; Configure TRISX register with the correct half of the port to output (+18)
    EndAsm
    ' If PORTB is declared, connect the pullup resistors.
    ' The pull-ups could be disabled.
$ifndef _Disable_Keypad_Pullups_
    #if (__KEYPAD_PORT == PORTB)        ' Only if PORTB is declared
        INTCON2.7 = 0                   ' Pull-ups resistors are enabled only if PORTB is declared.
        $ifdef _WPUB
        WPUB = $F0                      ' Not All PIC18 have a WPUB register. (config high nibble)
        $endif
    #endif
$else
    #if (__KEYPAD_PORT == PORTB)        ' Only if PORTB is declared
        INTCON2.7 = 1                   ' Pull-ups resistors are disabled only if PORTB is declared.
    #endif    
$endif
' Configuration the SLRCON register to reduce EMI output for the keypad PORT.
$ifdef _SLRCON
    #if (__KEYPAD_PORT == PORTA)        ' If keypad connected to PORTA.
    SLRCON.0 = 1                        ' All outputs on PORTB slew at a limited rate. 
    #endif

    #if (__KEYPAD_PORT == PORTB)        ' If keypad connected to PORTB.
    SLRCON.1 = 1                        ' All outputs on PORTA slew at a limited rate. 
    #endif

    $ifdef _PORTC
    #if (__KEYPAD_PORT == PORTC)        ' If keypad connected to PORTC.
    SLRCON.2 = 1                        ' All outputs on PORTC slew at a limited rate. 
    #endif
    $endif

    $ifdef _PORTD
    #if (__KEYPAD_PORT == PORTD)        ' If keypad connected to PORTD.
    SLRCON.3 = 1                        ' All outputs on PORTD slew at a limited rate. 
    #endif
    $endif

    $ifdef _PORTE
    #if (__KEYPAD_PORT == PORTE)        ' If keypad connected to PORTE.
    SLRCON.4 = 1                        ' All outputs on PORTE slew at a limited rate. 
    #endif
    $endif
$endif

' Scan columns routine
' It is a good practice to insert some 1K resistors to the outputs of the PIC to Keyboard.                  
' Using PORT KEYPAD Low nibble for scanning output and High nibble for Inputs.
'                                           ' Column0    Column1    Column2    Column3
    KPColumnData = SetColumn0               ' %11110111, %01111011, %00111101, %00011110
    KPScanResult = 16                       ' Init the Scan result (keypad 4x4).
    Repeat
        Set_Bank KPColumnData
        Asm
        Movf  KPColumnData,W,0              ; Load the value of the column
        Movwf (__KEYPAD_PORT + 0x09),0      ; Write SetColumn0/1/2/3 to LATX KEYPAD register
        EndAsm
        ' The port has been loaded with the bit column pulse.

        ' The code is running very fast to read some Keypad.
        ' With very high crystal > 10Mhz, sometimes keys could not be read with parasitic
        ' capacitance and long wiring. Also this code runs more faster than the original
        ' inkey command, some reading errors would be occur without a delay.
        ' Then a little programmable delay resolves the problem and allows using RC filters 
        ' inserted in keypad lines to reduce EMI. 
        ' An empiric formula would be: KPInkeyDelayX = (T1+T2)x3 in uS
        ' If R1,R2= 1K and C1,C2= 2,2nF: (2,2x10-6 + 2,2x10-6)x3 = 13,2uS + (Slew Rate Port)
        ' Then round the value: then KPInkeyDelayX = 13 uS  
        DelayUS KPInkeyDelayX                       

        ' Reading the input port to a byte buffer.
        KPRead_PortX = __KEYPAD_PORT
                                               
        ' Now Check All ROWs, reading the bits of the buffer.
        KPRead_PortX.0 = 1    
        If KPRead_PortX.7 = 0 Then ReadPortOUT0   ' Check for RX7 = 0 Keydown
        Dec KPScanResult
        If KPRead_PortX.6 = 0 Then ReadPortOUT0   ' Check for RX6 = 0 Keydown
        Dec KPScanResult
        If KPRead_PortX.5 = 0 Then ReadPortOUT0   ' Check for RX5 = 0 Keydown 
        Dec KPScanResult
        If KPRead_PortX.4 = 0 Then ReadPortOUT0   ' Check for RX4 = 0 Keydown
        Dec KPScanResult
        KPRead_PortX.0 = 0
ReadPortOUT0:
        If KPRead_PortX.0 = 1 Then Break  ' Exit the loop. If key pressed then return. 
        ' If key NO pressed, scan again moving the column to right (the bit 0).
        KPColumnData = KPColumnData >> 1    ' RB3        RB2        RB1        RB0        Final step
'                                       ' %11110111, %01111011, %00111101, %00011110, %00001111.
    Until KPColumnData = %00001111        ' All columns have been checked?    
    ' If there is NO KEY pressed the variable KPRead_PortX = 0.
    ' If there is a KEY pressed the variable KPRead_PortX = X, a value depending of the KEY pressed.

    ' This code keep the same frecuency pulses and width in the keypad lines (avoid more EMI variations).
    Set_Bank __KEYPAD_PORT
    Asm
    Movlw  0x0F                         ; Set All columns high.
    Movwf (__KEYPAD_PORT + 0x09),0      ; Write to LATX KEYPAD register.
    EndAsm
    ' All keys have been read, exit the scan routine.
    Return
#endIfMacro-
$endif
'-------------------------------------------------------------------------------
$ifdef _4x3KEYPAD_
#ifMacro- _mInkeyX
_Scan_Keypad_Sub:
' 4x3 KEYPAD
' Config the Keypad PORTX (TRISX)
' RX1 to RX4 = outputs, RX5 to RX7 = inputs 
    Set_Bank __KEYPAD_PORT
    Asm           
    Movlw 11100001b                     ; %11100001, low nible for outputs, RX1,RX2,RX3,RX4
    Andwf (__KEYPAD_PORT + 0x12),F,0    ; AND with TRISX
    Movlw 11100000b                     ; %11100000, 3 high nible for inpputs RX5,RX6,RX7
    Iorwf (__KEYPAD_PORT + 0x12),F,0    ; OR with TRISX. Don't modify the PORTB.0 bit.
    EndAsm

    ' If PORTB is declared, the pull-up resistors are connected.
    ' The pull-ups resistors could be disabled.
$ifndef _Disable_Keypad_Pullups_
    #if (__KEYPAD_PORT == PORTB)        ' Only if PORTB is declared
        INTCON2.7 = 0                   ' Pull-ups resistors are enabled only if PORTB is declared.
        $ifdef _WPUB
        WPUB = %11100000                ' Not All PIC18 have a WPUB register. (config high nibble)
        $endif
    #endif
$else
    #if (__KEYPAD_PORT == PORTB)        ' Only if PORTB is declared
        INTCON2.7 = 1                   ' Pull-ups resistors are disabled only if PORTB is declared.
        $ifdef _WPUB
        WPUB = 0                        ' NO Pull-ups bits. Not All PIC18 have a WPUB register.
        $endif    
    #endif    
$endif
' Configuration the SLRCON register to reduce EMI output for the keypad PORT.
$ifdef _SLRCON
    #if (__KEYPAD_PORT == PORTA)        ' If keypad connected to PORTA.
    SLRCON.0 = 1                        ' All outputs on PORTB slew at a limited rate. 
    #endif

    #if (__KEYPAD_PORT == PORTB)        ' If keypad connected to PORTB.
    SLRCON.1 = 1                        ' All outputs on PORTA slew at a limited rate. 
    #endif

    $ifdef _PORTC
    #if (__KEYPAD_PORT == PORTC)        ' If keypad connected to PORTC.
    SLRCON.2 = 1                        ' All outputs on PORTC slew at a limited rate. 
    #endif
    $endif
    
    $ifdef _PORTD
    #if (__KEYPAD_PORT == PORTD)        ' If keypad connected to PORTD.
    SLRCON.3 = 1                        ' All outputs on PORTD slew at a limited rate. 
    #endif
    $endif
    
    $ifdef _PORTE
    #if (__KEYPAD_PORT == PORTE)        ' If keypad connected to PORTE.
    SLRCON.4 = 1                        ' All outputs on PORTE slew at a limited rate. 
    #endif
    $endif    
$endif

' Scan columns routine
' It is a good practice to insert some 1K resistors to the outputs of the PIC to Keyboard.                  
' Using PORT KEYPAD LOW nibble for scan and HIGH nibble for receive.
    KPScanResult = 12                       ' Init the Scan result variable (12 keys)
    KPColumnData = SetColumn0                ' %11101111, %11110111, %11111011, %11111101
    Repeat
        Asm
        Banksel __KEYPAD_PORT
        Movlw 00011110b                     ; %00011110, Clear the old data in LATX, All bits to high.
        Iorwf (__KEYPAD_PORT + 0x09),F,0    ; Don't modify the lower bit for user. (__KEYPAD_PORT.0)
        Banksel KPColumnData
        Movf  KPColumnData,W,0                ; Load the value of the column: %11101111, %01110111, %00111011, %00011101, %00001110.
        Banksel __KEYPAD_PORT
        Andwf (__KEYPAD_PORT + 0x09),F,0    ; Write 0 in Column 0/1/2/3 to LATX KEYPAD register
        EndAsm
        ' The port has been loaded with the bit column pulse.

        ' The code is running very fast to read some Keypad.
        ' With very high crystal > 10Mhz, sometimes keys could not be read with parasitic
        ' capacitance and long wiring. Also this code runs more faster than the original
        ' inkey command, some reading errors would be occur without a delay.
        ' Then a little programmable delay resolves the problem and allows using RC filters 
        ' inserted in keypad lines to reduce EMI. 
        ' An empiric formula would be: KPInkeyDelayX = (T1+T2)x3 in uS
        ' Example:
        ' If R1,R2= 1K and C1,C2= 2,2nF: (2,2x10-6 + 2,2x10-6)x3 = 13,2uS + (Slew Rate Port)
        ' Round the value: then KPInkeyDelayX = 13 uS  
        DelayUS KPInkeyDelayX
        
        ' Load a buffer with the PORTX input.
        KPRead_PortX = __KEYPAD_PORT
                                               
        ' Now Check All ROWs
        KPRead_PortX.0 = 1    
        If KPRead_PortX.7 = 0 Then ReadPortOUT0   ' Check for RX7 = 0 Keydown
        Dec KPScanResult
        If KPRead_PortX.6 = 0 Then ReadPortOUT0   ' Check for RX6 = 0 Keydown 
        Dec KPScanResult
        If KPRead_PortX.5 = 0 Then ReadPortOUT0   ' Check for RX5 = 0 Keydown
        Dec KPScanResult
        KPRead_PortX.0 = 0
ReadPortOUT0:
        If KPRead_PortX.0 = 1 Then Break          ' If key pressed then return.
        ' If key NO pressed, scan again moving the column to right (Bit4 to Bit1).
        ' Rotate the KPColumnData bits to the right.
'                                       ' RB4        RB3        RB2        RB1        Final step 
'                                       ' %11101111, %01110111, %00111011, %00011101, %00001110.
        KPColumnData = KPColumnData >> 1    '
    Until KPColumnData = %00001110        ' All columns have been checked?
 
    ' This code keep the same frecuency pulses and width in the keypad lines.
    Set_Bank __KEYPAD_PORT
    Asm
    Movlw 00011110b                     ; %00011110, Clear the old data in LATX, All bits to high.
    Iorwf (__KEYPAD_PORT + 0x09),F,0    ; Write to LATX. Don't modify the lower bit.
    EndAsm
    Return
#endIfMacro-
$endif
'-------------------------------------------------------------------------------
$ifdef _4x2KEYPAD_
#ifMacro- _mInkeyX
_Scan_Keypad_Sub:
' 4x2 KEYPAD
' Config the Keypad PORTX in every scanning.
' RX0 to RX3 = outputs, RX4 to RX5 = inputs 
    Set_Bank __KEYPAD_PORT
    Asm           
    Movlw 11000011b                     ; %11000011, 4 pins RX2,RX3,RX4,RX5 for outputs,
    Andwf (__KEYPAD_PORT + 0x12),F,0
    Movlw 11000000b                     ; %11000000, 2 pins RX6,RX7 for inputs 
    Iorwf (__KEYPAD_PORT + 0x12),F,0
    EndAsm
    ' If PORTB is declared, connect the pullup resistors.
    ' The pull-ups resistors could be disabled, see main code.
$ifndef _Disable_Keypad_Pullups_
    #if (__KEYPAD_PORT == PORTB)        ' Only if PORTB is declared
        INTCON2.7 = 0                   ' Pull-ups resistors are enabled only if PORTB is declared.
        $ifdef _WPUB
        WPUB = %11000000                ' Config the input bits. Not All PIC18 have a WPUB register.
        $endif
    #endif
$else
    #if (__KEYPAD_PORT == PORTB)        ' Only if PORTB is declared
        INTCON2.7 = 1                   ' Pull-ups resistors are disabled only if PORTB is declared.
        '$ifdef _WPUB
        'WPUB = WPUB & %00111111         ' Config the Pull-ups bits. Not All PIC18 have a WPUB register.
        '$endif
    #endif    
$endif
' Configuration of the SLRCON register to reduce EMI output for the keypad PORT.
$ifdef _SLRCON
    #if (__KEYPAD_PORT == PORTA)        ' If keypad connected to PORTA.
    SLRCON.0 = 1                        ' All outputs on PORTB slew at a limited rate. 
    #endif

    #if (__KEYPAD_PORT == PORTB)        ' If keypad connected to PORTB.
    SLRCON.1 = 1                        ' All outputs on PORTA slew at a limited rate. 
    #endif

    $ifdef _PORTC
    #if (__KEYPAD_PORT == PORTC)        ' If keypad connected to PORTC.
    SLRCON.2 = 1                        ' All outputs on PORTC slew at a limited rate. 
    #endif
    $endif
    
    $ifdef _PORTD
    #if (__KEYPAD_PORT == PORTD)        ' If keypad connected to PORTD.
    SLRCON.3 = 1                        ' All outputs on PORTD slew at a limited rate. 
    #endif
    $endif

    $ifdef _PORTE
    #if (__KEYPAD_PORT == PORTE)        ' If keypad connected to PORTE.
    SLRCON.4 = 1                        ' All outputs on PORTE slew at a limited rate. 
    #endif
    $endif    
$endif

' Scan columns routine
' It is a good practice to insert some 1K resistors to the outputs of the PIC to Keyboard.                  
    KPScanResult = 8                        ' Init the Scan result variable (8 keys to scan).
    KPColumnData = SetColumn0                ' %11011111, load the first column to scan.
    Repeat
        ' The bits PORTX.0 and PORTX.1 are reserved for the user.
        Asm
        Banksel __KEYPAD_PORT
        Movlw 00111100b                     ; Clear the old data in LATX, All bits to high.
        Iorwf (__KEYPAD_PORT + 0x09),F,0    ; Don't modify the low nibble (2 bits).
        Banksel KPColumnData
        Movf  KPColumnData,W,0                ; Load the value of the column
        Banksel __KEYPAD_PORT
        Andwf (__KEYPAD_PORT + 0x09),F,0    ; Write 0 in Column 0/1/2/3 to LATX KEYPAD register
        EndAsm
        ' The port has been loaded with the bit column pulse.
    
        ' The code is running very fast to read some Keypad.
        ' With very high crystal > 10Mhz, sometimes keys could not be read with parasitic
        ' capacitance and long wiring. Also this code runs more faster than the original
        ' inkey command, some reading errors would be occur without a delay.
        ' Then a little programmable delay resolves the problem and allows using RC filters 
        ' inserted in keypad lines to reduce EMI. 
        ' An empiric formula would be: KPInkeyDelayX = (T1+T2)x3 in uS
        ' If R1,R2= 1K and C1,C2= 2,2nF: (2,2x10-6 + 2,2x10-6)x3 = 13,2uS + (Slew Rate Port)
        ' Round the value: then KPInkeyDelayX = 13 uS 
        DelayUS KPInkeyDelayX

        ' Reading the input port to a byte buffer.
        KPRead_PortX = __KEYPAD_PORT
                                               
        ' Now Check All ROWs
        KPRead_PortX.0 = 1    
        If KPRead_PortX.7 = 0 Then ReadPortOUT0   ' Check for RX2 = 0 Keydown 
        Dec KPScanResult
        If KPRead_PortX.6 = 0 Then ReadPortOUT0   ' Check for RX1 = 0 Keydown
        Dec KPScanResult
        KPRead_PortX.0 = 0
ReadPortOUT0:
        If KPRead_PortX.0 = 1 Then Break          ' If key pressed then return.
        Set_Bank KPColumnData
        Asm
        Bsf STATUS,0,0                  ; Load again one bit lost from the left.
        Rrcf KPColumnData,F,0             ; Rotate the KPColumnData bits to the right.
        EndAsm
'   All columns have been checked?      ' RB5        RB4        RB3        RB2        Final step 
    Until KPColumnData = %11111101        ' %11011111, %11101111, %11110111, %11111011, %11111101.
    ' This code keeps the same frecuency pulses and width in the keypad lines.
    Set_Bank __KEYPAD_PORT
    Asm      
    Movlw 00111100b                     ; %00111100, RX2,RX3,RX4,RX5 for outputs, 
    Iorwf (__KEYPAD_PORT + 0x09),F,0    ; IOR with PORTX. Clear All columns , All bits to high level.
    EndAsm    
    Return
#endIfMacro-
$endif
'-------------------------------------------------------------------------------
$endif
'*******************************************************************************
'* Name    : LCD_Reset                                                         *
'* Purpose : Force a Reset to the LCD                                          *
'* Input   : none                                                              *
'* Output  : none                                                              *
'* Note    : Reset the LCD to force an initialization.                         *
'*******************************************************************************
    $define LCD_Reset() ' 
    BPF = 0             '
    Cls

'*******************************************************************************
'* Name    : HRSLStrg(x,y,z)                                                   *
'* Purpose : Send a Cdata String to the Terminal                               *
'* Input   : x=>Label String, y=>Nb Characters, z=>Nb Carriage Return          *
'* Output  : none                                                              *
'* Note    : Send a String defined As a Label To the terminal                  *
'*******************************************************************************
    $define AllChars 255
' Declare the aliases of this library
    Dim bHRS_NumberCR As LVSByte1
    Dim bHRS_NbChars  As LVSByte2

' This routine take care of ROM memory > 64KB & Cdata written in the high side
' of the memory.

$define HRSLStrg(pLabel,pNbChars,pNumberCR) _mHRSLStrg pLabel,pNbChars,pNumberCR

_mHRSLStrg Macro- pLabel,pNbChars,pNumberCR
    #if (Prm_Count < 2)
        #error "_mHRSLStrg - Too few parameters"
    #else
        #if (Prm_Count == 2)
        	#if (Prm_1 != Label)
        		#error "_mHRSLStrg - (First Char) should be a LABEL!"
                Exitm
            #else
                #if (_MAXMEM > 65537)
                    Set_Bank TBLPTRL
                    Asm 
                    Movlw (Low pLabel)
                    Movwf TBLPTRL
                    Movlw (High pLabel)
                    Movwf TBLPTRH
                    Movlw (Upper pLabel)
                    Movwf TBLPTRU
                    EndAsm
                #else
                    Set_Bank TBLPTRL
                    Asm 
                    Movlw (Low pLabel)
                    Movwf TBLPTRL
                    Movlw (High pLabel)
                    Movwf TBLPTRH
                    EndAsm
                #endif
            #endif
        	#if (Prm_2 != Num8)
        		#error "_mHRSLStrg - (Number CR) should be a NUM8!"
                Exitm
            #else
                Num_Byte pNbChars, bHRS_NumberCR         
                Set_Bank bHRS_NbChars
                Asm
                Setf bHRS_NbChars,0
                EndAsm
                GoSub _mHRSLStrg_Sub
            #endif
        #endif
        #if (Prm_Count == 3)
        	#if (Prm_1 != Label)
        		#error "_mHRSLStrg - (First Char) should be a LABEL!"
                Exitm
            #else
                #if (_MAXMEM > 65537)
                    Set_Bank TBLPTRL
                    Asm- 
                    Movlw (Low pLabel)
                    Movwf TBLPTRL
                    Movlw (High pLabel)
                    Movwf TBLPTRH
                    Movlw (Upper pLabel)
                    Movwf TBLPTRU
                    Endasm-
                #else
                    Set_Bank TBLPTRL
                    Asm- 
                    Movlw (Low pLabel)
                    Movwf TBLPTRL
                    Movlw (High pLabel)
                    Movwf TBLPTRH
;                    Clrf  TBLPTRU 
                    Endasm-
                #endif
            #endif
        	#if (Prm_2 != Num8)
        		#error "_mHRSLStrg - (Number Characters) should be a NUM8!"
                Exitm
            #else
                Num_Byte pNbChars, bHRS_NbChars 
            #endif
        	#if (Prm_3 != Num8)
        		#error "_mHRSLStrg - (Number CR) should be a NUM8!"
                Exitm
            #else
                Num_Byte pNumberCR, bHRS_NumberCR        
                GoSub _mHRSLStrg_Sub
            #endif
        #endif
    #endif
Endm

#ifMacro- _mHRSLStrg
_mHRSLStrg_Sub:
    #if (_MAXMEM < 65537)
    TBLPTRU = 0                 ' Save a lot of Bytes.
    #endif
    EECON1 = 128                ' Access Flash memory
    While 1 = 1
        #ifdef watchdog_req
        Clrwdt
        #endif
        Tblrd*+  
        PRODH = TABLAT
        If PRODH = 0 Then           ' Check  if final of the string.
_mHRSLStrg00_Sub:
            While bHRS_NumberCR > 0 ' While there is a CR character to send.
                #ifdef watchdog_req
                Clrwdt
                #endif
                _HRSOut 13           ' Sending CR character to the terminal
                _HRSOut 10           ' Sending a LF character to the terminal
                Dec bHRS_NumberCR   ' Decrements the number of CR 
            Wend 
            EECON1 = 0              ' Disable Access Flash memory.
            TBLPTRU = 0
            Return 
        EndIf
        If bHRS_NbChars > 0 Then
            _HRSOut PRODH
            Dec bHRS_NbChars
        Else
            GoTo _mHRSLStrg00_Sub
        EndIf
    Wend
#endIfMacro-
'*******************************************************************************
'* Name    : PrintStrg(x,y,z,v)                                                *
'* Purpose : Print a Cdata String to the LCD                                   *
'* Input   : x = Label String, y = Number of Lines, z = Number of Columns      *
'*           v = Number of Characters                                          *
'* Output  : none                                                              *
'* Note    : The lenght of string is limited by the LCD                        *
'*******************************************************************************
' This routine take care of ROM memory > 64KB & Cdata written in the high side
' of the memory.

    Dim yHRS_NumberCR As LVSByte1
    Dim yHRS_NbChars  As LVSByte2
    Dim xPos          As LVSByte3
    Dim xLine         As LVSByte4

$define PrintStrg(pLabel,pLine,pPos,pNbChars) _mPrintStrg pLabel,pLine,pPos,pNbChars 

_mPrintStrg Macro- pLabel,pLine,pPos,pNbChars 
    #if (Prm_Count < 3)
        #error "_mHRSLStrg - Too few parameters"
    #else
        #if (Prm_Count == 3)
        	#if (Prm_1 != Label)
        		#error "_mHRSLStrg - (First Char) should be a LABEL!"
                Exitm
            #else
                #if (_MAXMEM > 65537)
                    Set_Bank TBLPTRL
                    Asm- 
                    Movlw (Low pLabel)
                    Movwf TBLPTRL
                    Movlw (High pLabel)
                    Movwf TBLPTRH
                    Movlw (Upper pLabel)
                    Movwf TBLPTRU
                    Endasm-
                #else
                    Set_Bank TBLPTRL
                    Asm- 
                    Movlw (Low pLabel)
                    Movwf TBLPTRL
                    Movlw (High pLabel)
                    Movwf TBLPTRH
                    Endasm-
                #endif
            #endif
        	#if (Prm_2 != Num8)
                #error "_mPrintStrg Macro - (pLine) should be a NUM8!"
                Exitm
            #else
                Num_Byte pLine, xLine
            #endif
        	#if (Prm_3 != Num8)
        		#error "_mPrintStrg Macro - (pPos) should be a NUM8!"
                Exitm
            #else
                Num_Byte pPos, xPos                
                Set_Bank yHRS_NbChars
                Asm
                Setf yHRS_NbChars,0
                EndAsm
                GoSub _mPrintStrg_Sub
            #endif
        #endif
        #if (Prm_Count == 4)
        	#if (Prm_1 != Label)
        		#error "_mHRSLStrg - (First Char) should be a LABEL!"
                Exitm
            #else
                #if (_MAXMEM > 65537)
                    Set_Bank TBLPTRL
                    Asm- 
                    Movlw (Low pLabel)
                    Movwf TBLPTRL
                    Movlw (High pLabel)
                    Movwf TBLPTRH
                    Movlw (Upper pLabel)
                    Movwf TBLPTRU
                    Endasm-
                #else
                    Set_Bank TBLPTRL
                    Asm- 
                    Movlw (Low pLabel)
                    Movwf TBLPTRL
                    Movlw (High pLabel)
                    Movwf TBLPTRH
                    Endasm-
                #endif
            #endif
        	#if (Prm_2 != Num8)
                #error "_mPrintStrg Macro - (pLine) should be a NUM8!"
                Exitm
            #else
                Num_Byte pLine, xLine
            #endif
        	#if (Prm_3 != Num8)
        		#error "_mPrintStrg Macro - (pPos) should be a NUM8!"
                Exitm
            #else
                Num_Byte pPos, xPos  
            #endif
        	#if (Prm_4 != Num8)
        		#error "_mHRSLStrg - (Number Characters) should be a NUM8!"
                Exitm
            #else
                Num_Byte pNbChars, yHRS_NbChars                    
                GoSub _mPrintStrg_Sub
            #endif
        #endif
    #endif
Endm

#ifMacro- _mPrintStrg
_mPrintStrg_Sub:
    #if (_MAXMEM < 65537)
    TBLPTRU = 0                 ' Save a lot of Bytes.
    #endif
    If xLine > __LCD_LINES Then
        xLine = __LCD_LINES
    EndIf
    If xPos > __LCD_CharsLenght Then
        xPos = __LCD_CharsLenght - 1
    EndIf
    If yHRS_NbChars > __LCD_CharsLenght Then    ' Added 10/04/2017 V01
        yHRS_NbChars = __LCD_CharsLenght
    EndIf
    Cursor xLine, xPos

    EECON1 = 128                ' Access Flash memory
    While 1 = 1
        #ifdef watchdog_req
        Clrwdt
        #endif
        Tblrd*+  
        PRODH = TABLAT
        If PRODH = 0 Then       ' Check  if final of the string.
            EECON1 = 0          ' Disable Access Flash memory.
            TBLPTRU = 0
            Return 
        EndIf
        If yHRS_NbChars > 0 Then
            Print PRODH
            Dec yHRS_NbChars
        Else
            EECON1 = 0          ' Disable Access Flash memory.
            TBLPTRU = 0
            Return
        EndIf
    Wend
#endIfMacro-
'*******************************************************************************
'* Name    : Clear GIE                                                         *
'* Purpose : Clear & Set the GIE interrupt flag                                *
'* Input   : none                                                              *
'* Output  : none                                                              *
'* Note    : The interrupt is always enabled in the States Machine             *
'*******************************************************************************
' Clear the GIE Flag
$ifndef ClearGIE
$define ClearGIE() INTCONBits_GIE = 0
$endif

' Set the GIE Flag
$ifndef SetGIE
$define SetGIE() INTCONBits_GIE = 1
$endif
'*******************************************************************************
'* Name    : HRSE2PStrg                                                        *
'* Purpose : Read an E2P string and sent it to the Terminal                    *
'* Input   : none                                                              *
'* Output  : none                                                              *
'* Note    : Write Address, Number of ASCII characters, Number of CR,LF        *
'*******************************************************************************
$ifdef _HRSE2PStrg_
' Declare the global variables.

' Definition of local Words variables.
$ifndef _LVWS_Block1_
    $define _LVWS_Block1_
    Dim LVSWord1 As Word System     ' Local Variable System Word1
    Dim LVSWord2 As Word System     ' Local Variable System Word2
$endif

    $if _eeprom > 256
    Dim HRSEepAddress As LVSWord1
    $else
    Dim HRSEepAddress As LVSByte1    
    $endif

    Dim xHRSe2p_NbChars  As LVSByte2
    Dim xHRSe2p_NumberCR As LVSByte3
    Dim bHRSE2PData      As LVSByte4
    
$define HRSE2PStrg(pAddress,pNbChars,pNumberCR) _mHRSE2PStrg pAddress,pNbChars,pNumberCR

_mHRSE2PStrg Macro- pAddress,pNbChars,pNumberCR
    #if (Prm_Count < 2)
        #error "_mHRSE2PStrg - Too few parameters"
    #else
        #if (Prm_Count == 2)
        	#if (Prm_1 != Num8) && (Prm_1 != Num16) && (Prm_1 != Byte) && (Prm_1 != Word)
        		#error "_mHRSE2PStrg - (First Char) should be a Num8, Num16, Byte or Word!"
                Exitm
            #else
                #if (Prm_1 == Num8) || (Prm_1 == Num16)
                    $if _eeprom > 256
                    Num_Word pAddress, HRSEepAddress
                    $else
                    Num_Byte pAddress, HRSEepAddress
                    $endif
                #endif
                #if (Prm_1 == Byte)
                    $if _eeprom > 256
                    Byte_Word pAddress, HRSEepAddress
                    $else
                    Byte_Byte pAddress, HRSEepAddress
                    $endif
                #endif
                #if (Prm_1 == Word)
                    $if _eeprom > 256
                    Word_Word pAddress, HRSEepAddress
                    $else
                    Word_Byte pAddress, HRSEepAddress
                    $endif
                #endif
            #endif
        	#if (Prm_2 != Num8)
        		#error "_mHRSE2PStrg - (Number CR) should be a NUM8!"
                Exitm
            #else
                Num_Byte pNbChars, xHRSe2p_NumberCR         
                Set_Bank xHRSe2p_NbChars
                Asm
                Setf xHRSe2p_NbChars,0
                EndAsm
                GoSub HRSE2PString_Sub
            #endif
        #endif
        #if (Prm_Count == 3)
        	#if (Prm_1 != Num8) && (Prm_1 != Num16) && (Prm_1 != Byte) && (Prm_1 != Word)
        		#error "_mHRSE2PStrg - (First Char) should be a Num8, Num16, Byte or Word!"
                Exitm
            #else
                #if (Prm_1 == Num8) || (Prm_1 == Num16)
                    $if _eeprom > 256
                    Num_Word pAddress, HRSEepAddress
                    $else
                    Num_Byte pAddress, HRSEepAddress
                    $endif
                #endif
                #if (Prm_1 == Byte)
                    $if _eeprom > 256
                    Byte_Word pAddress, HRSEepAddress
                    $else
                    Byte_Byte pAddress, HRSEepAddress
                    $endif
                #endif
                #if (Prm_1 == Word)
                    $if _eeprom > 256
                    Word_Word pAddress, HRSEepAddress
                    $else
                    Word_Byte pAddress, HRSEepAddress
                    $endif
                #endif
            #endif
        	#if (Prm_2 != Num8)
        		#error "_mHRSE2PStrg - (Number Characters) should be a NUM8!"
                Exitm
            #else
                Num_Byte pNbChars, xHRSe2p_NbChars 
            #endif
        	#if (Prm_3 != Num8)
        		#error "_mHRSE2PStrg - (Number CR) should be a NUM8!"
                Exitm
            #else
                Num_Byte pNumberCR, xHRSe2p_NumberCR        
                GoSub HRSE2PString_Sub
            #endif
        #endif
    #endif
Endm

#ifMacro- _mHRSE2PStrg
' Read a string written in the eeprom memory.
HRSE2PString_Sub:
    While 1 = 1
        #ifdef WatchDog_Req
        Clrwdt
        #endif
        bHRSE2PData = ERead HRSEepAddress
        If bHRSE2PData = 0 Then         ' Check  if final of the string.
HRSE2PString00_Sub:
            While xHRSe2p_NumberCR > 0  ' While there is a CR character to send.
                _HRSOut 13              ' Sending CR character to the terminal
                _HRSOut 10              ' Sending a LF character to the terminal
                Dec xHRSe2p_NumberCR    ' Decrements the number of CR 
            Wend 
            Return 
        EndIf
        If bHRS_NbChars > 0 Then
            _HRSOut bHRSE2PData
            Dec xHRSe2p_NbChars
            Inc HRSEepAddress
        Else
            GoTo HRSE2PString00_Sub
        EndIf
    Wend
#endIfMacro-
$endif
'*******************************************************************************
'* Name    : PrintE2PStrg                                                      *
'* Purpose : Read an E2P string and print to the LCD                           *
'* Input   : none                                                              *
'* Output  : none                                                              *
'* Note    : Write Address, Number of ASCII characters, Number of CR,LF        *
'*******************************************************************************
$ifdef _PrintE2PStrg_
' Declare the global variables.

' Definition of local Words variables.
$ifndef _LVWS_Block1_
    $define _LVWS_Block1_
    Dim LVSWord1 As Word System     ' Local Variable System Word1
    Dim LVSWord2 As Word System     ' Local Variable System Word2
$endif

    $if _eeprom > 256
    Dim zEepAddress As LVSWord1
    $else
    Dim zEepAddress As LVSByte1    
    $endif

    Dim ze2p_NbChars  As LVSByte2
    Dim zPos          As LVSByte3
    Dim zLine         As LVSByte4
    
$define PrintE2PStrg(pAddress,pLine,pPos,pNbChars) _mPrintE2PStrg pAddress,pLine,pPos,pNbChars

_mPrintE2PStrg Macro- pAddress,pLine,pPos,pNbChars
    #if (Prm_Count < 3)
        #error "_mPrintE2PStrg - Too few parameters"
    #else
        #if (Prm_Count == 3)
        	#if (Prm_1 != Num8) && (Prm_1 != Num16) && (Prm_1 != Byte) && (Prm_1 != Word)
        		#error "_mPrintE2PStrg - (First Char) should be a Num8, Num16, Byte or Word!"
                Exitm
            #else
                #if (Prm_1 == Num8) || (Prm_1 == Num16)
                    $if _eeprom > 256
                    Num_Word pAddress, zEepAddress
                    $else
                    Num_Byte pAddress, zEepAddress
                    $endif
                #endif
                #if (Prm_1 == Byte)
                    $if _eeprom > 256
                    Byte_Word pAddress, zEepAddress
                    $else
                    Byte_Byte pAddress, zEepAddress
                    $endif
                #endif
                #if (Prm_1 == Word)
                    $if _eeprom > 256
                    Word_Word pAddress, zEepAddress
                    $else
                    Word_Byte pAddress, zEepAddress
                    $endif
                #endif
            #endif
        	#if (Prm_2 != Num8)
                #error "_mPrintStrg Macro - (pLine) should be a NUM8!"
                Exitm
            #else
                Num_Byte pLine, zLine
            #endif
        	#if (Prm_3 != Num8)
        		#error "_mPrintStrg Macro - (pPos) should be a NUM8!"
                Exitm
            #else
                Num_Byte pPos, zPos                
                ze2p_NbChars = __LCD_CharsLenght
                GoSub _mPrintE2PStrg_Sub
            #endif
        #endif
        #if (Prm_Count == 4)
        	#if (Prm_1 != Num8) && (Prm_1 != Num16) && (Prm_1 != Byte) && (Prm_1 != Word)
        		#error "_mPrintE2PStrg - (First Char) should be a Num8, Num16, Byte or Word!"
                Exitm
            #else
                #if (Prm_1 == Num8) || (Prm_1 == Num16)
                    $if _eeprom > 256
                    Num_Word pAddress, zEepAddress
                    $else
                    Num_Byte pAddress, zEepAddress
                    $endif
                #endif
                #if (Prm_1 == Byte)
                    $if _eeprom > 256
                    Byte_Word pAddress, zEepAddress
                    $else
                    Byte_Byte pAddress, zEepAddress
                    $endif
                #endif
                #if (Prm_1 == Word)
                    $if _eeprom > 256
                    Word_Word pAddress, zEepAddress
                    $else
                    Word_Byte pAddress, zEepAddress
                    $endif
                #endif
            #endif
        	#if (Prm_2 != Num8)
                #error "_mPrintE2PStrg Macro - (pLine) should be a NUM8!"
                Exitm
            #else
                Num_Byte pLine, zLine
            #endif
        	#if (Prm_3 != Num8)
        		#error "_mPrintE2PStrg Macro - (pPos) should be a NUM8!"
                Exitm
            #else
                Num_Byte pPos, zPos                
            #endif
        	#if (Prm_4 != Num8)
        		#error "_mPrintE2PStrg Macro - (pNbChars) should be a NUM8!"
                Exitm
            #else
                Num_Byte pNbChars, ze2p_NbChars                
                GoSub _mPrintE2PStrg_Sub
            #endif
        #endif
    #endif
Endm

#ifMacro- _mPrintE2PStrg
_mPrintE2PStrg_Sub:
    If xLine > __LCD_LINES Then
        xLine = __LCD_LINES
    EndIf
    If xPos > __LCD_CharsLenght Then
        xPos = __LCD_CharsLenght - 1
    EndIf
    If ze2p_NbChars > __LCD_CharsLenght Then    
        ze2p_NbChars = __LCD_CharsLenght
    EndIf
    Cursor xLine, xPos

    While 1 = 1
        #ifdef watchdog_req
        Clrwdt
        #endif
        PRODH = ERead zEepAddress
        If PRODH = 0 Then       ' Check  if final of the string.
            Return
        EndIf
        If yHRS_NbChars > 0 Then
            Print PRODH
            Dec ze2p_NbChars
            Inc zEepAddress
        Else
            Return
        EndIf
    Wend
#endIfMacro-
$endif
'*******************************************************************************
'* Name    : ConvertLowNibbleAsccii                                            *
'* Purpose : Convert the a low nibble to ASCII character                       *
'* Input   : Data in WREG                                                      *
'* Output  : Data out in WREG                                                  *
'*******************************************************************************
$define ConvertLowNibbleAsccii(pValue,pReturn) '
    WREG = pValue                              '
    _mConvertLowNibbleAsccii                   '
    pReturn = WREG

_mConvertLowNibbleAsccii Macro-
    GoSub _mConvertLowNibbleAsccii_Sub
Endm

#ifMacro- _mConvertLowNibbleAsccii
_mConvertLowNibbleAsccii_Sub:
    WREG = WREG & $0F   ' Take the lower nibble only.
Asm
    Addlw   -10         ; Test to see if W < 10
    Btfsc   STATUS,0    ; If yes, skip ahead
    Addlw   "A"-"0"-10  ; Add ASCII 'A', and negate next line
    Addlw   "0"+10      ; Add ASCII '0' and original 10
EndAsm
    Return 
#endIfMacro-
'*******************************************************************************
'* Name    : CONV_1BIN_2HEX_Sub                                                *
'* Purpose : Convert 1 Binary Byte to 2 HEX Bytes                              *
'*******************************************************************************
' Conv1Byte_to_2ASCII_CRLF(Byte)
' Send a Byte Bin to the terminal in HEX ASCII with sending a CR,LF
'CONV_1BYTE_2HEX_Sub:
'    WREG = Byte_DSB >> 4        ' Convert the high nibble.
'    GoSub CONVERT_LOWNIBBLE_to_ASCII_Sub
'    GoSub HRSOUT_Sub
'    WREG = Byte_DSB             ' Convert the low nibble.
'    GoSub CONVERT_LOWNIBBLE_to_ASCII_Sub
'    GoSub HRSOUT_Sub
'    GoTo _HRSOut#CR_Sub          ' Send a CR,LF
'===============================================================================
' Send a Byte Bin to the terminal in HEX ASCII without sending CR,LF
' Conv1Byte_to_2ASCII(Byte)
'===============================================================================
'CONV_1BYTE_2HEXBB_Sub:
'    WREG = Byte_DSB >> 4        ' Convert the high nibble.
'    GoSub CONVERT_LOWNIBBLE_to_ASCII_Sub
'    GoSub HRSOUT_Sub

'CONV_1BYTE_1HEXBB11_Sub:
'    WREG = Byte_DSB             ' Convert the low nibble.
'    GoSub CONVERT_LOWNIBBLE_to_ASCII_Sub
'    GoTo HRSOUT_Sub
'*******************************************************************************
'* Name   : Beep(pBeepDelay,pType,pPin)                                        *
'* Purpose: Set a Buzzer for a determined time                                 *
'* Input  : pBeepDelay = 1 to 255   Type = (ceramic) or (sounder)              *
'* Output :                                                                    *
'* Notes  : Precision of the frequency could be +-1250hZ +-10%, delay +-100mS  *
'*******************************************************************************
    $define Beep(pBeepDelay,pType,pPin)      '
    $if pType = ceramic                      '
         Sound pPin,[120, (pBeepDelay / 11)] ' 
         High pPin                           '
    $endif                                   '
    $if pType = sounder                      '
         High pPin                           '
         DelayMS pBeepDelay                  '             
         Clear pPin                          '
    $endif

''===============================================================================
'    Dim RESTO As Byte
'
'BargraphHD44780:
''Calculate meter reading
'    bhSum = (METER * bhColumns) / 341   ' Meter value. Value 341 = 1024 / 3 (values per segment)
'    bhFull = bhSum / 3                  ' Number of bhFull characters |||
'    bhPartial = bhSum // 3              ' Modulus restvalue (0, 1 or 2)
'
''Display the bargraph          
'    Set_Cursor(2,1)
'    Print Rep 3\bhFull                  ' Displays bhFull characters ||| of the S-mete    
'    'Print At 2, 1, Rep 3\bhFull         ' Displays bhFull characters ||| of the S-meter
'    If bhPartial > 0 Then
'        Print bhPartial                 ' Prints either the empty, | or || character
'    EndIf
'    RESTO = bhColumns - bhFull
'    Print Rep 0\RESTO                   ' Clears the remaining part of the level bar 
'    Return
'*******************************************************************************
'* Name    : MidPoint                                                          *
'* Purpose : Compute middle point of 2 values                                  *
'* Input   : 2 Values                                                          *
'* Output  : Return_Type (Byte, Word or Dword)                                 *
'* Syntax  : Result = MidPoint(X,Y)                                            *
'* Notes   : The MidPoint library is divided in 3 commands (DWord, Word, Byte) *
'*           to save a lot of bytes in the calculation subroutine.             *
'*******************************************************************************
$ifdef _MidPoint_
'-------------------------------------------------------------------------------
$ifndef _LVDWS_Block1_
    $define _LVDWS_Block1_
    Dim LVSDWord1 As Dword System
    Dim LVSDWord2 As Dword System
$endif

' Definition of local DWords
    Dim MidPointDW1 As LVSDWord1
    Dim MidPointDW2 As LVSDWord2
 
$define MidPointDW(pValue1,pValue2) _mMidPointDW pValue1,pValue2

_mMidPointDW Macro- pValue1,pValue2
    #if (Prm_Count > 2)
        #error "_mMidPoint - Too many parameters"
        Exitm
    #else
        #if (Prm_Count < 2)
            #error "_mMidPoint - Too few parameters"
            Exitm
        #else
            #if (Prm_1 != Word) && (Prm_1 != Num16) && (Prm_1 != Num8) && (Prm_1 != Num32) && (Prm_1 != Byte) && (Prm_1 != Dword)
                #error "_mMidPointDW - (Param1) Should be a Word, Byte, DWord variable or number"
            #endif
            #if (Prm_2 != Word) && (Prm_2 != Num16) && (Prm_2 != Num8) && (Prm_2 != Num32) && (Prm_2 != Byte) && (Prm_2 != Dword)
                    #error "_mMidPointDW - (Param2) Should be a Word, Byte, DWord variable or number"
            #endif
            #if (Prm_1 == Dword)
                Dword_Dword pValue1, MidPointDW1
            #endif
            #if (Prm_1 == Word)
                Word_Dword pValue1, MidPointDW1
            #endif
            #if (Prm_1 == Byte)
                Byte_Dword pValue1, MidPointDW1
            #endif
            #if (Prm_1 == Num32)
                Num_Dword pValue1, MidPointDW1
            #endif 
            #if (Prm_1 == Num16)
                Num_Dword pValue1, MidPointDW1
            #endif
            #if (Prm_1 == Num8)
                Num_Dword pValue1, MidPointDW1
            #endif
            #if (Prm_2 == Dword)
                Dword_Dword pValue2, MidPointDW2
            #endif
            #if (Prm_2 == Word)
                Word_Dword pValue2, MidPointDW2
            #endif
            #if (Prm_2 == Byte)
                Byte_Dword pValue2, MidPointDW2
            #endif
            #if (Prm_2 == Num32)
                Num_Dword pValue2, MidPointDW2
            #endif
            #if (Prm_2 == Num16)
                Num_Dword pValue2, MidPointDW2
            #endif
            #if (Prm_2 == Num8)
                Num_Dword pValue2, MidPointDW2
            #endif
            GoSub _mMidPointDW_Sub
        #endif
        #if (_mMidPointDW_RETURN != 1)
            #error "_mMidPointDW - Mandatory return parameter misssing"
        #else
            #if (Return_Type != Dword)
                #error "_mMidPointDW - Return variable should be a DWord variable"
            #else
                #if (Return_Type == Dword)
                    Dword_Dword MidPointDW1, Return_Var
                #endif
            #endif
        #endif
    #endif
Endm

#ifMacro- _mMidPointDW
_mMidPointDW_Sub:
    If MidPointDW2 > MidPointDW1 Then
        Swap MidPointDW1,MidPointDW2
    EndIf
    MidPointDW1 = MidPointDW1 - MidPointDW2
    MidPointDW1 = MidPointDW1 / 2
    MidPointDW1 = MidPointDW1 + MidPointDW2 
    Return
#endIfMacro-
'-------------------------------------------------------------------------------
' Declare the local variables
$ifndef _LVWS_Block1_
    $define _LVWS_Block1_
    Dim LVSWord1 As Word System     ' Local Variable System Word1
    Dim LVSWord2 As Word System     ' Local Variable System Word2
$endif

    Dim MidPointW1 As LVSWord1
    Dim MidPointW2 As LVSWord2 

$define MidPointW(pValue1,pValue2) _mMidPointW pValue1,pValue2

_mMidPointW Macro-  pValue1,pValue2
    #if (Prm_Count > 2)
        #error "_mMidPointW - Too many parameters"
        Exitm
    #else
        #if (Prm_Count < 2)
            #error "_mMidPointW - Too few parameters"
            Exitm
        #else
            #if (Prm_1 != Word) && (Prm_1 != Num16) && (Prm_1 != Num8) && (Prm_1 != Byte)
                #error "_mMidPointW - (Param1) Should be a Word, Byte variable or number"
            #endif
            #if (Prm_2 != Word) && (Prm_1 != Num16) && (Prm_1 != Num8) && (Prm_1 != Byte)
                    #error "_mMidPointW - (Param2) Should be a Word, Byte variable or number"
            #endif
            #if (Prm_1 == Word)
                Word_Word pValue1, MidPointW1
            #endif
            #if (Prm_1 == Byte)
                Byte_Word pValue1, MidPointW1
            #endif
            #if (Prm_1 == Num16)
                Num_Word pValue1, MidPointW1
            #endif
            #if (Prm_1 == Num8)
                Num_Word pValue1, MidPointW1
            #endif
            #if (Prm_2 == Word)
                Word_Word pValue2, MidPointW2
            #endif
            #if (Prm_2 == Byte)
                Byte_Word pValue2, MidPointW2
            #endif
            #if (Prm_2 == Num16)
                Num_Word pValue2, MidPointW2
            #endif
            #if (Prm_2 == Num8)
                Num_Word pValue2, MidPointW2
            #endif
            GoSub _mMidPointW_Sub
        #endif
        #if (_mMidPointW_RETURN != 1)
            #error "_mMidPointW - Mandatory return parameter misssing"
        #else
            #if (Return_Type != Dword) && (Return_Type != Word)
                #error "_mMidPointW - Return variable should be a DWord or a Word variable"
            #else
                #if (Return_Type == Dword)
                    Word_Dword MidPointW1, Return_Var
                #endif
                #if (Return_Type == Word)
                    Word_Word MidPointW1, Return_Var
                #endif
            #endif
        #endif
    #endif
Endm

#ifMacro- _mMidPointW
_mMidPointW_Sub:
    If MidPointW2 > MidPointW1 Then
        Swap MidPointW1,MidPointW2
    EndIf
    MidPointW1 = MidPointW1 - MidPointW2
    MidPointW1 = MidPointW1 / 2
    MidPointW1 = MidPointW1 + MidPointW2 
    Return
#endIfMacro-
'-------------------------------------------------------------------------------
    Dim MidPointB1 As LVSByte1
    Dim MidPointB2 As LVSByte2 

$define MidPointB(pValue1,pValue2) _mMidPointB pValue1,pValue2

_mMidPointB Macro-  pValue1,pValue2
    #if (Prm_Count > 2)
        #error "_mMidPoint - Too many parameters"
        Exitm
    #else
        #if (Prm_Count < 2)
            #error "_mMidPoint - Too few parameters"
            Exitm
        #else
            #if (Prm_1 != Num8) && (Prm_1 != Byte)
                #error "_mMidPoint - (Param1) Should be a Byte variable or number"
            #endif
            #if (Prm_1 != Num8) && (Prm_1 != Byte)
                    #error "_mMidPoint - (Param2) Should be a Byte variable or number"
            #endif
            #if (Prm_1 == Byte)
                Byte_Byte pValue1, MidPointB1
            #endif
            #if (Prm_1 == Num8)
                Num_Byte pValue1, MidPointB1
            #endif
            #if (Prm_2 == Byte)
                Byte_Byte pValue2, MidPointB2
            #endif
            #if (Prm_2 == Num8)
                Num_Byte pValue2, MidPointB2
            #endif
            GoSub _mMidPointB_Sub
        #endif
        #if (_mMidPointB_RETURN != 1)
            #error "_mMidPointB - Mandatory return parameter misssing"
        #else
            #if (Return_Type != Word) && (Return_Type != Byte)
                #error "_mMidPointB - Return variable should be a Word or a Byte variable"
            #else
                #if (Return_Type == Word)
                    Byte_Word MidPointB1, Return_Var
                #endif
                #if (Return_Type == Byte)
                    Byte_Byte MidPointB1, Return_Var
                #endif
            #endif
        #endif
    #endif
Endm

#ifMacro- _mMidPointB
_mMidPointB_Sub:
    If MidPointB2 > MidPointB1 Then
        Swap MidPointB1,MidPointB2
    EndIf
    MidPointB1 = MidPointB1 - MidPointB2
    MidPointB1 = MidPointB1 / 2
    MidPointB1 = MidPointB1 + MidPointB2 
    Return
#endIfMacro-
'-------------------------------------------------------------------------------
$endif
'*******************************************************************************
'* Name    : Binary_to_3BCD                                                    *
'* Purpose : Convert one binary Byte (0 To 255) To 3 BCD bytes                 *
'* Input   : Byte Or Num8                                                      *
'* Output  : Byte_LSB, Byte_DSB, Byte_MSB                                      *
'* Syntax  : Binary_to_3BCD(pValue)                                            *
'* Notes   :                                                                   *
'*******************************************************************************
$ifdef _Binaryto3BCD_

' Declare local variables
    Dim BinaryTempB As LVSByte1

' Declare global variables
    Dim Byte_MSB As Byte System
    Dim Byte_DSB As Byte System
    Dim Byte_LSB As Byte System
'
$define Binaryto3BCD(pValue) mBinaryto3BCD pValue

mBinaryto3BCD Macro- pValue
	#if (Prm_Count != 1)         
        ' Ensure the correct amount of parameters
		#error "Incorrect amount of parameters for Binary_to_BCD3 macro. 1 Parameter required!"	
		Exitm
    #else
        #if (Prm_1 != Byte) && (Prm_1 != Num8)
            ' Ensure the parameter is a byte
            #error "Binary_to_BCD3 Macro - Input Value(Param1) Should be a Byte Variable or a Num8"
            Exitm
        #else    
            #if (Prm_1 == Byte)
                Byte_Byte pValue, BinaryTempB
            #endif
            #if (Prm_1 == Num8)
                Num_Byte pValue, BinaryTempB
            #endif            
             GoSub mBinaryto3BCD_Sub
        #endif
    #endif
Endm

#ifMacro- mBinaryto3BCD
mBinaryto3BCD_Sub:
    Byte_MSB = BinaryTempB / 100
    Byte_DSB = BinaryTempB // 100
    Byte_LSB = Byte_DSB // 10
    Byte_DSB = Byte_DSB / 10
    Return
#endIfMacro-    
$endif
'*******************************************************************************
'* Name    : RotateBitsLeft                                                    *
'* Purpose : Move the Bits of a Byte to the Left                               *
'* Input   : Byte Or Num8                                                      *
'* Output  : Return Type (Byte)                                                *
'* Syntax  : ResultByte = RotateBitsLeft(Var1,Shift)                           *
'* Notes   :                                                                   *
'*******************************************************************************
$ifdef _RotateBits_

    Dim _mzLoopShiftB    As LVSByte1 
    Dim _zmValueToShiftB As LVSByte2

$define RotateBitsLeft(pValue,pShift) _mRotateBitsLeft pValue,pShift

_mRotateBitsLeft Macro- pValue,pShift
    #if (Prm_Count > 2)
	   #error "_mRotateBitsLeft - Too many parameters"
       Exitm
    #else
        #if (Prm_Count < 2)
            #error "_mRotateBitsLeft - Too few parameters"
            Exitm
        #else
            #if (Prm_1 != Byte) && (Prm_1 != Num8)
                #error "_mRotateBitsLeft - (Param1) Should be a Byte or Num8"
                Exitm
            #endif
            #if (Prm_2 != Byte) && (Prm_2 != Num8)
                #error "_mRotateBitsLeft - (Param2) Should be a Byte Or Num8"
                Exitm
            #else
                #if (Prm_2 == Byte) 
                Byte_Byte pShift,_mzLoopShiftB         
                #endif   
                #if (Prm_2 == Num8) 
                Num_Byte pShift,_mzLoopShiftB
                #endif
                #if (Prm_1 == Byte) 
                Byte_Byte pValue,_zmValueToShiftB
                #endif
                #if (Prm_1 == Num8) 
                Num_Byte pValue,_zmValueToShiftB
                #endif                                 
                GoSub _mRotateBitsLeft_sub            
                #if (_mRotateBitsLeft_RETURN != 1)
                    #error "_mRotateBitsLeft - Mandatory return parameter misssing"
                #else
                    #if (Return_Type != Byte)
                        #error "_mRotateBitsLeft - Return variable should be a Byte variable"
                    #else
                        #if (Return_Type == Byte)
                        Byte_Byte _zmValueToShiftB, Return_Var
                        #endif
                    #endif
                #endif
            #endif
        #endif
    #endif        
Endm
 
#ifMacro- _mRotateBitsLeft
_mRotateBitsLeft_sub:
' Se hace con el asemblador, no hay remedio...
    Set_Bank _zmValueToShiftB
Asm
_LBLX__Y11MM
    Rlncf   _zmValueToShiftB,F,0
;    Decf    _mzLoopShiftB,F,0
;    Movf    _mzLoopShiftB,F,0
;    Btfss   STATUS,Z,0
;    Bra     _LBLX__Y11MM
    Decfsz  _mzLoopShiftB,F,0    ; Modified 21/04/2013
    Bra     _LBLX__Y11MM        ; Modified 21/04/2013
EndAsm
    Return
#endIfMacro-
'*******************************************************************************
'* Name    : RotateBitsRight                                                   *
'* Purpose : Move the Bits of a Byte to the Right                              *
'* Input   : Byte Or Num8                                                      *
'* Output  : Return Type (Byte)                                                *
'* Syntax  : ResultByte = RotateBitsRight(Var1,Shift)                          *
'* Notes   :                                                                   *
'*******************************************************************************
$define RotateBitsRight(pValue, pShift) _mRotateBitsRight pValue, pShift

_mRotateBitsRight Macro- pValue, pShift
    #if (Prm_Count > 2)
	   #error "_mRotateBitsRight - Too many parameters"
       Exitm
    #else
        #if (Prm_Count < 2)
            #error "_mRotateBitsRight - Too few parameters"
            Exitm
        #else
            #if (Prm_1 != Byte) && (Prm_1 != Num8)
                #error "_mRotateBitsRight - (Param1) Should be a Byte or Num8"
                Exitm
            #endif
            #if (Prm_2 != Byte) && (Prm_2 != Num8)
                #error "_mRotateBitsRight - (Param2) Should be a Byte Or Num8"
                Exitm
            #else
                #if (Prm_2 == Byte) 
                Byte_Byte pShift,_mzLoopShiftB         
                #endif   
                #if (Prm_2 == Num8) 
                Num_Byte pShift,_mzLoopShiftB
                #endif
                #if (Prm_1 == Byte) 
                Byte_Byte pValue,_zmValueToShiftB
                #endif
                #if (Prm_1 == Num8) 
                Num_Byte pValue,_zmValueToShiftB
                #endif                                 
                GoSub _mRotateBitsRight_sub            
                #if (_mRotateBitsRight_RETURN != 1)
                    #error "_mRotateBitsRight - Mandatory return parameter misssing"
                #else
                    #if (Return_Type != Byte)
                        #error "_mRotateBitsRight - Return variable should be a Byte variable"
                    #else
                        #if (Return_Type == Byte)
                        Byte_Byte _zmValueToShiftB, Return_Var
                        #endif
                    #endif
                #endif
            #endif
        #endif
    #endif        
Endm
 
#ifMacro- _mRotateBitsRight
_mRotateBitsRight_sub:
' Se hace con el asemblador, no hay remedio...
    Set_Bank _zmValueToShiftB
Asm
_LBLX__Y22MM
    Rrncf   _zmValueToShiftB,F,0
;    Decf    _mzLoopShiftB,F,0
;    Movf    _mzLoopShiftB,F,0
;    Btfss   STATUS,Z,0
;    Bra     _LBLX__Y22MM
    Decfsz  _mzLoopShiftB,F,0    ; Modified 21/04/2013
    Bra     _LBLX__Y22MM        ; Modified 21/04/2013
EndAsm
    Return
#endIfMacro-
$endif
'-------------------------------------------------------------------------------


'BCD_BIN: ' Enter with value in Convert, return is also in Convert
'    Temp_Convert = Convert & $F0       ' take the high nibble BCD Value only by
'                                       ' masking the low nibble with a bitwise and
'    swapf Temp_Convert,1               ' place in the low nibble
'    Temp_Convert = Temp_Convert * 10   ' make Temp_Convert = Temp_Convert * 10
'                                       ', hte 10's digits
'    Convert = Convert & $0F            ' place the low digit of convert in the low nibble by masking with a bitwise and

'    Convert = Convert + Temp_Convert ' the result of the addition of the two  is the binary value of the orignal bcd
'    Return
''-------------------------------------------------------------------------------
'BIN_BCD: ' Convert Binary (Decimal) to BCD
'        ' Enter with value in Convert, return is also in Convert

'    Temp_Convert = Convert//10         ' Temp_Convert has the remainder of the divide by 10 in the low nibble
'    Convert = Convert / 10             ' Convert has the integer value of the divide by 10 in the low nibble
'    swapf Convert,1                    ' Swap the high and low nibbles of Temp_Convert and place result back into Temp_Convert
'    Convert = Convert ^ Temp_Convert   ' Bitwise XOR the two results to form the BCD Value
'    Return


'*******************************************************************************
'* Name    : BCD2toBinary                                                      *
'* Purpose : Convert one Byte with 2 BCD To one binary Byte                    *
'* Input   : Variable (Byte)                                                   *
'* Output  : Return_Type (Byte)                                                *
'* Syntax  : ResultByteVar = BCD2toBinary(VAR1)                                *
'* Notes   :                                                                   *
'*******************************************************************************
$ifdef _BCD2ToBinary_

' Declare local variables
    Dim _BcdBinaryTempB As LVSByte1 
    Dim _2BCD_Byte      As LVSByte2    

$define BCD2ToBinary(pValue) _mBCD2_to_Binary pValue
 
_mBCD2_to_Binary Macro pValue
	#if (Prm_Count != 1)         
        ' Ensure the correct amount of parameters
		#error "Incorrect amount of parameters for _mBCD2_to_Binary macro. 1 Parameter required!"	
		Exitm
    #else
        #if (Prm_1 != Byte) && (Prm_1 != Num8)
            ' Ensure the parameter is a byte
            #error "_mBCD2_to_Binary Macro - Input Variable(Param1) Should be a Byte Variable or a Num8"
            Exitm
        #else    
            #if (Prm_1 == Byte)
                Byte_Byte pValue, _2BCD_Byte
            #endif
            #if (Prm_1 == Num8)
                Num_Byte pValue, _2BCD_Byte
            #endif            
            GoSub _mBCD2_to_Binary_Sub
            #if (_mBCD2_to_Binary_RETURN != 1)
                #error "_mBCD2_to_Binary - Mandatory return parameter misssing"
            #else
                #if (Return_Type != Byte)
                    #error "_mBCD2_to_Binary - Return variable should be a Byte variable"
                    Exitm
                #else
                    Byte_Byte _BcdBinaryTempB, Return_Var
                #endif
            #endif
        #endif
    #endif
Endm

#ifMacro- _mBCD2_to_Binary
_mBCD2_to_Binary_Sub:
    ' This is the code
    Clear _BcdBinaryTempB          'this temporal variable must to be defined first
    If _2BCD_Byte.0 = 1 Then _BcdBinaryTempB = 1
    If _2BCD_Byte.1 = 1 Then _BcdBinaryTempB = _BcdBinaryTempB + 2
    If _2BCD_Byte.2 = 1 Then _BcdBinaryTempB = _BcdBinaryTempB + 4
    If _2BCD_Byte.3 = 1 Then _BcdBinaryTempB = _BcdBinaryTempB + 8
    If _2BCD_Byte.4 = 1 Then _BcdBinaryTempB = _BcdBinaryTempB + 10
    If _2BCD_Byte.5 = 1 Then _BcdBinaryTempB = _BcdBinaryTempB + 20      
    If _2BCD_Byte.6 = 1 Then _BcdBinaryTempB = _BcdBinaryTempB + 40
    If _2BCD_Byte.7 = 1 Then _BcdBinaryTempB = _BcdBinaryTempB + 80
    Return
#endIfMacro-    
$endif
'*******************************************************************************
'* Name    : WordTo5BCD                                                        *
'* Purpose : Convert a binary Word To 5 BCD Bytes (Array)                      *
'* Input   : Variable (Byte)                                                   *
'* Output  : Return_Type (Array 5 Bytes)                                       *
'* Syntax  : WordTo5BCD(Value (Word), Mode (Bit))                              *
'* Notes   : The Results could be BCD or ASCII depending of Mode               *
'*******************************************************************************
' If Mode = 0 The result in the array is BCD Byte. 
' If Mode = 1 The array in the array is ASCII Byte.

$ifdef _WordTo5BCD_
' Declare Global variables
    Dim BCDArray[5] As Byte 

' Declare local variables
' Definition of local Words
$ifndef _LVWS_Block1_
    $define _LVWS_Block1_
    Dim LVSWord1 As Word System     ' Local Variable System Word1
    Dim LVSWord2 As Word System     ' Local Variable System Word2
$endif

    Dim OutMode      As LVSByte1
    Dim TempWordLib  As LVSWord1
    Dim Temp2WordLib As LVSWord2

$define WordTo5BCD(pValue1, pValue2) _mWord_to_5BCD pValue1, pValue2
    
_mWord_to_5BCD Macro pValue1, pValue2 
    #if (Prm_Count > 2)
	   #error "_mWord_to_5BCD - Too many parameters"
       Exitm
    #else
        #if (Prm_Count < 2)
            #error "_mWord_to_5BCD - Too few parameters"
            Exitm
        #else
            #if (Prm_1 != Word) && (Prm_1 != Byte) && (Prm_1 != Num16) && (Prm_1 != Num8)
                #error "_mWord_to_5BCD - (Param1) Should be a Byte/Word variable or a Number8 or Number16" 
            #endif
            #if (Prm_2 != Byte) && (Prm_2 != Num8)
                #error "_mWord_to_5BCD - (Param2) Should be a Byte or a Number8" 
            #endif
            #if (Prm_1 == Word)            
                Word_Word pValue1, TempWordLib
            #endif
            #if (Prm_1 == Byte)            
                Byte_Word pValue1, TempWordLib
            #endif 
            #if (Prm_1 == Num16)            
                Num_Word pValue1, TempWordLib
            #endif
            #if (Prm_1 == Num8)            
                Num_Word pValue1, TempWordLib
            #endif
            #if (Prm_2 == Byte)            
                Byte_Byte pValue2, OutMode
            #endif                        
            #if (Prm_2 == Num8)            
                Num_Byte pValue2, OutMode
            #endif
            GoSub _WordBin_5BCD_Sub            
        #endif
    #endif
Endm

#ifMacro- _mWord_to_5BCD    
_WordBin_5BCD_Sub:
    BCDArray#0 =    TempWordLib / 10000     '= 6        '6 X 10.000 'BYTE
    TempWordLib =   TempWordLib // 10000    '= 4785                 'WORD
    Temp2WordLib =  TempWordLib // 1000     '= 785                  'WORD
    BCDArray#1 =    TempWordLib / 1000      '= 4        '4 X 1000   'BYTE
    TempWordLib =   Temp2WordLib // 100     '= 85                   'BYTE
    BCDArray#4 =    TempWordLib // 10       '= 5        '5 X 1      'BYTE
    BCDArray#2 =    Temp2WordLib / 100      '= 7        '7 X 100    'BYTE
    BCDArray#3 =    TempWordLib / 10        '= 8        '8 X 10     'BYTE
    If OutMode = 1 Then
        BCDArray#0 = BCDArray#0 + 48    ' ASCII result
        BCDArray#1 = BCDArray#1 + 48    ' ASCII result
        BCDArray#2 = BCDArray#2 + 48    ' ASCII result
        BCDArray#3 = BCDArray#3 + 48    ' ASCII result
        BCDArray#4 = BCDArray#4 + 48    ' ASCII result
    EndIf 
    Return
#endIfMacro-
$endif
'*******************************************************************************
'* Name   : GetElement                                                         *
'* Purpose: Read a byte from a large Array                                     *
'* Input    : Array Name, Index (position of a byte into the array             *
'* Output   : Return_Var (Byte)                                                *
'* Syntax   : myvar = GetElement myarray, index                                *
'* Notes    :                                                                  *
'*******************************************************************************
$ifdef _GetElement_

' Define the local variables
' Definition of local Words
$ifndef _LVWS_Block1_
    $define _LVWS_Block1_
    Dim LVSWord1 As Word System     ' Local Variable System Word1
    Dim LVSWord2 As Word System     ' Local Variable System Word2
$endif

    Dim xgpe_InpValueB As LVSByte1
    Dim xgpe_ElementNoW As LVSWord1

' Define other local variables   


'myvar = GetElement myarray, index  
$define GetElement(pMyArrayX, pIndexX) _mGetElement pMyArrayX, pIndexX

_mGetElement Macro-  pMyArrayX, pIndexX
    #if (Prm_Count > 2)
        #error "GetElement - Too many parameters!"
    #else
        #if (Prm_Count < 2)
            #error "GetElement - Too few parameters!"
        #else
            #if (Prm_1 != Byte_Array_Ptr)
                #error "GetElement - Array(Param1) Should be a BYTE array pointer!"
            #endif
            #if (Prm_2 != Byte) && (Prm_2 != Word) && (Prm_2 != Num8) && (Prm_2 != Num16)
                #error "GetElement - Element(Param2) Should be a Byte, Word variable or number6/16!"
            #endif
            #if (Prm_1 == Byte_Array_Ptr)
                Num_FSR0 pMyArrayX
            #endif
            #if (Prm_2 == Byte)
                Byte_Word pIndexX, xgpe_ElementNoW
            #endif
            #if (Prm_2 == Word)
                Word_Word pIndexX, xgpe_ElementNoW
            #endif
            #if (Prm_2 == Num8)
                Num_Word pIndexX, xgpe_ElementNoW
            #endif
            #if (Prm_2 == Num16)
                Num_Word pIndexX, xgpe_ElementNoW
            #endif
            GoSub _xGetArray_Sub
        #endif
    #endif
    #if (_mGetElement_RETURN != 1)
        #error "GetElement - Mandatory return parameter misssing!"
    #else
        #if(Return_Type != Byte)
            #error "GetElement - Return variable should be a Byte variable only!"
            Exitm
        #endif
        #if (Return_Type == Byte)
        Byte_Byte INDF0, Return_Var
        #endif
    #endif
Endm

#ifMacro- _mGetElement
_xGetArray_Sub:
    FSR0 = FSR0 + xgpe_ElementNoW 
    Return
#endIfMacro-
$endif
'****************************************************************************
'* Name   : PutElement                                                      *
'* Purpose: Write a byte to a large Array                                   *
'* Input    : Array Name, Index (position of a byte into the array, Bytte   *
'* Output   :                                                               *
'* Syntax   : PutElement myarray, index, myvar                              *
'* Notes    :                                                               *
'****************************************************************************
$ifdef _PutElement_

' Define the local variables
$ifndef _LVWS_Block1_
    $define _LVWS_Block1_
    Dim LVSWord1 As Word System     ' Local Variable System Word1
    Dim LVSWord2 As Word System     ' Local Variable System Word2
$endif

    Dim zgpe_InpValue  As LVSByte1
    Dim zgpe_ElementNo As LVSWord1

' Define other local variables   
 

'PutElement myarray, index, myvar  
$define PutElement(pMyArrayX, pIndexX, pMyVarX) _mPutElement pMyArrayX, pIndexX, pMyVarX

_mPutElement Macro-  pMyArrayX, pIndexX, pMyVarX
    #if (Prm_Count > 3)
        #error "PutElement - Too many parameters!"
    #else
        #if (Prm_Count < 3)
            #error "PutElement - Too few parameters!"
        #else
            #if(Prm_1 != Byte_Array_Ptr)
                #error "PutElement - Array(Param1) Should be a BYTE array only!"
            #endif
            #if (Prm_2 != Byte) && (Prm_2 != Word) && (Prm_2 != Num8) && (Prm_2 != Num16)
                #error "PutElement - Element(Param2) Should be a Byte, a Word variable or number8/16!"
            #endif
            #if(Prm_3 != Byte) && (Prm_3 != Num8)
                #error "PutElement - Value(Param3) Should be a Byte variable or number8"
            #endif
            #if (Prm_1 == Byte_Array_Ptr)
                Num_FSR0 pMyArrayX
            #endif
            #if (Prm_2 == Byte)
                Byte_Word pIndexX, zgpe_ElementNo
            #endif
            #if (Prm_2 == Word)
                Word_Word pIndexX, zgpe_ElementNo
            #endif
            #if (Prm_2 == Num8)
                Num_Word pIndexX, zgpe_ElementNo
            #endif            
            #if (Prm_2 == Num16)
                Num_Word pIndexX, zgpe_ElementNo
            #endif
            #if (Prm_3 == Byte)
                Byte_Byte pMyVarX, zgpe_InpValue
            #endif
            #if (Prm_3 == Num8)
                Num_Byte pMyVarX, zgpe_InpValue
            #endif
            GoSub _xPutArray_Sub
        #endif
    #endif
Endm

#ifMacro- _mPutElement  
_xPutArray_Sub:
    FSR0 = FSR0 + zgpe_ElementNo
    INDF0 = zgpe_InpValue
  Return
#endIfMacro-
$endif
'*******************************************************************************
'* Name    : Dword Array Load And Retrieve                                     *
'* Purpose : Load and Retreive a value from a Dword Array                      *
'* Input   : none                                                              *
'* Output  : Return_Type (Byte)                                                *
'* Syntax  : Retreive from a Dword Array                                       *
'*           Var = DwordArray Array Name , [Array Index]                       *
'* Syntax  : Load into a Dword Array                                           *
'*           DwordArray Array Name , [Array Index] , Var                       *
'* Notes   : Author: Les Johnson                                               *
'*******************************************************************************
' Dword Array Load and Retrieve Macro
'
' The Actual array is build from a single or multiple byte arrays
' If a Dword array of size 20 is required, the byte array must be four times this
' because 32-bit (Dword) variables and constants require 4 bytes to hold their value
' So create the array:
'
' Dim MyArray[80] as Byte			' Room for 20 Dword (32-bit) elements

$ifdef _DwordArray_

'$if (_core <> 16)
'    $error "DwordArray Macro only suitable For 18F devices!"
'$endif
'---------------------------------------------------------------------------------------
' Declare a Dword Array
'
' Syntax:
' DeclareDwordArray [ Array Name , Array Size ]
'
    $define Declare_DwordArray(pArrayName,pArraySize) '
    Reminders = Off                                   '
    Dim pArrayName[pArraySize * 4] As Byte            '
    Reminders = On

$define DwordArray(pArrayName, pArrayIndex, pValueToPlace ) _mDwordArray pArrayName, pArrayIndex, pValueToPlace

_mDwordArray Macro- pArrayName, pArrayIndex, pValueToPlace \ Dword
    #if ((Prm_1 != Byte_Array_Ptr) && (Prm_1 != Word_Array_Ptr))
        #error "Parameter 1 must be an Array's Name"
        Exitm
    #endif
	#if((Prm_2 == Float) || (Prm_2 == Fnum))
     	#error "DwordArray macro index value cannot be a Floating Point Variable or Constant"
    	Exitm
    #endif
    #ifdef watchdog_req
    Clrwdt
    #endif
    Asm-
    Lfsr 0,pArrayName
    Endasm-

    #if((Prm_2 == Num8) || (Prm_2 == Num16) || (Prm_2 == Num32))    ; Index is a Constant value
        #if (pArrayIndex > 0)
        Movlw ((pArrayIndex * 4) & 255)         ; Multiply index by four and extract the low byte
        Addwf FSR0L,F                           ; Add it to the value already held in FSR0L
        Movlw (((pArrayIndex * 4) >> 8) & 255)  ; Multiply index by four and extract the high byte
        Addwfc FSR0H,F                          ; Add it to the value already held in FSR0H
        #endif
    #endif

    #if(Prm_2 == Byte)                          ; Index is a Byte Variable?
        #if(pArrayIndex != WREG)
    Asm-
        Movff pArrayIndex,WREG
    Endasm-
        #endif
        Mullw 4                                 ; Multiply index by four (immune from bank changes)
        Movf PRODL,W                            ; \
        Addwf FSR0L,F                           ;  | Add it to the value already held in FSR0L\H
        Movf PRODH,W                            ;  |
        Addwfc FSR0H,F                          ; /
    #endif

    #if((Prm_2 == Word) || (Prm_2 == Dword))    ; Index is a Word or Dword Variable?
        Asm-
        Lfsr 1,pArrayIndex                      ; Load the index variable's address into FSR1
        Bcf STATUS,0                            ; \
        Rlcf POSTINC1,W                         ;  |
        Movwf PRODL                             ;  | 
        Rlcf INDF1,W                            ;  |
        Movwf PRODH                             ;  | Multiply index by four (immune from bank changes)
        Bcf STATUS,0                            ;  |
        Rlcf PRODL,F                            ;  |
        Rlcf PRODH,F                            ; /
        Movf PRODL,W                            ; \
        Addwf FSR0L,F                           ;  |
        Movf PRODH,W                            ;  | Add it To the value already held in FSR0L\H
        Addwfc FSR0H,F                          ; /
        Endasm-
    #endif
'
' Load or Retrieve from the array depending on whether the macro has an assignment variable preceeding it
    #if (_mDwordArray_Return == 0)        		; No assignment variable found, so it is a loading macro
        #if (Prm_Count != 3)
             #error "Missing Loading Operand with DwordArray macro"
        #else
            #if((Prm_3 == Num8) || (Prm_3 == Num16) || (Prm_3 == Num32) || (Prm_3 == SNum8) || (Prm_3 == SNum16) || (Prm_3 == SNum32))
            	#if((pValueToPlace & 255) == 255)
        			Setf POSTINC0
        		#else
        			#if((pValueToPlace & 255) == 0)					; Operate on low byte
        				Clrf POSTINC0
        			#else
        				Num_SFR (pValueToPlace & 255),POSTINC0
        			#endif
        		#endif
        
        		#if(((pValueToPlace >> 8) & 255) == 255)				; Operate on mid 1 byte
        			Setf POSTINC0
        		#else
        			#if(((pValueToPlace >> 8) & 255) == 0)
        				Clrf POSTINC0
        			#else
        				Num_SFR ((pValueToPlace >> 8) & 255),POSTINC0
        			#endif
        		#endif
        
        		#if(((pValueToPlace >> 16) & 255) == 255)			; Operate on mid 2 byte
        			Setf POSTINC0
        		#else
        			#if(((pValueToPlace >> 16) & 255) == 0)
        				Clrf POSTINC0
        			#else
        				Num_SFR ((pValueToPlace >> 16) & 255),POSTINC0
        			#endif
        		#endif
        
        		#if(((pValueToPlace >> 24) & 255) == 255)			; Operate on high byte
        			Setf POSTINC0
        		#else
        			#if(((pValueToPlace >> 24) & 255) == 0)
        				Clrf POSTINC0
        			#else
        				Num_SFR ((pValueToPlace >> 24) & 255),POSTINC0
        			#endif
        		#endif
        	#endif
            #if(Prm_3 == Byte)
                Asm-
            	Movff pValueToPlace,POSTINC0
            	Endasm-
                Clrf POSTINC0
            	Clrf POSTINC0
            	Clrf POSTINC0     
            #endif
        	#if(Prm_3 == Word)
                Asm-
            	Movff pValueToPlace,POSTINC0
            	Movff pValueToPlace + 1,POSTINC0
            	Endasm-
                Clrf POSTINC0
            	Clrf POSTINC0
            #endif
        	#if((Prm_3 == Dword) || (Prm_3 == Float))
                Asm-
            	Movff pValueToPlace,POSTINC0
            	Movff pValueToPlace + 1,POSTINC0
            	Movff pValueToPlace + 2,POSTINC0
            	Movff pValueToPlace + 3,POSTINC0
                Endasm-
            #endif
        #endif
    #else                               ; Otherwise it is a Retrieving macro
        Asm-
        Movff POSTINC0,Return_Var
        Movff POSTINC0,Return_Var + 1
        Movff POSTINC0,Return_Var + 2
        Movff POSTINC0,Return_Var + 3
        Endasm-
    #endif
Endm
$endif
'*******************************************************************************
'* Name    : MedianFilter                                                      *
'* Purpose : Calculate the Median value of N Array values                      *
'* Input   : none                                                              *
'* Output  : Return_Type (Byte)                                                *
'* Syntax  : ByteVar = MedianFilter(ByteArray, SamplesToTake)                  *
'* Notes   :                                                                   *
'*******************************************************************************
$ifdef _MedianFilter_

' Local variables
$ifndef _LVWS_Block1_
    $define _LVWS_Block1_
    Dim LVSWord1 As Word System     ' Local Variable System Word1
    Dim LVSWord2 As Word System     ' Local Variable System Word2
$endif

' Definition of local bits
$ifndef _LVSBitS_Block1_
    $define _LVSBitS_Block1_
    Dim LVSBitsA As Byte System     ' Local Variable System byte
$endif

     Dim qMedianFilterTemp1B   As LVSByte1
     Dim qMedianFilterTemp2B   As LVSByte2
     Dim qMedianIndexB         As LVSByte3
     Dim qMedianSamplesToTakeB As LVSByte4
     Dim qMedianFilterFSRW     As LVSWord1
     Dim qMedianSwapOccuredb   As LVSBitsA.0

$define MedianFilter(pValue1, pValue2) _nMedianFilter pValue1, pValue2

_nMedianFilter Macro  pValue1, pValue2
    #if (Prm_Count > 2)
        #error "_nMedianFilter - Too many parameters"
        Exitm
    #else
        #if (Prm_Count < 2)
            #error "_nMedianFilter - Too few parameters"
            Exitm
        #else
            #if (Prm_1 != Byte_Array_Ptr)
                #error "_nMedianFilter - Array(Param1) Should be a BYTE array"
                Exitm
            #endif
            #if (Prm_2 != Byte) && (Prm_2 != Num8) && (Prm_2 != Num16) && (Prm_2 != Num32)
                #error "_nMedianFilter - NoSamples(Param2) Should be a Byte variable or number"
            #endif
            #if (Prm_1 == Byte_Array_Ptr)
                Num_Word pValue1, qMedianFilterFSRW
            #endif
            #if (Prm_2 == Byte)
                Byte_Byte pValue2, qMedianSamplesToTakeB
            #endif
            #if (Prm_2 == Num8)
                Num_Byte pValue2, qMedianSamplesToTakeB
            #endif
            #if (Prm_2 == Num16)
                Num_Byte pValue2, qMedianSamplesToTakeB
            #endif
            #if (Prm_2 == Num32)
                Num_Byte pValue2, qMedianSamplesToTakeB
            #endif
            GoSub _nMedianFilter_Sub
        #endif
        #if (_nMedianFilter_RETURN != 1)
            #error "_nMedianFilter - Mandatory return parameter misssing"
        #else
            #if (Return_Type != Byte)
                #error "_nMedianFilter - Return variable should be a Byte variable"
            #else
                #if (Return_Type == Byte)
                    Byte_Byte qMedianFilterTemp1B, Return_Var
                #endif
            #endif
        #endif
    #endif
Endm

#ifMacro- _nMedianFilter
_nMedianFilter_Sub:
    Repeat
        qMedianSwapOccuredb = 0                                  ' CLEAR FLAG THAT INDICATES SWAP. 								
        qMedianIndexB = 0
        Repeat	
            FSR0L = qMedianFilterFSRW + qMedianIndexB             ' FOR EACH CELL OF THE ARRAY...
        	qMedianFilterTemp1B = POSTINC0
            qMedianFilterTemp2B = INDF0            
            If qMedianFilterTemp1B > qMedianFilterTemp2B Then  	' MOVE LARGER VALUES UP. 
                FSR0L = qMedianFilterFSRW + qMedianIndexB                                     
                qMedianFilterTemp2B = POSTINC0			        ' ..BY SWAPPING THEM. 
                qMedianFilterTemp1B = INDF0
                POSTDEC0 = qMedianFilterTemp2B
                INDF0 = qMedianFilterTemp1B
                qMedianSwapOccuredb = 1						    ' SET BIT IF SWAP OCCURRED.  
            EndIf
            Inc qMedianIndexB
        Until qMedianIndexB = qMedianSamplesToTakeB - 1			' CHECK OUT NEXT CELL OF THE ARRAY. 
    Until qMedianSwapOccuredb = 0								' KEEP SORTING UNTIL NO MORE SWAPS.
    FSR0L = qMedianSamplesToTakeB / 2 + qMedianFilterFSRW
    Dec FSR0L
    qMedianFilterTemp1B = INDF0
    Return 
#endIfMacro-    
$endif
'*******************************************************************************
'* Name    : BubbleSort                                                        *
'* Purpose : Performs a bubble sort On N number of elements On a Byte array    *
'          : in either direction.                                              *
'* Input   : none                                                              *
'* Output  : none                                                              *
'* Syntax  : BubbleSort(Array, Elements, Direction)                            *
'* Notes   :                                                                   *
'*******************************************************************************
' Operators:
' Array  any Byte array 
' Elements - a constant, or byte variable indicating the number of elements
'            within the array to sort 
' Direction - a constant, or byte variable indicating the direction of sorting 0 or 1.
'            Any number > 0 will be taken as 1. 1 = high numbers first 0 = low numbers first 

$ifdef _BubbleSort_ 
' Local variables    
$ifndef _LVWS_Block1_
    $define _LVWS_Block1_
    Dim LVSWord1 As Word System     ' Local Variable System Word1
    Dim LVSWord2 As Word System     ' Local Variable System Word2
$endif
' Definition of local bits
$ifndef _LVSBitS_Block1_
    $define _LVSBitS_Block1_
    Dim LVSBitsA As Byte System     ' Local Variable System byte
$endif

     Dim rBubbleSwapOccuredb   As LVSBitsA.0
     Dim rBubbleSortDirectionb As LVSBitsA.1
     Dim rBubbleSortTemp1B     As LVSByte1
     Dim rBubbleSortTemp2B     As LVSByte2
     Dim rBubbleSortIndexB     As LVSByte3
     Dim rBubbleSortElementsB  As LVSByte4
     Dim rBubbleSortFSRW       As LVSWord1

$define BubbleSort(pValue1,Pvalue2,PValue3) _mBubbleSort pValue1,Pvalue2,PValue3

_mBubbleSort Macro  pValue1,Pvalue2,PValue3
    #if (Prm_Count > 3)
        #error "_mBubbleSort - Too many parameters"
        Exitm
    #else
        #if (Prm_Count < 3)
            #error "_mBubbleSort - Too few parameters"
            Exitm
        #else
            #if (Prm_1 != Byte_Array_Ptr)
                #error "_mBubbleSort - Array(Param1) Should be a BYTE array"
            #endif
            #if (Prm_2 != Byte) && (Prm_2 != Num8) && (Prm_2 != Num16) && (Prm_2 != Num32)
                #error "_mBubbleSort - NoElements(Param2) Should be a Byte variable or number"
            #endif
            #if (Prm_3 != Byte) && (Prm_3 != Num8)
                #error "_mBubbleSort - Direction(Param3) Should be a Byte variable or number8"
            #endif
            #if (Prm_1 == Byte_Array_Ptr)
                Num_Word pValue1, rBubbleSortFSRW
            #endif
            #if (Prm_2 == Byte)
                Byte_Byte Pvalue2, rBubbleSortElementsB
            #endif
            #if (Prm_2 == Num8)
                Num_Byte Pvalue2, rBubbleSortElementsB
            #endif
            #if (Prm_2 == Num16)
                Num_Byte Pvalue2, rBubbleSortElementsB
            #endif
            #if (Prm_2 == Num32)
                Num_Byte Pvalue2, rBubbleSortElementsB
            #endif
            #if (Prm_3 == Byte)
                Byte_Bit PValue3, rBubbleSortDirectionb
            #endif
            #if (Prm_3 == Num8)
                Num_Bit PValue3, rBubbleSortDirectionb
            #endif
            GoSub _mBubbleSort_Sub
        #endif  
    #endif
Endm

#ifMacro- _mBubbleSort
_mBubbleSort_Sub:
    Repeat
        rBubbleSwapOccuredb = 0                                ' CLEAR FLAG THAT INDICATES SWAP. 								
        rBubbleSortIndexB = 0
        Repeat	
            FSR0L = rBubbleSortFSRW + rBubbleSortIndexB         ' FOR EACH CELL OF THE ARRAY...
        	rBubbleSortTemp1B = POSTINC0
            rBubbleSortTemp2B = INDF0  
            If rBubbleSortDirectionb = 0 Then
                If rBubbleSortTemp1B > rBubbleSortTemp2B Then _BubbleSortSwap_Sub ' MOVE LARGER VALUES UP.
            Else
                If rBubbleSortTemp1B< rBubbleSortTemp2B Then _BubbleSortSwap_Sub 
            EndIf
            GoTo _OverBubbleSortSwap_Sub
_BubbleSortSwap_Sub:  	                                    ' MOVE VALUES AROUND                                             
                FSR0L = rBubbleSortFSRW + rBubbleSortIndexB                                     
                rBubbleSortTemp2B = POSTINC0					' ..BY SWAPPING THEM. 
                rBubbleSortTemp1B = INDF0
                POSTDEC0 = rBubbleSortTemp2B
                INDF0 = rBubbleSortTemp1B
                rBubbleSwapOccuredb = 1						' SET BIT IF SWAP OCCURRED.  
_OverBubbleSortSwap_Sub:
            Inc rBubbleSortIndexB
        Until rBubbleSortIndexB = rBubbleSortElementsB - 1    ' CHECK OUT NEXT CELL OF THE ARRAY. 
    Until rBubbleSwapOccuredb = 0							' KEEP SORTING UNTIL NO MORE SWAPS.
    Return 
#endIfMacro-    
$endif
'*******************************************************************************
'* Name    : ManchEncode                                                       *
'* Purpose : Coding Manchester (by Les Johnson 2005)                           *
'* Input   : none                                                              *
'* Output  : Return type (Byte, Word)                                          *
'* Syntax  : ManchEncode(VarByte), ManchDecode(VarWord)                        *
'* Notes   : Method 2, using the Rol (rotate left) instruction                 *
'*******************************************************************************
$ifdef _Manchester_

'Add Local (non-persistent) variables here
$ifndef _LVWS_Block1_
    $define _LVWS_Block1_
    Dim LVSWord1 As Word System     ' Local Variable System Word1
    Dim LVSWord2 As Word System     ' Local Variable System Word2
$endif

    Dim F_Carry As STATUS.0      ' Alias the CARRY flag
    Dim InLibB     As LVSByte1   ' BYTE to ENCODE
    Dim OutLibB    As LVSByte2   ' BYTE DECODED
    Dim CountLibB  As LVSByte3   ' Bit counter
    Dim TempManchW As LVSWord1
'-------------------------------------------------------------------------------
$define ManchEncode(pValue) _mManchEncode pValue

_mManchEncode Macro- pValue
    #if (Prm_Count > 1)
	   #error "_mManchEncode - Too many parameters"
       Exitm
    #else
        #if (Prm_Count < 1)
            #error "_mManchEncode - Too few parameters"
            Exitm
        #else
            #if (Prm_1 != Byte) && (Prm_1 != Num8)
                #error "_mManchEncode - Should be a variable or a number"
                Exitm
            #else
                #if (Prm_1 == Byte) 
                    Byte_Byte pValue, InLibB         
                #endif
                #if (Prm_1 == Num8) 
                    Num_Byte pValue, InLibB         
                #endif
                GoSub mManchEncode_Sub
                #if (_mManchEncode_RETURN != 1)
                    #error "_mManchEncode - Mandatory return parameter misssing"
                #else
                    #if (Return_Type != Word)
                        #error "_mManchEncode - Return variable should be a Word variable"
                        Exitm
                    #else
                        Word_Word TempManchW, Return_Var
                    #endif
                #endif
            #endif
        #endif
    #endif                
Endm

' CONVERT BYTE TO MANCHESTER WORD
' Data to convert is in InLibB
' Result is in TempManchW
'
#ifMacro- _mManchEncode
mManchEncode_Sub:
    CountLibB = 8                   ' 8 bits per byte
EN_REPEAT:                          ' Create a loop for All the bits
    Rol InLibB                   ' Rotate in order to test the CARRY flag
    If F_Carry = 1 Then             ' Bit to convert = 1 ?
        Rol TempManchW, Set      ' Place '1' into manchester bytes
        Rol TempManchW, Clear    ' Place '0' into manchester bytes
    Else                            ' Bit to convert = 0
        Rol TempManchW, Clear    ' Place '0' into manchester bytes
        Rol TempManchW, Set      ' Place '1' into manchester bytes
    EndIf
    Declare Reminders = Off
    Djnz CountLibB, EN_REPEAT       ' Close the loop
    Declare Reminders = On
    Return
#endIfMacro-
'-------------------------------------------------------------------------------
$define ManchDecode(pValue) _mManchDecode pValue

_mManchDecode Macro- pValue
    #if (Prm_Count > 1)
	   #error "_mManchDecode - Too many parameters"
       Exitm
    #else
        #if (Prm_Count < 1)
            #error "_mManchDecode - Too few parameters"
            Exitm
        #else
            #if(Prm_1 != Word) && (Prm_1 != Num16)
                #error "_mManchDecode - Should be a variable or a number"
                Exitm
            #endif
            #if (Prm_1 == Word) 
                Word_Word pValue, TempManchW         
            #endif
            #if (Prm_1 == Num16) 
                Num_Word pValue, TempManchW         
            #endif
            GoSub mManch_Decode_Sub
        #endif
    #endif
    #if (_mManchDecode_RETURN != 1)
        #error "_mManchDecode - Mandatory return parameter misssing"
    #else
        #if (Return_Type != Byte)
            #error "_mManchDecode - Return variable should be a Byte variable"
            Exitm
        #else
            Byte_Byte OutLibB, Return_Var
        #endif
    #endif
Endm
'
' CONVERT MANCHESTER WORD TO BYTE
' Data to convert is in TempManchW
' Data is returned in OutLibB
' TempManchW remains untouched
'
' BIT PATTERN 10 - RESULT BIT = 1
' BIT PATTERN 01 - RESULT BIT = 0
'
#ifMacro- _mManchDecode
mManch_Decode_Sub:
    CountLibB = 8                   ' 8 bit pairs to convert
DE_REPEAT:                          ' Create a loop for All the bits
    Rol TempManchW               ' 1st bit determines result bit
    Rol OutLibB                  ' Rotate CARRY flag into BYTEOUT
    Rol TempManchW               ' skip unused 2nd bit
    Declare Reminders = Off
    Djnz CountLibB, DE_REPEAT       ' Close the loop
    Declare Reminders = On
    Return
#endIfMacro-    
$endif
'*******************************************************************************
'* Name    : GetParity                                                         *
'* Purpose : Get the parity of a Byte                                          *
'* Input   : Byte                                                              *
'* Output  : Return type (Byte)                                                *
'* Syntax  : Var1 = GetParity(VarByte)                                         *
'* Notes   :                                                                   *
'*******************************************************************************
$ifdef _GetParity_
'
' Declare local (non-persistent) variables
    Dim _ParityTempB As LVSByte1   ' BYTE to ENCODE  

$define GetParity(pValue) _mGetParity pValue

_mGetParity Macro- pValue 
    #if (Prm_Count > 1) 
        #error "_mGetParity - Too many parameters" 
    #else 
        #if (Prm_Count < 1) 
            #error "_mGetParity - Too few parameters" 
            Exitm
        #else 
            #if (Prm_1 != Byte) && (Prm_1 != Num8) 
                #error "_mGetParity - DataByte(Param1) Should be a Byte variable or number 0-255" 
                Exitm
            #endif 
            #if (Prm_1 == Byte) 
                Byte_Byte pValue, _ParityTempB 
            #endif 
            #if (Prm_1 == Num8) 
                Num_Byte pValue, _ParityTempB 
            #endif 
            GoSub _mGetParity_Sub 
        #endif 
        #if (_mGetParity_RETURN != 1) 
            #error "_mGetParity - Mandatory return parameter misssing"
            Exitm 
        #else 
            #if (Return_Type != Byte) 
                #error "_mGetParity - Return variable should be a Byte" 
                Exitm
            #else 
                Byte_Byte _ParityTempB, Return_Var 
            #endif 
        #endif 
    #endif 
Endm 
'
#ifMacro- _mGetParity
_mGetParity_Sub:
Asm
    Swapf  _ParityTempB,W,0
    Xorwf  _ParityTempB,F,0
    ;rrf    _ParityTempB,W
    Rrcf   _ParityTempB,W,0
    Xorwf  _ParityTempB,F,0
    Btfsc  _ParityTempB,2,0
    Incf   _ParityTempB,F,0
EndAsm
    If _ParityTempB.0 = 1 Then 
        _ParityTempB = 1
    Else
        _ParityTempB = 0
    EndIf
    Return
#endIfMacro-
$endif
'*******************************************************************************
'* Name    : Clear_LCDChrs                                                     *
'* Purpose : Clear N number of Chareacters On Line 1 Or 2                      *
'* Input   : none                                                              *
'* Output  : none                                                              *
'* Syntax  : Clear_LCDChrs(Row,Column,Number Chars)                            *
'* Notes   :                                                                   *
'*******************************************************************************
'' Define the Local variables used 
'    Dim zCUR_Row   As LVSByte1
'    Dim zCUR_Col   As LVSByte2
'    Dim zCUR_Chrs  As LVSByte3
'    Dim zLCD_Index As LVSByte4

'$define Clear_LCDChrs(pValue1,pValue2,pValue3) mClear_Chrs pValue1,pValue2,pValue3

'mClear_Chrs Macro- pValue1,pValue2,pValue3
'    #if (Prm_Count > 3)
'	   #error "mClear_Chrs - Too many parameters"
'       Exitm
'    #else
'        #if (Prm_Count < 3)
'            #error "mClear_Chrs - Too few parameters"
'            Exitm
'        #else
'            #if (Prm_1 != Byte) && (Prm_1 != Num8)
'                #error "mClear_Chrs - (Param1) Should be a Byte or Num8"
'                Exitm
'            #endif
'            #if (Prm_2 != Byte) && (Prm_2 != Num8)
'                #error "mClear_Chrs - (Param2) Should be a Byte Or Num8"
'                Exitm
'            #endif
'            #if (Prm_3 != Byte) && (Prm_3 != Num8)
'                #error "mClear_Chrs - (Param3) Should be a Byte Or Num8"
'                Exitm                                
'            #else
'                #if (Prm_1 == Byte) 
'                    Byte_Byte pValue1,zCUR_Row         
'                #endif
'                #if (Prm_1 == Num8) 
'                    Num_Byte pValue1,zCUR_Row         
'                #endif
'                #if (Prm_2 == Byte) 
'                    Byte_Byte pValue2,zCUR_Col         
'                #endif   
'                #if (Prm_2 == Num8) 
'                    Num_Byte pValue2,zCUR_Col         
'                #endif                 
'                #if (Prm_3 == Byte) 
'                    Byte_Byte pValue3,zCUR_Chrs         
'                #endif   
'                #if (Prm_3 == Num8) 
'                    Num_Byte pValue3,zCUR_Chrs         
'                #endif                
'                GoSub mClear_Chrs_Sub
'            #endif
'        #endif
'    #endif
'Endm

'#ifMacro- mClear_Chrs
'mClear_Chrs_Sub:
'    ' Checking the correct values.
'    If zCUR_Row > __LCD_LINES Then
'        zCUR_Row = __LCD_LINES
'    EndIf
'    If zCUR_Col > __LCD_CharsLenght Then
'        zCUR_Col = __LCD_CharsLenght - 1
'    EndIf

'    Cursor zCUR_Row,zCUR_Col        ' Set the Cursor to the line= Row, Column1
'    zLCD_Index = 0
'    Repeat
'        Print $20                   ' Send a SPACE to the LCD
'        Inc zLCD_Index              ' Increment the index
'    Until zLCD_Index > zCUR_Chrs    ' Until the last number of characters deleted
'    Cursor zCUR_Row,zCUR_Col        ' Set the Cursor to the Origin position.
'    Return
'#endIfMacro-
'*******************************************************************************
'* Name    : CLL                                                               *
'* Purpose : Alternative To the standard Proton Cls command                    *
'* Input   : none                                                              *
'* Output  : none                                                              *
'* Syntax  : CLL {Line, {Pos}} Command                                         *
'* Notes   : This command takes a long time! 0,5mS                             *
'*******************************************************************************
' For users still using an alphanumeric LCD this provides a useful enhanced
' alternative to the standard Proton CLS command.  When invoked with no parameters
' it will perform a standard Proton CLS, however, if you add a line number argument
' it will clear just that line, if you add a second argument (Position) it will clear
' from that position to the end of the line leaving the cursor at the beginning of the clear.
'
' CLL {Line, {Pos}} Command
'
'      With no arguments same as proton CLS
'
'      With 1 argument (Line), clears line specified in argument
'      Con 1 argumento (Linea), borra la lnea especificada en el argumento
'
'      With 2 arguments (Line, Pos), clears to end of Line from Position
'      Con 2 argumentos (Linea, Posicin), borra el final de la lnea desde el argumento Posicin
'
    Dim bCUR_RowB   As LVSByte1
    Dim bCUR_ColB   As LVSByte2
    Dim bCUR_ChrsB  As LVSByte3

$define CLL(pValue1,pValue2) _mCLL pValue1,pValue2
 
_mCLL Macro- pValue1,pValue2
    #if (Prm_Count == 0)
    Cls    ' Here is the additional code added after the generator has produced the outline
    #else
        #if (Prm_Count == 1)           
            #if (Prm_1 != Byte) && (Prm_1 != Num8) && (Prm_1 != Num16) && (Prm_1 != Num32)
                #error "_mCLL - Line(Param 1) should be a Byte variable or number"
            #endif
            #if (Prm_1 == Byte)
                Byte_Byte pValue1, bCUR_RowB
            #endif
            #if (Prm_1 == Num8)
                Num_Byte pValue1, bCUR_RowB
            #endif
            #if (Prm_1 == Num16)
                Num_Byte pValue1, bCUR_RowB
            #endif
            #if (Prm_1 == Num32)
                Num_Byte pValue1, bCUR_RowB
            #endif
            bCUR_ColB = 1
        #endif
        #if (Prm_Count == 2)
            #if (Prm_1 != Byte) && (Prm_1 != Num8) && (Prm_1 != Num16) && (Prm_1 != Num32)
                #error "_mCLL - Line(Param 1) should be a Byte variable or number"
            #endif
            #if (Prm_1 == Byte)
                Byte_Byte pValue1, bCUR_RowB
            #endif
            #if (Prm_1 == Num8)
                Num_Byte pValue1, bCUR_RowB
            #endif
            #if (Prm_1 == Num16)
                Num_Byte pValue1, bCUR_RowB
            #endif
            #if (Prm_1 == Num32)
                Num_Byte pValue1, bCUR_RowB
            #endif

            #if (Prm_2 != Byte) && (Prm_2 != Num8) && (Prm_2 != Num16) && (Prm_2 != Num32)
                #error "_mCLL - Pos(Param 2) should be a Byte variable or number"
            #endif
            #if (Prm_2 == Byte)
                Byte_Byte pValue2, bCUR_ColB
            #endif
            #if (Prm_2 == Num8)
                Num_Byte pValue2, bCUR_ColB
            #endif
            #if (Prm_2 == Num16)
                Num_Byte pValue2, bCUR_ColB
            #endif
            #if (Prm_2 == Num32)
                Num_Byte pValue2, bCUR_ColB
            #endif
        #endif
        GoSub _mCLL_Sub
    #endif
Endm

#ifMacro- _mCLL
_mCLL_Sub:
    ' Checking the correct values.
    If bCUR_RowB > __LCD_LINES Then
        bCUR_RowB = __LCD_LINES
    EndIf
    If bCUR_ColB > __LCD_CharsLenght Then
        bCUR_ColB = __LCD_CharsLenght - 1
    EndIf

    Cursor bCUR_RowB, bCUR_ColB
    bCUR_ChrsB = __LCD_CharsLenght - bCUR_ColB + 1
    Repeat
        Print $20                   ' Send a SPACE to the LCD
        Dec bCUR_ChrsB               ' Increment the index
    Until bCUR_ChrsB = 0             ' Until the last number of characters deleted
    Cursor bCUR_RowB,bCUR_ColB        ' Set the Cursor to the Origin position.
    Return
#endIfMacro-
'Note  This macro requires a constant __LCD_CharsLenght to be defined to reflect your
' hardware configuration.  E.g. Symbol __LCD_CharsLenght = 16 for a 16 character display. 
'*******************************************************************************
'* Name    : CountUntil                                                        *
'* Purpose : Write a "SPACE" To the LCD column 1 To column 16, Row1, And       *
'*           place the Cursor in column1, Row1.                                *
'* Input   : none                                                              *
'* Output  : none                                                              *
'* Syntax  : LCD_Clear_Row1()                                                  *
'* Notes   : This command takes a long time! 0,5mS                             *
'*******************************************************************************
$ifdef _CountUntil_

' Aliases locals Word and Byte variables  (Only For this File)
$ifndef _LVWS_Block1_
    $define _LVWS_Block1_
    Dim LVSWord1 As Word System     ' Local Variable System Word1
    Dim LVSWord2 As Word System     ' Local Variable System Word2
$endif
' Definition of local bits
$ifndef _LVSBitS_Block1_
    $define _LVSBitS_Block1_
    Dim LVSBitsA As Byte System     ' Local Variable System byte
$endif

    Dim _CounterStopPortB  As LVSByte1    ' Number of CR to send
    Dim _CounterStopPinB   As LVSByte2    ' Temp variable
    Dim _CounterInputPortB As LVSByte3    ' Number of the string to send
    Dim _CounterInputPinB  As LVSByte4
    Dim _CountW            As LVSWord1

    Dim _CounterStopValb As LVSBitsA.0
    Dim _OKCountb        As LVSBitsA.1
    Dim _CounterBitTempb As LVSBitsA.2

$define CountUntil(pCountPort,pCounterPin,pCounterStopPort,pCounterStopPin,pCounterStopValue) CountUntilM pCountPort,pCounterPin,pCounterStopPort,pCounterStopPin,pCounterStopValue 

'CountUntilM Macro  CountPort, CounterPin, CounterStopPort, CounterStopPin, CounterStopValue 
CountUntilM Macro-  pCountPort,pCounterPin,pCounterStopPort,pCounterStopPin,pCounterStopValue 
    #if (Prm_Count > 5) 
        #error "CountUntil - Too many parameters" 
    #else 
        #if (Prm_Count < 5) 
            #error "CountUntil - Too few parameters" 
        #else 
            #if(Prm_1 != Num8) && (Prm_1 != Byte) 
                #error "CountUntil - CountPort(Param1) Should be a Valid Port" 
            #endif 
            #if(Prm_2 != Byte) && (Prm_2 != Num8) 
                #error "CountUntil - CounterPin(Param2) Should be a Byte variable or number" 
            #endif 
            #if (Prm_3 != Num8) && (Prm_3 != Byte) 
                #error "CountUntil - CounterStopPort(Param3) Should be a Valid Port" 
            #endif 
            #if(Prm_4 != Byte) && (Prm_4 != Num8) 
                #error "CountUntil - CounterStopPin(Param4) Should be a Byte variable or number" 
            #endif 
            #if(Prm_5 != Byte) && (Prm_4 != Num8) 
                #error "CountUntil - CounterStopValue(Param5) Should be a Byte variable or number" 
            #endif 
            #if (Prm_1 == Byte) 
                Num_Byte pCountPort, _CounterInputPortB 
            #endif                                       
            #if (Prm_1 == Num8) 
                Num_Byte pCountPort, _CounterInputPortB          
            #endif 
            #if (Prm_2 == Byte) 
                Byte_Byte pCounterPin, PRODL 
            #endif 
            #if (Prm_2 == Num8) 
                Num_Byte pCounterPin, PRODL 
            #endif 
            #if (Prm_3 == Byte) 
                Num_Byte pCounterStopPort, _CounterStopPortB 
            #endif   
            #if (Prm_3 == Num8) 
                Num_Byte pCounterStopPort, _CounterStopPortB 
            #endif 
            #if (Prm_4 == Byte) 
                Byte_Byte pCounterStopPin, PRODH 
            #endif 
            #if (Prm_4 == Num8) 
                Num_Byte pCounterStopPin, PRODH 
            #endif 
            #if (Prm_5 == Byte) 
                Byte_Bit P5, _CounterStopValb 
            #endif 
            #if (Prm_5 == Num8) 
                Num_Bit pCounterStopValue, _CounterStopValb 
            #endif 
            GoSub CounterUntilM2_Sub 
        #endif 
        #if (CountUntilM_RETURN != 1) 
            #error "CountUntilM - Mandatory return parameter misssing" 
        #else 
            #if(Return_Type !=Word) && (Return_Type !=Byte) && (Return_Type !=Dword) 
                #error "CountUntilM - Return variable should be a Word, Byte, DWord variable" 
            #else 
                #if (Return_Type == Dword) 
                    Word_Word _CountW, Return_Var 
                #endif 
                #if (Return_Type == Word) 
                    Word_Word _CountW, Return_Var 
                #endif 
                #if (Return_Type == Byte) 
                    Byte_Word _CountW, Return_Var 
                #endif 
            #endif 
        #endif 
    #endif 
Endm 
'
#ifMacro- CountUntilM
CounterUntilM2_Sub:
    _CounterInputPinB = _CounterInputPinB & 7
    _CounterInputPinB = 1 <<  PRODL
 
    _CounterStopPinB = _CounterStopPinB & 7
    _CounterStopPinB = 1 <<  PRODH
    FSR0H = $0F                      ' We have to ensure we stay in the top bank
    _OKCountb = 0                     ' Clear this bit to start with
 
    #if _CounterInputPinB >= Bank0_End
        #error "CountUntil variables must reside within bank 0" 
    #endif
Asm
cnt#loop     
    Movf _CounterStopPortB,W          ; get the address of the Stop port
    Movwf FSR0L
    ;movfw INDF0
    Movf INDF0,W
    Andwf _CounterStopPinB,W          ; mask to leave the bit  
    Bcf _CounterBitTempb              ; preset a _TEMP_BYTE bit
    Btfss STATUS,2                   ; check to see if the bit was clear
    Bsf _CounterBitTempb              ; bit not clear so clear the flag
    Clrw                             ; now check if that value is the stop value
    Btfsc _CounterStopValb            ; 
    Addlw 1
    Btfsc _CounterBitTempb 
    Sublw 1
    Btfsc STATUS,2
    Bra CNT#EXIT                     ; make sure we leave properly
    Movf _CounterInputPortB,W         ; get the address of the counter port
    Movwf FSR0L
    ;movfw INDF0
    Movf INDF0,W
    Andwf _CounterInputPinB,W         ; mask of to leave the input bit
    Btfss STATUS,2                   ; check the value of the port
    Bra cnt#exit2             	     ; bit is not zero so see if we can up the count   
    Bsf _OKCountb                     ; bit is clear so next high we can count 
    GoTo cnt#loop
cnt#exit2                               
    Btfss _OKCountb                   ; if it's ok to count do so
    Bra cnt#loop                     ; nop so round the loop
    Bcf _OKCountb                     ; clear the flag so we don't count twice
    Incf _CountW,F                    ; now inc the word var
    Btfsc STATUS,2
    Incf _CountH,F 
    Bra cnt#loop                     ; round the loop 
CNT#EXIT
EndAsm       
    Return
#endIfMacro-
$endif
'*******************************************************************************
'* Name    : HRSOutArrayAscii                                                  *
'* Purpose : Write the characters of the Array                                 *
'*           place the Cursor in column1, Row1.                                *
'* Input   : none                                                              *
'* Output  : none                                                              *
'* Syntax  : LCD_Clear_Row1()                                                  *
'* Notes   : This command takes a long time! 0,5mS                             *
'*******************************************************************************

'$ifndef _mya_FSR0_Var
'    $define _mya_FSR0_Var
'    Dim mya_FSR0W As LVSWord1
'    Dim mya_FSR1W As LVSWord2
'$endif
    
'' Now define the aliases of this library.
'    Dim mya_Offset   As LVSByte1   ' As Local Variable
'    Dim mya_Index    As LVSByte2   ' As Local Variable
'    Dim mya_DataByte As LVSByte3   ' As Local Variable

'$define HRSOutArrayAscii(pArrayInp, pOffset, pNbBytes) _mHRSOutArrayASCII pArrayInp, pOffset, pNbBytes

'_mHRSOutArrayASCII Macro- pArrayInp, pOffset, pNbBytes
'#if (Prm_Count > 3)
'    #error "_mHRSOutArrayASCII - Too many parameters"
'    Exitm
'#else
'    #if (Prm_Count < 3)
'        #error "_mHRSOutArrayASCII - Too few parameters"
'        Exitm
'    #else
'        #if (Prm_1 != Byte_Array_Ptr) && (Prm_1 != String)
'            #error "_mHRSOutArrayASCII - ByteArray -(Param1) Should be a Byte Array or String"
'            Exitm
'        #else
'            GoSub MyA_SaveFSR0_Sub
'            #if (Prm_1 == Byte_Array_Ptr)
'                Num_FSR0 pArrayInp
'            #endif
'            #if(Prm_1 == String)
'                Num_FSR0 pArrayInp
'            #endif
'        #endif

'        #if (Prm_2 != Byte) && (Prm_2 != Num8)
'            #error "_mHRSOutArrayASCII - Offset -(Param2) Should be a Byte or a Num8"
'            Exitm
'        #else
'            #if(Prm_2 == Byte)
'                Byte_Byte pOffset, mya_Offset
'            #endif
'            #if(Prm_2 == Num8)
'                Num_Byte pOffset, mya_Offset
'            #endif
'        #endif

'        #if (Prm_3 != Byte) && (Prm_3 != Num8)
'            #error "_mHRSOutArrayASCII - Number Parameters -(Param2) Should be a Byte or a Num8"
'            Exitm
'        #else
'            #if(Prm_3 == Byte)
'                Byte_Byte pNbBytes, mya_Index
'            #endif
'            #if(Prm_3 == Num8)
'                Num_Byte pNbBytes, mya_Index
'            #endif
'        #endif
'        GoSub _mHRSOutArrayAscii_Sub
'        GoSub MyA_RestoreFSR0_Sub
'    #endif
'#endif
'Endm

'#ifMacro- _mHRSOutArrayASCII
'_mHRSOutArrayAscii_Sub:
'    If mya_Index = 0 Then Return
'    FSR0 = FSR0 + mya_Offset         ' Add the offset to FSR0
'    Repeat
'        #ifdef watchdog_req
'        Clrwdt
'        #endif
'        mya_DataByte = POSTINC0      ' Reading the array
'        _HRSOut mya_DataByte          ' Send the byte to the terminal
'        '_HRSOut " "
'        Dec mya_Index
'    Until mya_Index = 0
'    _HRSOut CR
'    Return    
'#endIfMacro-

'$define HRSOutArrayASC(pArrayInp, pOffset, pNbBytes) _mHRSOutArrayASCSp pArrayInp, pOffset, pNbBytes

'_mHRSOutArrayASCSp Macro- pArrayInp, pOffset, pNbBytes
'#if (Prm_Count > 3)
'    #error "_mHRSOutArrayASCSp - Too many parameters"
'    Exitm
'#else
'    #if (Prm_Count < 3)
'        #error "_mHRSOutArrayASCSp - Too few parameters"
'        Exitm
'    #else
'        #if (Prm_1 != Byte_Array_Ptr) && (Prm_1 != String)
'            #error "_mHRSOutArrayASCSp - ByteArray -(Param1) Should be a Byte Array or String"
'            Exitm
'        #else
'            GoSub MyA_SaveFSR0_Sub
'            #if (Prm_1 == Byte_Array_Ptr)
'                Num_FSR0 pArrayInp
'            #endif
'            #if(Prm_1 == String)
'                Num_FSR0 pArrayInp
'            #endif
'        #endif

'        #if (Prm_2 != Byte) && (Prm_2 != Num8)
'            #error "_mHRSOutArrayASCSp - Offset -(Param2) Should be a Byte or a Num8"
'            Exitm
'        #else
'            #if(Prm_2 == Byte)
'                Byte_Byte pOffset, mya_Offset
'            #endif
'            #if(Prm_2 == Num8)
'                Num_Byte pOffset, mya_Offset
'            #endif
'        #endif

'        #if (Prm_3 != Byte) && (Prm_3 != Num8)
'            #error "_mHRSOutArrayASCSp - Number Parameters -(Param2) Should be a Byte or a Num8"
'            Exitm
'        #else
'            #if(Prm_3 == Byte)
'                Byte_Byte pNbBytes, mya_Index
'            #endif
'            #if(Prm_3 == Num8)
'                Num_Byte pNbBytes, mya_Index
'            #endif
'        #endif
'        GoSub mHRSOutArrayASCSp_Sub
'        GoSub MyA_RestoreFSR0_Sub
'    #endif
'#endif
'Endm

'#ifMacro- _mHRSOutArrayASCSp
'mHRSOutArrayASCSp_Sub:
'    If mya_Index = 0 Then Return
'    FSR0 = FSR0 + mya_Offset         ' Add the offset to FSR0
'    Repeat
'        #ifdef watchdog_req
'        Clrwdt
'        #endif
'        mya_DataByte = POSTINC0      ' Reading the array
'        If mya_DataByte > 31 Then
'            Select mya_DataByte
'                Case 127, $8D, $98, $A0
'                    _HRSOut "?"
'                Case Else
'                    _HRSOut mya_DataByte  ' Send the byte to the terminal
'            EndSelect
'        Else
'            _HRSOut "?"
'        EndIf
'        _HRSOut "  "
'        Dec mya_Index
'    Until mya_Index = 0
'    _HRSOut CR
'    Return    
'#endIfMacro-
'*******************************************************************************
'* Name Macro   : HRSArrayHex                                                  *
'* Purpose      : Send bytes of an array to the terminal in HEX format         *
'*                                                                             *
'* Input    : Array Name,Offset position,Number of Bytes                       *
'* Output   :                                                                  *
'* Notes    :                                                                  *
'* Syntax   : HRSOutArrayHex(Array Name,Offset position,Number of Bytes)       *
'*******************************************************************************
'
'$define HRSArrayHex(pArrayInp,pOffset,pNbBytes) _mHRSOutArrayHex pArrayInp,pOffset,pNbBytes

'_mHRSOutArrayHex Macro- pArrayInp,pOffset,pNbBytes
'#if (Prm_Count > 3)
'    #error "_mHRSOutArrayHex - Too many parameters"
'    Exitm
'#else
'    #if (Prm_Count < 3)
'        #error "_mHRSOutArrayHex - Too few parameters"
'        Exitm
'    #else
'        #if (Prm_1 != Byte_Array_Ptr) && (Prm_1 != String)
'            #error "_mHRSOutArrayHex - ByteArray -(Param1) Should be a Byte Array or String"
'            Exitm
'        #else
'            GoSub MyA_SaveFSR0_Sub
'            #if (Prm_1 == Byte_Array_Ptr)
'                Num_FSR0 pArrayInp
'            #endif
'            #if(Prm_1 == String)
'                Num_FSR0 pArrayInp
'            #endif
'        #endif

'        #if (Prm_2 != Byte) && (Prm_2 != Num8)
'            #error "_mHRSOutArrayHex - Offset -(Param2) Should be a Byte or a Num8"
'            Exitm
'        #else
'            #if(Prm_2 == Byte)
'                Byte_Byte pOffset, mya_Offset
'            #endif
'            #if(Prm_2 == Num8)
'                Num_Byte pOffset, mya_Offset
'            #endif
'        #endif

'        #if (Prm_3 != Byte) && (Prm_3 != Num8)
'            #error "_mHRSOutArrayHex - Number Parameters - (Param3) Should be a Byte or a Num8"
'            Exitm
'        #else
'            #if(Prm_3 == Byte)
'                Byte_Byte pNbBytes, mya_Index
'            #endif
'            #if(Prm_3 == Num8)
'                Num_Byte pNbBytes, mya_Index
'            #endif
'        #endif
'        GoSub _mHRSOutArrayhex_Sub
'        GoSub MyA_RestoreFSR0_Sub
'    #endif
'#endif
'Endm

'#ifMacro- _mHRSOutArrayHex
'_mHRSOutArrayhex_Sub:
'    If mya_Index = 0 Then Return
'    FSR0 = FSR0 + mya_Offset         ' Add the offset to FSR1
'    Repeat
'        #ifdef watchdog_req
'        Clrwdt
'        #endif
'        mya_DataByte = POSTINC0      ' Reading the array
'        _HRSOut Hex2 mya_DataByte     ' Send the byte to the terminal
'        _HRSOut " "
'        Dec mya_Index
'    Until mya_Index = 0
'    _HRSOut CR
'    Return    
'#endIfMacro-
'*******************************************************************************
'* Send Arrays Bytes to the Terminal                                           *
'* Name Macro   : HRSOutArrayDec                                               *
'* Purpose      : Send bytes of an array to the terminal in Dec format         *
'*                                                                             *
'* Input    : Array Name,Offset position,Number of Bytes                       *
'* Output   :                                                                  *
'* Notes    :                                                                  *
'* Syntax   : HRSOutArrayDec(Array Name, Offset position, Number of Bytes)     *
'*******************************************************************************
'
'$define HRSOutArrayDec(pArrayInp,pOffset,pNbBytes) _mHRSOutArrayDec pArrayInp,pOffset,pNbBytes

'_mHRSOutArrayDec Macro- pArrayInp,pOffset,pNbBytes
'#if (Prm_Count > 3)
'    #error "_mHRSOutArrayDec - Too many parameters"
'    Exitm
'#else
'    #if (Prm_Count < 3)
'        #error "_mHRSOutArrayDec - Too few parameters"
'        Exitm
'    #else
'        #if (Prm_1 != Byte_Array_Ptr) && (Prm_1 != String)
'            #error "_mHRSOutArrayDec - ByteArray -(Param1) Should be a Byte Array or String"
'            Exitm
'        #else
'            GoSub MyA_SaveFSR0_Sub
'            #if (Prm_1 == Byte_Array_Ptr)
'                Num_FSR0 pArrayInp
'            #endif
'            #if(Prm_1 == String)
'                Num_FSR0 pArrayInp
'            #endif
'        #endif

'        #if (Prm_2 != Byte) && (Prm_2 != Num8)
'            #error "_mHRSOutArrayDec - Offset -(Param2) Should be a Byte or a Num8"
'            Exitm
'        #else
'            #if(Prm_2 == Byte)
'                Byte_Byte pOffset, mya_Offset
'            #endif
'            #if(Prm_2 == Num8)
'                Num_Byte pOffset, mya_Offset
'            #endif
'        #endif

'        #if (Prm_3 != Byte) && (Prm_3 != Num8)
'            #error "_mHRSOutArrayDec - Number Parameters - (Param3) Should be a Byte or a Num8"
'            Exitm
'        #else
'            #if(Prm_3 == Byte)
'                Byte_Byte pNbBytes, mya_Index
'            #endif
'            #if(Prm_3 == Num8)
'                Num_Byte pNbBytes, mya_Index
'            #endif
'        #endif
'        GoSub _mHRSOutArrayDec_Sub
'        GoSub MyA_RestoreFSR0_Sub
'    #endif
'#endif
'Endm

'#ifMacro- _mHRSOutArrayDec
'_mHRSOutArrayDec_Sub:
'    If mya_Index = 0 Then Return
'    FSR0 = FSR0 + mya_Offset         ' Add the offset to FSR1
'    Repeat
'        #ifdef watchdog_req
'        Clrwdt
'        #endif
'        mya_DataByte = POSTINC0      ' Reading the array
'        _HRSOut Dec mya_DataByte      ' Send the byte to the terminal
'        _HRSOut " "
'        Dec mya_Index
'    Until mya_Index = 0
'    _HRSOut CR
'    Return    
'#endIfMacro-
'*******************************************************************************
'*******************************************************************************
'* Name   : ArrayROL                                                           *
'* Purpose: Rotate All bits of an Array to the LEFT.  Not reload lowest bits   *
'* Input  : Bytes Array                                                        *
'* Ouput  : Same array                                                         *
'* Syntax : ArrayROL_NR(Array Name, Array Lenght)                              *
'* Notes  :                                                                    *
'-------------------------------------------------------------------------------
$ifdef _ArrayROL_

' Now define the aliases of this library.
$ifndef _LVWS_Block1_
    $define _LVWS_Block1_
    Dim LVSWord1 As Word System     ' Local Variable System Word1
    Dim LVSWord2 As Word System     ' Local Variable System Word2
$endif

    Dim mya_STATUS_RegB  As LVSByte1
    Dim mya_ArrayLenghtB As LVSByte2

    $ifndef _mya_FSR0_Var
        $define _mya_FSR0_Var
        Dim mya_FSR0W As LVSWord1
        Dim mya_FSR1W As LVSWord2
    $endif

$define ArrayROL(pArray,pLenght) _mArray_RolNR pArray,pLenght

_mArray_RolNR  Macro- pArray,pLenght
#if (Prm_Count > 2)
    #error "ArrayROL Macro - Too many parameters"
    Exitm
#else
    #if (Prm_Count < 2)
        #error "ArrayROL Macro - Too few parameters"
        Exitm
    #else
        #if (Prm_1 != Byte_Array_Ptr)
            #error "ArrayROL - ByteArray -(Param1) Should be a Byte Array!"
            Exitm
        #else
            GoSub MyA_SaveFSR0_Sub
            #if (Prm_1 == Byte_Array_Ptr)
                Num_FSR0 pArray
            #endif
        #endif

        #if (Prm_2 != Num8)
            #error "ArrayROL - Lenght -(Param2) Should be a Num8"
            Exitm
        #else
            #if(Prm_2 == Num8)
                #if (pLenght == 0)
                    #error "ArrayROL - Lenght -(Param1) The lenght of an array cannot be null!"
                    Exitm                    
                #endif
                Num_Byte pLenght, mya_ArrayLenghtB
            #endif
        #endif
        GoSub _mArray_RolNR_Sub
        GoSub MyA_RestoreFSR0_Sub
    #endif
#endif
Endm

#ifMacro- _mArray_RolNR
_mArray_RolNR_Sub:
    STATUS.0 = 0                    ' Clear the Carry Bit
    mya_STATUS_RegB = STATUS         ' Save the STATUS REG to mya_STATUS_RegB
    Repeat
        #ifdef watchdog_req
        Clrwdt
        #endif
        STATUS = mya_STATUS_RegB     ' Restore the STATUS REG from mya_STATUS_RegB
        Asm
        Rlcf INDF0,F,0              ' Roll All bits to the left with carry
        EndAsm
        mya_STATUS_RegB = STATUS     ' Save the STATUS REG to mya_STATUS_RegB
        Inc FSR0                    ' Modified original routine. The RAM pointer is WORD.
        Dec mya_ArrayLenghtB         ' Check if All bits are ROTATED 
    Until mya_ArrayLenghtB = 0 
    Return
#endIfMacro-
$endif
'*******************************************************************************
'* Name   : ArrayROR                                                           *
'* Purpose: Rotate All bits of an Array To the RIGHT.  Not reload lowest bits  *
'* Input  : Bytes Array                                                        *
'* Ouput  : Same array                                                         *
'* Syntax : ArrayROR(Array Name, Array Lenght)                                 *
'* Notes  :                                                                    *
'*******************************************************************************
$ifdef _ArrayROR_
$ifndef _LVWS_Block1_
    $define _LVWS_Block1_
    Dim LVSWord1 As Word System     ' Local Variable System Word1
    Dim LVSWord2 As Word System     ' Local Variable System Word2
$endif

    Dim myb_STATUS_Reg  As LVSByte1
    Dim myb_ArrayLenght As LVSByte2
    $ifndef _mya_FSR0_Var
        $define _mya_FSR0_Var
        Dim mya_FSR0W As LVSWord1
        Dim mya_FSR1W As LVSWord2
    $endif

$define ArrayROR(pArray,pLenght) _mArray_RorNR pArray,pLenght

_mArray_RorNR  Macro- pArray,pLenght
#if (Prm_Count > 2)
    #error "ArrayROR Macro - Too many parameters"
    Exitm
#else
    #if (Prm_Count < 2)
        #error "ArrayROR Macro - Too few parameters"
        Exitm
    #else
        #if (Prm_1 != Byte_Array_Ptr)
            #error "ArrayROR - ByteArray -(Param1) Should be a Byte Array!"
            Exitm
        #else
            GoSub MyA_SaveFSR0_Sub
            #if (Prm_1 == Byte_Array_Ptr)
                Num_FSR0 pArray
            #endif
        #endif

        #if (Prm_2 != Num8)
            #error "ArrayROR - Shift -(Param2) Should be a Num8"
            Exitm
        #else
            #if(Prm_2 == Num8)
                #if (pLenght == 0)
                    #error "ArrayROR - Lenght -(Param1) The lenght of an array cannot be null!"
                    Exitm                    
                #endif
                Num_Byte pLenght, myb_ArrayLenght
            #endif
        #endif
        GoSub _mArray_RorNR_Sub
        GoSub MyA_RestoreFSR0_Sub
    #endif
#endif
Endm

#ifMacro- _mArray_RorNR
_mArray_RorNR_Sub:
    STATUS.0 = 0                        ' Clear the Carry Bit
    myb_STATUS_Reg = STATUS             ' Save the STATUS to mya_STATUS_RegB 
    FSR0 = FSR0 + (myb_ArrayLenght - 1) ' Goto the upper byte of the array 
    Repeat
        #ifdef watchdog_req
        Clrwdt
        #endif
        STATUS = myb_STATUS_Reg         ' Restore the STATUS REG from mya_STATUS_RegB
        Asm
        Rrcf INDF0,F,0
        EndAsm
        myb_STATUS_Reg = STATUS         ' Save the STATUS to mya_STATUS_RegB 
        Dec FSR0                        ' Modified original routine. The RAM pointer is WORD.
        Dec myb_ArrayLenght
    Until myb_ArrayLenght = 0           ' Check if All bits are ROTATED
    Return
#endIfMacro-
$endif
'*******************************************************************************
'* Name   : ArrayROLR                                                          *
'* Purpose: Rotate All bits of an Array To the LEFT. With reload lowest bits   *
'* Input  : Bytes Array                                                        *
'* Ouput  : Same array                                                         *
'* Syntax : ArrayROLR(Array Name,Array Lenght)                                 *
'* Notes  :                                                                    *
'*******************************************************************************
$ifdef _ArrayROLR_
$ifndef _LVWS_Block1_
    $define _LVWS_Block1_
    Dim LVSWord1 As Word System     ' Local Variable System Word1
    Dim LVSWord2 As Word System     ' Local Variable System Word2
$endif

    Dim myc_STATUS_Reg  As LVSByte1
    Dim myc_ArrayLenght As LVSByte2
    $ifndef _mya_FSR0_Var
        $define _mya_FSR0_Var
        Dim mya_FSR0W As LVSWord1
        Dim mya_FSR1W As LVSWord2
    $endif

$define ArrayROLR(pArray,pLenght) _mArray_RolWR pArray,pLenght

_mArray_RolWR  Macro- pArray,pLenght
#if (Prm_Count > 2)
    #error "_mArray_RolWR Macro - Too many parameters"
    Exitm
#else
    #if (Prm_Count < 2)
        #error "_mArray_RolWR Macro - Too few parameters"
        Exitm
    #else
        #if (Prm_1 != Byte_Array_Ptr)
            #error "_mArray_RolWR - ByteArray -(Param1) Should be a Byte Array!"
            Exitm
        #else
            GoSub MyA_SaveFSR0_FSR1_Sub
            #if (Prm_1 == Byte_Array_Ptr)
                Num_FSR0 pArray
                Num_FSR1 pArray
            #endif
        #endif

        #if (Prm_2 != Num8)
            #error "_mArray_RolWR - Shift -(Param2) Should be a Num8"
            Exitm
        #else
            #if(Prm_2 == Num8)
                #if (pLenght == 0)
                    #error "_mArray_RolWR - Lenght -(Param1) The lenght of an array cannot be null!"
                    Exitm                    
                #endif
                Num_Byte pLenght, myc_ArrayLenght
            #endif
        #endif
        GoSub _mArray_RolWR_Sub
        GoSub MyA_RestoreFSR0_FSR1_Sub
    #endif
#endif
Endm

#ifMacro- _mArray_RolWR
_mArray_RolWR_Sub:
    myc_STATUS_Reg = STATUS         ' Save the STATUS to mya_STATUS_RegB
    Repeat
        #ifdef watchdog_req
        Clrwdt
        #endif
        STATUS = myc_STATUS_Reg     ' Restore the STATUS REG from mya_STATUS_RegB
        Asm
        Rlcf INDF0,F,0              ' Roll All bits to the left with carry
        EndAsm
        myc_STATUS_Reg = STATUS     ' Save the STATUS to mya_STATUS_RegB
        Inc FSR0                    ' Modified original routine. The RAM pointer is WORD.
        Dec myc_ArrayLenght         
    Until myc_ArrayLenght = 0       ' Check if All bits are ROTATED 
    Asm
    Bcf   INDF1,0,0
    Btfsc myc_STATUS_Reg,0,0        ; Check the highest bit of the highest Byte to be rotated.
    Bsf   INDF1,0,0
    EndAsm
    Return
#endIfMacro-
$endif
'*******************************************************************************
' Macro Name        : ArrayRORR
' Input Variables   : Bytes Array
' Destination       : Same array
' Definition        : Rotate All bits of an Array to the RIGHT
'                   : Not reload the highest bits
' Syntax            : ArrayRORR(Array Name, Array Lenght)
' Notes             : With reload the lowest bits
'-------------------------------------------------------------------------------
$ifdef _ArrayRORR_
$ifndef _LVWS_Block1_
    $define _LVWS_Block1_
    Dim LVSWord1 As Word System     ' Local Variable System Word1
    Dim LVSWord2 As Word System     ' Local Variable System Word2
$endif

    Dim myd_STATUS_Reg  As LVSByte1
    Dim myd_ArrayLenght As LVSByte2
    $ifndef _mya_FSR0_Var
        $define _mya_FSR0_Var
        Dim mya_FSR0W As LVSWord1
        Dim mya_FSR1W As LVSWord2
    $endif

$define ArrayRORR(pArray,pLenght) _mArray_RorWR pArray,pLenght

_mArray_RorWR  Macro- pArray,pLenght
#if (Prm_Count > 2)
    #error "_mArray_RorWR Macro - Too many parameters"
    Exitm
#else
    #if (Prm_Count < 2)
        #error "_mArray_RorWR Macro - Too few parameters"
        Exitm
    #else
        #if (Prm_1 != Byte_Array_Ptr)
            #error "_mArray_RorWR - ByteArray -(Param1) Should be a Byte Array!"
            Exitm
        #else
            GoSub MyA_SaveFSR0_FSR1_Sub
            #if (Prm_1 == Byte_Array_Ptr)
                Num_FSR0 pArray
            #endif
        #endif

        #if (Prm_2 != Num8)
            #error "_mArray_RorWR - Shift -(Param2) Should be a Byte or a Num8"
            Exitm
        #else
            #if(Prm_2 == Num8)
                #if (pLenght == 0)
                    #error "_mArray_RorWR - Lenght -(Param1) The lenght of an array cannot be null!"
                    Exitm                    
                #endif
                Num_Byte pLenght, myd_ArrayLenght
            #endif
        #endif
        GoSub _mArray_RorWR_Sub
        GoSub MyA_RestoreFSR0_FSR1_Sub
    #endif
#endif
Endm

#ifMacro- _mArray_RorWR
_mArray_RorWR_Sub:
    myd_STATUS_Reg = STATUS             ' Save the STATUS REG to mya_STATUS_RegB 
    FSR0 = FSR0 + (myd_ArrayLenght - 1) ' Goto the upper byte of the array 
    FSR1 = FSR0                         ' Copy the address of the array to FSR1
    Repeat
        #ifdef watchdog_req
        Clrwdt
        #endif
        STATUS = myd_STATUS_Reg         ' Restore the STATUS from mya_STATUS_RegB
        Asm
        Rrcf INDF0,F,0
        EndAsm
        myd_STATUS_Reg = STATUS         ' Save the STATUS REG to mya_STATUS_RegB 
        Dec FSR0
        Dec myd_ArrayLenght
    Until myd_ArrayLenght = 0           ' Check if All bits are ROTATED
    Asm
    Bcf   INDF1,7,0
    Btfsc myd_STATUS_Reg,0,0            ; Check the lowest bit of the lowest Byte to be rotated.
    Bsf   INDF1,7,0
    EndAsm
    Return
#endIfMacro-
$endif
'*******************************************************************************
$if _defined(_ArrayROL_) Or _defined(_ArrayROR_) Or _defined(_ArrayROLR_) Or _defined(_ArrayRORR_)
'#ifMacro- _mHRSOutArrayASCII, _mHRSOutArrayHex,_mArray_RolNR,_mArray_RorNR,_mArray_RolWR,_mArray_RorWR
#ifMacro- _mArray_RolNR,_mArray_RorNR,_mArray_RolWR,_mArray_RorWR
MyA_SaveFSR0_FSR1_Sub:
    mya_FSR1W = FSR1   
MyA_SaveFSR0_Sub:
    mya_FSR0W = FSR0
    Return
MyA_RestoreFSR0_FSR1_Sub:
    FSR1 = mya_FSR1W    
MyA_RestoreFSR0_Sub:
    FSR0 = mya_FSR0W
    Return    
#endIfMacro-
$endif
'*******************************************************************************
'* Name    : CheckOWCRC                                                        *
'* Purpose : Calculate the CRC of OW                                           *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   :                                                                   *
'*******************************************************************************  
$ifdef _CheckOWCRC_
$ifndef _LVBS_Block2_
    $define _LVBS_Block2_
    Dim LVSByte5 As Byte System     ' Local Variable System Byte5
    Dim LVSByte6 As Byte System     ' Local Variable System Byte6
    Dim LVSByte7 As Byte System     ' Local Variable System Byte7
    Dim LVSByte8 As Byte System     ' Local Variable System Byte8
$endif
$ifndef _LVWS_Block1_
    $define _LVWS_Block1_
    Dim LVSWord1 As Word System     ' Local Variable System Word1
    Dim LVSWord2 As Word System     ' Local Variable System Word2
$endif
' Definition of local bits
$ifndef _LVSBitS_Block1_
    $define _LVSBitS_Block1_
    Dim LVSBitsA As Byte System     ' Local Variable System byte
$endif

' Add aliases (non-persistent) variables here
    Dim OW_CRC_Calc As LVSByte1
    Dim OW_Len      As LVSByte2
    Dim OW_Byte_Ptr As LVSByte3
    Dim OW_Bit_Ptr  As LVSByte4
    Dim OW_TmpDat   As LVSByte5
    Dim OW_TstDat   As LVSByte6
    Dim OW_TstBit   As LVSBitsA.0
    Dim MemAddr     As LVSWord1 
    Dim MemMax      As LVSWord2

' Other local variable (do not use outside this file).
$ifndef FSR1_Save_Var
    $define FSR1_Save_Var
    Dim FSR1_Save As Word System
$endif 

$define CheckOWCRC(pArray, pOW_Len) _mOW_CRC pArray, pOW_Len

_mOW_CRC Macro-  pArray, pOW_Len
    #if (Prm_Count > 2) 
        #error "OW_CRC - Too many parameters" 
    #else 
        #if (Prm_Count < 2) 
            #error "OW_CRC - Too few parameters" 
        #else 
            #if(Prm_1 != Byte_Array_Ptr) 
                #error "OW_CRC - OW_DATA(Param1) Should be a BYTE array pointer" 
            #endif 
            #if(Prm_2 != Byte) && (Prm_2 != Num8) && (Prm_2 != Num16) && (Prm_2 != Num32) 
                #error "OW_CRC - OW_LEN(Param2) Should be a Byte variable or number" 
            #endif 
            FSR1_Save = FSR1       ' Save FSR1L\H register
            #if (Prm_1 == Byte_Array_Ptr) 
                Num_FSR1 pArray
            #endif 
            #if (Prm_2 == Byte) 
                Byte_Byte pOW_Len, OW_Len 
            #endif 
            #if (Prm_2 == Num8) 
                Num_Byte pOW_Len, OW_Len 
            #endif 
            #if (Prm_2 == Num16) 
                Num_Byte pOW_Len, OW_Len 
            #endif 
            #if (Prm_2 == Num32) 
                Num_Byte pOW_Len, OW_Len 
            #endif 
            GoSub Get_OW_Calc_Sub 
        #endif 
        #if (_mOW_CRC_RETURN != 1) 
            #error "OW_CRC - Mandatory return parameter misssing" 
        #else 
            #if(Return_Type !=Byte) && (Return_Type !=Word) && (Return_Type !=Dword) 
                #error "OW_CRC - Return variable should be a Byte variable or number" 
            #else 
                #if (Return_Type == Byte) 
                    Byte_Byte OW_CRC_Calc, Return_Var 
                #endif 
            #endif 
        #endif 
        FSR1 = FSR1_Save       ' Restore FSR1L\H register
    #endif 
Endm 
'
#ifMacro- _mOW_CRC
Get_OW_Calc_Sub:
    OW_CRC_Calc = 0
    OW_TstBit = 0                                   ' Set up initial CRC value
	For OW_Byte_Ptr = 0 To OW_Len -1   		   	    ' Run through All the data bytes
	   OW_TmpDat = POSTINC1                         ' Get the next data byte
	   For OW_Bit_Ptr = 0 To 7                      ' Run through each bit in data byte
	   	   OW_TstBit = OW_CRC_Calc.0 ^ OW_TmpDat.0  ' XOR bit0 of data byte with CRC bit0	   
	       OW_TmpDat = OW_TmpDat >> 1               ' Position data byte for next bit test
	       If OW_TstBit = 1 Then                    ' If test bit not set, just shift CRC
		      OW_CRC_Calc = OW_CRC_Calc ^ $18       ' If set, account for EXOR feedback
           EndIf
	   	   OW_CRC_Calc = OW_CRC_Calc >> 1           ' shift out CRC bit 0
		   OW_CRC_Calc.7 = OW_TstBit                ' Test bit rotates into CRC bit 7
	   Next
	Next                                            ' Last byte is the received CRC value should
    Return		                                    ' result in a CRC of 0.
#endIfMacro-
$endif
'*******************************************************************************
'* Name    : GetArrayBit, WriteArrayBit, SetArrayBit, ClearArrayBit            *
'* Purpose : get a bit from an array                                           *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   : GetArrayBit(pBitArray,pIndex)                                     *
'******************************************************************************* 
$ifdef _ArrayBit_
' Definition of the Local Variables of this library.
' Definition of local Bytes

' Definition of local Words

' Now define the aliases of this library.
    Dim BitArrayIndex    As LVSByte1
    Dim BitArrayTemp1    As LVSByte2
    Dim BitArrayTemp2    As LVSByte3
    Dim SetbitArrayValue As LVSByte4

$define GetArrayBit(pBitArray,pIndex) _mGetArrayBit pBitArray,pIndex

'GetArrayBitM Macro  BitArray, Index
_mGetArrayBit Macro-  pBitArray,pIndex 
    #if (Prm_Count > 2) 
        #error "GetArrayBit - Too many parameters" 
    #else 
        #if (Prm_Count < 2) 
            #error "GetArrayBit - Too few parameters" 
        #else 
            #if(Prm_1 != Byte_Array_Ptr) 
                #error "GetArrayBit - BitArray(Param1) Should be a BYTE Array" 
            #endif 
            #if(Prm_2 != Byte) && (Prm_2 != Num8) 
                #error "GetArrayBit - Index(Param2) Should be a Byte variable or number" 
            #endif 
            #if (Prm_1 == Byte_Array_Ptr) 
                Num_FSR0 pBitArray 
            #endif 
            #if (Prm_2 == Byte) 
                Byte_Byte pIndex, BitArrayIndex 
            #endif 
            #if (Prm_2 == Num8) 
                Num_Byte pIndex, BitArrayIndex 
            #endif  
            GoSub TestBitArray_Sub 
        #endif 
        #if (_mGetArrayBit_RETURN != 1) 
            #error "GetArrayBit - Mandatory return parameter misssing" 
        #else 
            #if(Return_Type !=Byte) 
                #error "GetArrayBit - Return variable should be a Byte variable" 
            #else 
                #if (Return_Type == Byte) 
                    Byte_Byte BitArrayTemp2, Return_Var 
                #endif 
            #endif 
        #endif 
    #endif 
Endm

#ifMacro- _mGetArrayBit
TestBitArray_Sub:
    GoSub SetBitArrayPointer
    BitArrayTemp1 = INDF0 >> BitArrayTemp2
    BitArrayTemp2 = BitArrayTemp1.0
    Return
#endIfMacro-
'-------------------------------------------------------------------------------
$define WriteArrayBit(pBitArray, pIndex, pValue) _mWriteArrayBit pBitArray, pIndex, pValue

'WriteArrayBitM Macro  P1, P2, P3    
_mWriteArrayBit Macro- pBitArray, pIndex, pValue
    #if (Prm_Count > 3)
    	#error "WriteArrayBit - Too many parameters"
    #else
    	#if (Prm_Count < 3)
    		#error "WriteArrayBit - Too few parameters"
    	#else
    		#if(Prm_1 != Byte_Array_Ptr)
    			#error "WriteArrayBit - BitArray(Param1) Should be a BYTE array pointer"
    		#endif
    		#if(Prm_2 != Byte) && (Prm_2 != Num8)
    			#error "WriteArrayBit - Index(Param2) Should be a Byte variable or number"
    		#endif
    		#if(Prm_3 != Byte) && (Prm_3 != Num8)
    			#error "WriteArrayBit - Value(Param3) Should be a Byte variable or number"
    		#endif    		
    		#if (Prm_1 == Byte_Array_Ptr)
    		Num_FSR0 pBitArray
            #endif
    		#if (Prm_2 == Byte)
    			Byte_Byte pIndex, BitArrayIndex
    		#endif
    		#if (Prm_2 == Num8)
    			Num_Byte pIndex, BitArrayIndex
    		#endif
    		#if (Prm_3 == Byte)
    			Byte_Byte pValue, SetbitArrayValue
    		#endif
    		#if (Prm_3 == Num8)
    			Num_Byte pValue, SetbitArrayValue
    		#endif
    		GoSub SetBitArraySub
    	#endif
    #endif
Endm
'-------------------------------------------------------------------------------
$define SetArrayBit(pBitArray, pIndex) _mSetArrayBit pBitArray, pIndex

'SetArrayBitM Macro  BitArray, Index    
_mSetArrayBit Macro-  pBitArray, pIndex
    #if (Prm_Count > 2)
    	#error "SetArrayBit - Too many parameters"
    #else
    	#if (Prm_Count < 2)
    		#error "SetArrayBit - Too few parameters"
    	#else
    		#if(Prm_1 != Byte_Array_Ptr)
    			#error "SetArrayBit - BitArray(Param1) Should be a BYTE array pointer"
    		#endif
    		#if(Prm_2 != Byte) && (Prm_2 != Num8)
    			#error "SetArrayBit - Index(Param2) Should be a Byte variable or number"
    		#endif
    		#if (Prm_1 == Byte_Array_Ptr) && ((Prm_2 == Byte) || (Prm_2 == Num8))
	    		#if (Prm_1 == Byte_Array_Ptr)
	    		Num_FSR0 pBitArray
                #endif
	    		#if (Prm_2 == Byte)
	    			Byte_Byte pIndex, BitArrayIndex
	    		#endif
	    		#if (Prm_2 == Num8)
	    			Num_Byte pIndex, BitArrayIndex
	    		#endif
	   			SetbitArrayValue = 1
	    		GoSub SetBitArraySub
            #endif 
    	#endif
    #endif
Endm
'-------------------------------------------------------------------------------
$define ClearArrayBit(pBitArray, pIndex) _mClearArrayBit pBitArray, pIndex
   
'ClearArrayBitM Macro  BitArray, Index    
_mClearArrayBit Macro- pBitArray, pIndex
    #if (Prm_Count > 2)
    	#error "ClearArrayBit - Too many parameters"
    #else
    	#if (Prm_Count < 2)
    		#error "ClearArrayBit - Too few parameters"
    	#else
    		#if(Prm_1 != Byte_Array_Ptr)
    			#error "ClearArrayBit - BitArray(Param1) Should be a BYTE array pointer"
    		#endif
    		#if(Prm_2 != Byte) && (Prm_2 != Num8)
    			#error "ClearArrayBit - Index(Param2) Should be a Byte variable or number"
    		#endif
    		#if (Prm_1 == Byte_Array_Ptr) && ((Prm_2 == Byte) || (Prm_2 == Num8))
	    	    #if (Prm_1 == Byte_Array_Ptr)
	  		       Num_FSR0 pBitArray
                #endif
	    		#if (Prm_2 == Byte)
	   			Byte_Byte pIndex, BitArrayIndex
	    		#endif
	    		#if (Prm_2 == Num8)
	    		Num_Byte pIndex, BitArrayIndex
	    		#endif
	   			SetbitArrayValue = 0
	    		GoSub SetBitArraySub 
            #endif               
    	#endif
    #endif
Endm

#ifMacro- _mGetArrayBit, _mWriteArrayBit, _mSetArrayBit, _mClearArrayBit
SetBitArrayPointer:
    BitArrayTemp1 = BitArrayIndex / 8
    Movf BitArrayTemp1,W,0
    Addwf FSR0L,F,0
    Movlw 0
    Addwfc FSR0LH,F,0
    BitArrayTemp2 = BitArrayIndex & 7    
    Return
#endIfMacro-
'
#ifMacro _mWriteArrayBit, _mSetArrayBit, _mClearArrayBit
SetBitArraySub:
	GoSub SetBitArrayPointer 
    Set_Bank BitArrayTemp1
	Movff INDF0,BitArrayTemp1
	Movf BitArrayTemp2,W,0
	Bz SetBitArrayL2	
SetBitArrayL1:
	Rrncf INDF0,F,0
	Decfsz WREG,F,0
	Bra SetBitArrayL1
SetBitArrayL2: 
    INDF0.0 = SetbitArrayValue
	Movf BitArrayTemp2,W,0
	Bz SetBitArrayL3                                          
	Bcf STATUS,0,0	
SetBitArrayL4:
	Rlncf INDF0,F,0
	Decfsz WREG,F,0
	Bra SetBitArrayL4
SetBitArrayL3:                                              
    Return
#endIfMacro
$endif
'*******************************************************************************
'* Name    : CRC16                                                             *
'* Purpose : Calculate a xcrc_CRC checksum based on the rather unusual C       *
'*           expression shown below:                                           *
'* xcrc_CRC = (xcrc_CRC >> 8) = ^ yyCRC_TABLE [*buffer++ ^ (xcrc_CRC & 0xFF)]; *
'* Input   : Array + CRCInitValue                                              *
'* Output  : Return_Var (Word)                                                 *
'* Syntax  :                                                                   *
'*       CRC16(pArrayInput,pNumberBytestoTake,pNumberBytesOffset,pCRCInitValue)*
'* Notes:                                                                      *           
'******************************************************************************* 
$ifdef _CRC16_
' Definition of the Local Variables of this library.
' Local Bytes variables

' Local Words variables
$ifndef _LVWS_Block1_
    $define _LVWS_Block1_
    Dim LVSWord1 As Word System         ' Local Variable System Word1
    Dim LVSWord2 As Word System         ' Local Variable System Word2
$endif

' Define the aliases
    Dim xcrc_loop        As LVSByte1    'Loop variable
    Dim xcrc_CRC_Offset  As LVSByte2
    Dim xcrc_LengthArray As LVSByte3    'xcrc_LengthArray of BUFFER array -1

    Dim xcrc_temp        As LVSWord1    'General purpose variable
    Dim xcrc_CRC         As LVSWord2

' define global variables

'-------------------------------------------------------------------------------
' 'The main program starts here
'		DelayMS 100  'Wait for everything to stabilise
' 'cls  'Clear the LCD
' xcrc_LengthArray = 19  'The xcrc_LengthArray of the BUFFER array - 1
'		Str buffer = 10, 20, 30, 40, 50, 60, 70, 80, 90, 100, 110, 120, 130, 140, 150, 160, 170, 180, 190, 200  'Put some values in the buffer
' xcrc_CRC = 0  'Clear the initial xcrc_CRC value for now
'
' CRC_Result = CRC16(buffer,20,0,$1745)
' GoSub calculate_crc  'Calculate the xcrc_CRC
' Print At 1, 1, IHex4 xcrc_CRC  'Display the xcrc_CRC value in hexadecimal notation on the LCD
' Stop  'Stop here

'-------------------------------------------------------------------------------
'Calculate a xcrc_CRC checksum based on the rather unusual C expression shown below: -
'xcrc_CRC = (xcrc_CRC >> 8) = ^ yyCRC_TABLE [*buffer++ ^ (xcrc_CRC & 0xFF)];

'The code is actually based upon the Z80 representation of the same expression.

'Input  : xcrc_CRC holds the 16-bit xcrc_CRC value
': BUFFER holds the values to xcrc_CRC
': xcrc_LengthArray holds the xcrc_LengthArray of the BUFFER array (minus 1)
'Output : xcrc_CRC holds the new xcrc_CRC checksum
'
'-------------------------------------------------------------------------------

$define CRC16(pArrayInput,pNumberBytestoTake,pNumberBytesOffset,pCRCInitValue) _mCRC_16 pArrayInput, pNumberBytestoTake, pNumberBytesOffset, pCRCInitValue

_mCRC_16 Macro- pArrayInput, pNumberBytestoTake, pNumberBytesOffset, pCRCInitValue
#if (Prm_Count > 4)
    #error "CRC_16 - Too many parameters"
    Exitm
#else
    #if (Prm_Count < 4)
        #error "CRC_16 - Too few parameters"
        Exitm
    #else
        #if(Prm_1 != Byte_Array_Ptr) && (Prm_1 != String)
            #error "_mCRC_16 macro - (Param1) Should be a Byte Array or a String"
            Exitm
        #endif
        #if(Prm_2 != Num8) && (Prm_2 != Byte)
            #error "_mCRC_16 Macro - (Param2) Should be a Byte or Num8"
            Exitm
        #endif
        #if(Prm_3 != Num8) && (Prm_3 != Byte)
            #error "_mCRC_16 Macro - (Param3) Should be a Byte or Num8"
            Exitm
        #endif
        #if(Prm_4 != Num8) && (Prm_4 != Num16)
            #error "_mCRC_16 Macro - (Param4) Should be a Num8, Num16"
            Exitm
        #endif
        #if (Prm_1 == Byte_Array_Ptr)
            Num_FSR0 pArrayInput
        #endif
        #if(Prm_1 == String)
            Num_FSR0 pArrayInput
        #endif

        #if (Prm_2 == Byte)
            Byte_Byte pNumberBytestoTake, xcrc_LengthArray
        #endif
        #if (Prm_2 == Num8)
            Num_Byte pNumberBytestoTake, xcrc_LengthArray
        #endif

        #if (Prm_3 == Byte)
            Byte_Byte pNumberBytesOffset, xcrc_CRC_Offset
        #endif
        #if (Prm_3 == Num8)
            Num_Byte pNumberBytesOffset, xcrc_CRC_Offset
        #endif            

        #if (Prm_4 == Num8)
            Num_Word pCRCInitValue, xcrc_CRC
        #endif
        #if (Prm_4 == Num16)
            Num_Word pCRCInitValue, xcrc_CRC
        #endif
        GoSub xx#CRC_16_Sub
    #endif
    #if (_mCRC_16_RETURN != 1)
        #error "_mCRC_16 - Macro - Mandatory return parameter misssing"
        Exitm
    #else
        #if(Return_Type != Word)
            #error "_mCRC_16 - Macro - Return variable should be a Word"
            Exitm
        #else
            #if(Return_Type == Word)
                Word_Word xcrc_CRC, Return_Var
            #endif
        #endif
    #endif
#endif
Endm
'
#ifMacro- _mCRC_16
xx#CRC_16_Sub:								
    #ifdef watchdog_req
    Clrwdt
    #endif
    TBLPTRU = 0
    FSR0 = FSR0 + xcrc_CRC_Offset
    'xcrc_LengthArray = Number of bytes to calculate the xcrc_CRC
    xcrc_LengthArray = xcrc_LengthArray - 1   ' The xcrc_LengthArray is the number of characters.
    xcrc_loop = 0
    Repeat                                              ' Create a loop for All the values in BUFFER
        #ifdef watchdog_req
        Clrwdt
        #endif
        ClearGIE()
        EECON1 = 128                                    ' Access Flash memory
        xcrc_temp = POSTINC0 ^ xcrc_CRC.LowByte         ' Find the table offset by XORing low xcrc_CRC byte with data in BUFFER
        xcrc_temp = xcrc_temp * 2				        ' Correct for 16-bit reads from the table
'        TBLPTR = yyCRC_TABLE + xcrc_temp 	            ' Point to location within xcrc_CRC table 
        TBLPTR = AddressOf(yyCRC_TABLE) + xcrc_temp 	' Point to location within xcrc_CRC table 
        Tblrd*+									        ' Read the low BYTE of the 16-bit value from the table, and auto increment
        xcrc_CRC.LowByte = xcrc_CRC.HighByte ^ TABLAT   ' XOR high xcrc_CRC with low (table) and becomes new low xcrc_CRC byte 
        Tblrd*										    ' Read the high byte of the 16-bit value from the table
        xcrc_CRC.HighByte = TABLAT 					    ' The Hi byte (table) becomes the new hi xcrc_CRC byte
        Inc xcrc_loop								    ' Move up the BUFFER array
    Until xcrc_loop > xcrc_LengthArray					' Do All the values in the BUFFER array
    EECON1 = 0                                          ' End Access Flash memory
    SetGIE()
    Return 											    ' Exit the subroutine
'
yyCRC_TABLE:
CData As Word  $0000, $1189, $2312, $329b, $4624, $57ad, $6536, $74bf,_
            $8c48, $9dc1, $af5a, $bed3, $ca6c, $dbe5, $e97e, $f8f7,_
            $1081, $0108, $3393, $221a, $56a5, $472c, $75b7, $643e,_
            $9cc9, $8d40, $bfdb, $ae52, $daed, $cb64, $f9ff, $e876,_
            $2102, $308b, $0210, $1399, $6726, $76af, $4434, $55bd,_
            $ad4a, $bcc3, $8e58, $9fd1, $eb6e, $fae7, $c87c, $d9f5,_
            $3183, $200a, $1291, $0318, $77a7, $662e, $54b5, $453c,_
            $bdcb, $ac42, $9ed9, $8f50, $fbef, $ea66, $d8fd, $c974,_
            $4204, $538d, $6116, $709f, $0420, $15a9, $2732, $36bb,_
            $ce4c, $dfc5, $ed5e, $fcd7, $8868, $99e1, $ab7a, $baf3,_
            $5285, $430c, $7197, $601e, $14a1, $0528, $37b3, $263a,_
            $decd, $cf44, $fddf, $ec56, $98e9, $8960, $bbfb, $aa72,_
            $6306, $728f, $4014, $519d, $2522, $34ab, $0630, $17b9,_
            $ef4e, $fec7, $cc5c, $ddd5, $a96a, $b8e3, $8a78, $9bf1,_
            $7387, $620e, $5095, $411c, $35a3, $242a, $16b1, $0738,_
            $ffcf, $ee46, $dcdd, $cd54, $b9eb, $a862, $9af9, $8b70,_
            $8408, $9581, $a71a, $b693, $c22c, $d3a5, $e13e, $f0b7,_
            $0840, $19c9, $2b52, $3adb, $4e64, $5fed, $6d76, $7cff,_
            $9489, $8500, $b79b, $a612, $d2ad, $c324, $f1bf, $e036,_
            $18c1, $0948, $3bd3, $2a5a, $5ee5, $4f6c, $7df7, $6c7e,_
            $a50a, $b483, $8618, $9791, $e32e, $f2a7, $c03c, $d1b5,_
            $2942, $38cb, $0a50, $1bd9, $6f66, $7eef, $4c74, $5dfd,_
            $b58b, $a402, $9699, $8710, $f3af, $e226, $d0bd, $c134,_
            $39c3, $284a, $1ad1, $0b58, $7fe7, $6e6e, $5cf5, $4d7c,_
            $c60c, $d785, $e51e, $f497, $8028, $91a1, $a33a, $b2b3,_
            $4a44, $5bcd, $6956, $78df, $0c60, $1de9, $2f72, $3efb,_
            $d68d, $c704, $f594, $e416, $90a9, $8120, $b3bb, $a232,_
            $5ac5, $4b4c, $79d7, $685e, $1ce1, $0d68, $3ff3, $2e7a,_
            $e70e, $f687, $c41c, $d595, $a12a, $b1a3, $8238, $93b1,_
            $6b46, $7acf, $4854, $59dd, $2d62, $3ceb, $0e70, $1ff9,_
            $f78f, $e606, $d49d, $c514, $b1ab, $a022, $92b9, $8330,_
            $7bc7, $6a4e, $58d5, $495c, $3de3, $2c6a, $1ef1, $0f78
#endIfMacro-
$endif
'*******************************************************************************
'* Name   : Multi_RAM_Byte_Array.Inc                                           *
'*  Author: [Les Johnson] 2015                                                 *
'*  Purpose : Create a 2 dimensional Byte array                                *
'*  Notes   : This will also create several constants:                         *
'*           ArrayName#SizeY holds the amount of Columns                       *
'*           ArrayName#SizeX holds the amount of Rows                          *
'*           ArrayName#Size  holds the overall amount of elements              *
'*           contained in the array                                            *
'*  Syntax  : Create_MBArray ( ArrayName , Array Columns, Array Rows)          *
'*  Core    : 16, For 18F devices only. Using Proton+ Version 3.3.4.0 Onwards. *
'******************************************************************************* 
      
$ifdef _Multi_DIM_Array_

'------------------------------------------------------------------------------------------
$define Create_MByteArray(pName, pDimY, pDimX) '
    Dim pName[pDimY * pDimX] As Byte Heap      '
    Symbol pName#SizeY = pDimY                 '
    Symbol pName#SizeX = pDimX                 '
    Symbol pName#Size = pDimY * pDimX          '
Asm-                                           '
    pName#v(91) = pDimY                        '
    pName#v(92) = pDimX                        '
Endasm-

'------------------------------------------------------------------------------------------
'
' Simulate a two dimension RAM Byte array Read
' The macro uses No variable RAM other that SFR registers, and no Call Stack space is used.
'
' For 18F devices only. Using Proton+ Version 3.3.4.0 Onwards.
'
' The calculation for accessing an element is: -
' FSR0 = RAM Array_Name
' FSR0 = FSR0 + Index2
' PROD = Index1 * Index2_Length    
' FSR0 = FSR0 + PROD

' Syntax: 
'   Variable = Read_MultiByteArray pRAM_ArrayName , [pIndex1 , pIndex2]
'
' Where:- 
' Variable is the 8-bit value extracted from the array
' pRAM_ArrayName is the name of the RAM array in question. i.e. a Byte array
' pIndex1 is the first index value of the array
' pIndex2 is the second index value of the array
'
'   For example, create a 4x6 RAM array
'                     
'   Create_MByteArray(MyArray, 4, 6)  ' Declare the array
'                <   X Axis    >
'                < Dimension 2 >
'             ^ 00,01,02,03,04,05  ^
' (Y Axis)    | 10,11,12,13,14,15  | (Y Axis)
' Dimension 1 | 20,21,22,23,24,25  | Dimension 1
'             v 30,31,32,33,34,35  v
'
' In order to access the 4th element from the 3rd dimension element and the 4th dimension element. i.e. value 34 in the table above, use:
'   Variable = Read_MultiByteArray MyArray,[3,4]
'
' This is analogous of Read_MultiByteArray MyArray[Y Axis, X Axis] 

$define Read_MultiByteArray(pArrayName, pIndexY, pIndexX) _mRead_MultiByteArray pArrayName, pIndexY, pIndexX

_mRead_MultiByteArray Macro- pArrayName, pIndexY, pIndexX \Byte
#if((Prm_1 != String) && (Prm_1 != Byte_Array_Ptr) && (Prm_1 != Word_Array_Ptr))
    #error "_mRead_MultiByteArray parameter must be a String, byte array or word array"
    Exitm
#endif
    #ifdef watchdog_req
    Clrwdt
    #endif
#if(((Prm_2 == Num8) || (Prm_2 == Num16) || (Prm_2 == Num32)) && ((Prm_3 == Num8) || (Prm_3 == Num16) || (Prm_3 == Num32)))
    Lfsr 0,(pArrayName + ((pIndexY * pArrayName#v(92)) + pIndexX))
#else

    Lfsr 0,(pArrayName)                                             ' Point FSR0L/H to the start of the RAM array
    #if((Prm_3 == Num8) || (Prm_3 == Num16) || (Prm_3 == Num32))
        Movlw (pIndexX)
    #endif 
    #if((Prm_3 == Byte) || (Prm_3 == Word) || (Prm_3 == Dword))
        Movff (pIndexX,WREG)                                        ' Get pIndexX into WREG
    #endif
    Addwf FSR0L,F                                                   ' \
    Movlw 0                                                         ' |  Add this to FRS0L/H
    Addwfc FSR0H,F                                                  ' /

    #if((Prm_2 == Num8) || (Prm_2 == Num16) || (Prm_2 == Num32))
        Movlw (pIndexY)
    #endif
    #if((Prm_2 == Byte) || (Prm_2 == Word) || (Prm_2 == Dword))  
        Movff (pIndexY,WREG)                                        ' Get pIndexY into WREG 
    #endif
    Mullw (pArrayName#v(92))                                        ' Multiply by the length of Index 2 (Result in PRODL\H)
    Movf PRODL,W                                                    ' \ 
    Addwf FSR0L,F                                                   ' | Calculate the offset within the RAM array
    Movf PRODH,W                                                    ' |
    Addwfc FSR0H,F                                                  ' /      
#endif
'
' At this point FSR0L/H is pointing to the correct element based on pIndexY, pIndexX and the length of pIndexX
'                
#if(_mRead_MultiByteArray_Return == 1)                              ' Is there a return variable?
    #if((Return_Type == String) || (Return_Type == Byte_Array_Ptr) || (Return_Type == Word_Array_Ptr))  
        #error "RamByteArray macro cannot return into a String, Byte Array or Word Array"
        Exitm
    #endif
    
    #if(Return_Type == Byte)                                        ' \
        Movff (INDF0,Return_Var)                                    ' |
    #endif                                                          ' |
                                                                    ' |
    #if((Return_Type == Word) || (Return_Type == SWord))            ' |
        Movff (INDF0,Return_Var)                                    ' | Place the contents of the element into the return variable
        Clrf (Return_Var + 1)                                       ' |
    #endif                                                          ' |
                                                                    ' |
    #if(Return_Type == Dword)                                       ' |
        Movff (INDF0,Return_Var)                                    ' |
        Clrf (Return_Var + 1)                                       ' |
        Clrf (Return_Var + 2)                                       ' |
        Clrf (Return_Var + 3)                                       ' /
    #endif                                                        
#endif
Endm        
'------------------------------------------------------------------------------------------
'
' Simulate a two dimension RAM Byte array Write and Read
' The macro uses No variable RAM other that SFR registers, and no Call Stack space is used.
'
' For 18F devices only. Using Proton+ Version 3.3.4.0 Onwards.
'
' The calculation for accessing an element is: -
' FSR0 = RAM Array_Name
' FSR0 = FSR0 + Index2
' PROD = Index1 * Index2_Length    
' FSR0 = FSR0 + PROD
'
' Syntax:
'   Write_MultiByteArray pRAM_ArrayName, [pIndex1, pIndex2], pValueToWrite
'
' Where:- 
' Variable is the 8-bit value extracted from the array
' pRAM_ArrayName is the name of the RAM array in question. i.e. a Byte array
' pIndex1 is the first index value of the array
' pIndex2 is the second index value of the array
'
'   For example, create a 4x6 RAM array
'                     
'   DeclareMBArray(MyArray, 4, 6)  ' Declare the array
'                <   X Axis    >
'                < Dimension 2 >
'             ^ 00,01,02,03,04,05  ^
' (Y Axis)    | 10,11,12,13,14,15  | (Y Axis)
' Dimension 1 | 20,21,22,23,24,25  | Dimension 1
'             v 30,31,32,33,34,35  v
'
' In order to access the 4th element from the 3rd dimension element and the 4th dimension element. i.e. value 34 in the table above, use:
'   Variable = Write_MultiByteArray MyArray,[3,4]
'
' This is analogous of Write_MultiByteArray MyArray,[Y Axis, X Axis] 

$define Write_MultiByteArray(pArrayName, pIndexY, pIndexX, pValueOut) _mWrite_MultiByteArray pArrayName, pIndexY, pIndexX, pValueOut

_mWrite_MultiByteArray Macro- pArrayName, pIndexY, pIndexX, pValueOut \Byte
#if((Prm_1 != String) && (Prm_1 != Byte_Array_Ptr) && (Prm_1 != Word_Array_Ptr))
    #error "_mWrite_MultiByteArray parameter must be a String, byte array or word array"
    Exitm
#endif
    #ifdef watchdog_req
    Clrwdt
    #endif
#if(((Prm_2 == Num8) || (Prm_2 == Num16) || (Prm_2 == Num32)) && ((Prm_3 == Num8) || (Prm_3 == Num16) || (Prm_3 == Num32)))
    Lfsr 0,(pArrayName + ((pIndexY * pArrayName#v(92)) + pIndexX))
#else

    Lfsr 0,(pArrayName)                                             ' Point FSR0L/H to the start of the RAM array
    #if((Prm_3 == Num8) || (Prm_3 == Num16) || (Prm_3 == Num32))
        Movlw (pIndexX)
    #endif 
    #if((Prm_3 == Byte) || (Prm_3 == Word) || (Prm_3 == Dword))
        Movff (pIndexX,WREG)                                        ' Get pIndexX into WREG
    #endif
    Addwf FSR0L,F                                                   ' \
    Movlw 0                                                         ' | Add this to FRS0L/H
    Addwfc FSR0H,F                                                  ' /

    #if((Prm_2 == Num8) || (Prm_2 == Num16) || (Prm_2 == Num32))
        Movlw (pIndexY)
    #endif
    #if((Prm_2 == Byte) || (Prm_2 == Word) || (Prm_2 == Dword))  
        Movff (pIndexY,WREG)                                        ' Get pIndexY into WREG 
    #endif
    Mullw (pArrayName#v(92))                                        ' Multiply by the length of Index 2 (Result in PRODL\H)
    Movf PRODL,W                                                    ' \ 
    Addwf FSR0L,F                                                   ' | Calculate the offset within the RAM array
    Movf PRODH,W                                                    ' |
    Addwfc FSR0H,F                                                  ' /      
#endif
'
' Check the value to place into the array
'
#if((Prm_4 == Num8) || (Prm_4 == Num16) || (Prm_4 == Num32))     
    Num_SFR pValueOut,INDF0                                              
#endif                                                         
#if((Prm_4 == Byte) || (Prm_4 == Word) || (Prm_4 == Dword))    
    Movff (pValueOut,INDF0)                                    
#endif 
Endm  
'-------------------------------------------------------------------------------    
$endif  ' _MULTI_DIM_ARRAY_
'===============================================================================




'===============================================================================
'*******************************************************************************    
_OverStateMachineLibrary:
'-------------------------------------------------------------------------------
    TBLPTRU = 0
    EECON1 = 0              ' Clear All registers used for the eeprom acces.
    EECON2 = 0
    EEADR = 0  
    $ifdef _EEADRH
    EEADRH = 0
    $endif
'-------------------------------------------------------------------------------
$endif
'***END OF FILE***************************************************************** 
      
                
